USE {Variable_TempDb}
GO

--        
Declare fls cursor for SELECT NAME FROM SYS.OBJECTS WHERE TYPE = 'U' AND NAME LIKE '[__]%'
Declare @N sysname, @str VARCHAR(1000)
open fls
fetch next from fls into @N
while @@fetch_status = 0
begin
	SET @str = 'DROP TABLE ['+rtrim(@N)+']'
	PRINT @str
	EXECUTE (@str)
	fetch next from fls into @N
end
Close fls
Deallocate fls
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[__Journal]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.[__Journal]
CREATE TABLE dbo.[__Journal] (ID INT IDENTITY(1,1), TITLE nvarchar(254), TEXT nvarchar(max), TABLE_NAME varchar(100), ROWS_NOT_COPIED bigint)

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]

GO
                                

set xact_abort on
BEGIN TRAN

USE {Variable_WorkDb}
GO

---    INSERTED_UIDS,     1,         
IF COLUMNPROPERTY(object_id('[dbo].[DEPARTMENTS]'), 'INSERTED_UIDS', 'AllowsNull') is not NULL
    ALTER TABLE [dbo].[DEPARTMENTS]  DROP COLUMN [INSERTED_UIDS]
GO

--  INSERTED_UIDS  DEPARTMENTS
IF COLUMNPROPERTY(object_id('[dbo].[DEPARTMENTS]'), 'INSERTED_UIDS', 'AllowsNull') is NULL
   ALTER TABLE [dbo].[DEPARTMENTS] ADD [INSERTED_UIDS] uniqueidentifier NULL 
GO

USE {Variable_TempDb}
GO

/*     */
DECLARE @PREFIX VARCHAR(254)
SET @PREFIX = db_name()
SET @PREFIX = RIGHT(@PREFIX,2)

DECLARE @dFIRST_DATE_OF_YEAR DATETIME
SET @dFIRST_DATE_OF_YEAR = DATEDIFF (YEAR, 1, DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)) --   

DECLARE
	@OwnDepLink INT

SET @OwnDepLink = [{Variable_WorkDb}].dbo.GetOwnDepLink ()

 INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS
 (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	[DESCRIPTION],
 	INN,
 	KPP,
 	OKPO,
 	VED_LINK,
 	MAIN_LINK,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	PREFIX_POLUCH,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	UCHR_LINK,
 	CODE_TOFK,
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE],
 	[SOURCE],
 	LINK_DEP,
	OKTMO,
 	[INSERTED_UIDS]
 )
 OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_]
SELECT
 	CODE          = ISNULL(@PREFIX + '/','')+ ISNULL(LTRIM(RTRIM( [Code] )),''),
 	[NAME]        = CASE WHEN ISNULL(LTRIM(RTRIM( [Description] )),'') <> '' THEN LTRIM(RTRIM([Description]))
 					ELSE	
						CASE WHEN ISNULL(LTRIM(RTRIM( [] )),'') = '' THEN ISNULL(LTRIM(RTRIM( [] )),'') ELSE ISNULL(LTRIM(RTRIM( [] )),'') END	
					END,
 	FULL_NAME     = CASE WHEN (CASE WHEN ISNULL(LTRIM(RTRIM( [] )),'') = '' THEN ISNULL(LTRIM(RTRIM( [] )),'') ELSE ISNULL(LTRIM(RTRIM( [] )),'') END = '')
					THEN [Description]	 ELSE
					CASE WHEN ISNULL(LTRIM(RTRIM( [] )),'') = '' THEN ISNULL(LTRIM(RTRIM( [] )),'') ELSE ISNULL(LTRIM(RTRIM( [] )),'') END
					END,
	[DESCRIPTION] = [Description],
 	INN           = [],
 	KPP           = [],
 	OKPO          = ISNULL(LTRIM(RTRIM( [] )),''),
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = ISNULL(LTRIM(RTRIM( [] )),''), ---????
 	BUDG          = '', ----????????
 	BRON          = 0,
 	PREFIX        = '',
 	PREFIX_POLUCH = '',
 	OGRN          = ISNULL(LTRIM(RTRIM( [] )),''),
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = LEFT(ISNULL(T.[],''),8),
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	[SOURCE]      = NULL,
    LINK_DEP      = @OwnDepLink,
	OKTMO		= NULL,
 	[INSERTED_UIDS] = Ref
FROM [{Variable_TempDb}].dbo.[CatalogObject|] T
WHERE 
	DeletionMark = 'false'
	AND
	EXISTS (select * from [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] AR 
				WHERE AR. = T.Ref AND AR.Period BETWEEN @dFIRST_DATE_OF_YEAR AND '20250101')	
--	and (T.[] = '2108001331' or T.[] = '2108002825' or T.[] = '2108006724')
	--ISNULL(LTRIM(RTRIM( [Code] )),'') = '00001'
				
	-- 
	INSERT INTO {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS_REF
	SELECT O1.LINK, DG.LINK
	FROM
	{Variable_TempDb}.[dbo].[__DEPARTMENTS_] O1
	INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] B ON B.[] = O1.Ref
	INNER JOIN 
	(
		SELECT [],MAX(Period) AS Period
		FROM {Variable_TempDb}.dbo.[InformationRegisterRecordSet|]
		WHERE Period <= GETDATE()
		GROUP BY []
	) A ON A.[] = B.[] AND A.[Period] = B.[Period]
	INNER JOIN {Variable_TempDb}.dbo.[CatalogObject|] C ON C.Ref = B.[]
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS DG ON DG.[SYS] = 3 AND DG.SNAME = (CASE C. 
																							WHEN '' THEN ''
																							WHEN '' THEN ''																							
																							WHEN '' THEN ''	
																						END)

	--       = 1
	UPDATE D SET D.[SOURCE] = F.LINK
	FROM
		{Variable_WorkDb}.dbo.DEPARTMENT_GROUPS G
		INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS_REF GR on GR.GROUP_LINK = G.LINK
		INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = GR.DEP_LINK
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] O1 ON O1.LINK = D.LINK
		INNER JOIN {Variable_WorkDb}.dbo.FIN_SOURCE F ON F.CODE = '1'
	WHERE
		G.[SYS] = 3 AND G.SNAME = ''																					
	 
	-- LINK_DEP      
	UPDATE [{Variable_WorkDb}].dbo.DEPARTMENTS
	SET LINK_DEP = [{Variable_WorkDb}].dbo.getowndeplink()
	WHERE LINK IN (select LINK from [{Variable_TempDb}].[dbo].[__DEPARTMENTS_])
	--
	 
	EXECUTE [{Variable_WorkDb}].dbo.UPD_DEPARTMENTS_ORDER

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
GO

-- --  ,  ,   
-- DECLARE @iGROUP_LINK INT
-- SELECT TOP 1 @iGROUP_LINK = dg.LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg WHERE dg.SNAME = ''
 
-- INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF
-- (DEP_LINK, GROUP_LINK)
-- select LINK, @iGROUP_LINK FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] do
-- inner join [{Variable_TempDb}].[dbo].[CatalogObject|] o on o.Ref = do.Ref
--  WHERE exists (select 1 from [{Variable_TempDb}].[dbo].[CatalogObject|] c where c. = o.Ref)
 	 
--GO

--  
UPDATE d
SET d.ZB = head.LINK
FROM [{Variable_WorkDb}].dbo.DEPARTMENTS d
inner join [{Variable_TempDb}].dbo.__DEPARTMENTS_ do on do.LINK = d.LINK
inner join [{Variable_TempDb}].dbo.[CatalogObject|] o on o.Ref = do.Ref
inner join [{Variable_TempDb}].dbo.__DEPARTMENTS_ head on head.Ref = o.
GO

--   
USE [{Variable_TempDb}]

IF OBJECT_ID('TEMPDB..#DEP','U') IS NOT NULL DROP TABLE #DEP CREATE TABLE #DEP (LINK INT)

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS ([CODE], [NAME], [FULL_NAME], [INN], [KPP], [LINK_DEP])
	OUTPUT INSERTED.[LINK] INTO #DEP (LINK)
SELECT DISTINCT 
	[CODE] = LEFT(,20),
	[NAME] = CASE WHEN len([])<>0 THEN LEFT(,254) ELSE LEFT(,20) END,
	[FULL_NAME] = CASE WHEN len([])<>0 THEN LEFT(,254) ELSE LEFT(,20) END,
	[INN] = REPLICATE('0',10),
	[KPP] = REPLICATE('0',9),
	[LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] O ON O.REF = T.REF
WHERE
	LEN() > 0 AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENTS_TYPE_FN(4) WHERE LTRIM(LTRIM(CODE)) = LTRIM(RTRIM()))

DECLARE @GROUP_LINK INT SET @GROUP_LINK = (SELECT LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS WHERE [SYS] = 4)
   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT DISTINCT A.LINK, @GROUP_LINK
FROM #DEP A WHERE @GROUP_LINK IS NOT NULL AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = A.LINK AND T.GROUP_LINK = @GROUP_LINK)
GO

--  
UPDATE D SET D.imns_LINK = I.LINK
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
	INNER JOIN  [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = T.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] O ON O.REF = T.REF
	INNER JOIN (SELECT D.LINK, D.CODE, NUM = ROW_NUMBER() OVER (PARTITION BY D.CODE ORDER BY D.LINK)
					FROM  [{Variable_WorkDb}].dbo.DEPARTMENTS D
							INNER JOIN  [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
							INNER JOIN  [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 4
					WHERE EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[CatalogObject|] WHERE LTRIM(RTRIM()) LIKE LTRIM(RTRIM(D.CODE)))
				) I ON I.NUM = 1 AND LTRIM(RTRIM(O.)) LIKE LTRIM(RTRIM(I.CODE)) AND LEN(O.) > 0
WHERE
	D.imns_LINK IS NULL AND I.LINK IS NOT NULL
GO


--   
USE [{Variable_WorkDb}]

INSERT INTO  [{Variable_WorkDb}].[dbo].[OKVED] ([CODE], [NAME], [LINK_DEP])
SELECT DISTINCT 
	[CODE] = LEFT(,8),
	[NAME] = LEFT(,254),
	[LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] O ON O.REF = T.REF
WHERE
	LEN() > 0 AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].[dbo].[OKVED] WHERE LTRIM(LTRIM([CODE])) = LTRIM(RTRIM(LEFT(,8))))

DELETE B FROM [{Variable_WorkDb}].dbo.DEPARTMENTS_OKVED B WHERE EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A WHERE A.LINK = B.DEP)
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS_OKVED (DEP, OKVED, MAIN)
SELECT T.LINK, I.LINK, 1
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] O ON O.REF = T.REF
	INNER JOIN (SELECT LINK, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY CODE ORDER BY LINK)
					FROM  [{Variable_WorkDb}].[dbo].[OKVED]
				) I ON I.NUM = 1 AND LTRIM(RTRIM(O.)) LIKE LTRIM(RTRIM(I.CODE)) AND LEN(O.) > 0
 
GO

-- 
USE [{Variable_WorkDb}]
GO

DECLARE
	@OwnDepLink INT

--  --
DECLARE @T_DEP TABLE 
	(
	DEP_LINK	INT,
	OKTMO		VARCHAR (20)
	)

INSERT INTO @T_DEP
	(
	DEP_LINK,
	OKTMO
	)
SELECT
	T1.LINK,
	OKTMO = LEFT (T2.[], 11)
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T1
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] T2 ON T2.REF = T1.REF
WHERE
	ISNULL (T2.[], '') <> ''

SET @OwnDepLink = dbo.GetOwnDepLink ()

-- 1.    
INSERT INTO dbo.OKTMO (CODE, NAME, LINK_DEP)
SELECT
	T1.CODE,
	T1.CODE,
	T1.LINK_DEP
FROM 
	(
	SELECT
		CODE = TTT.OKTMO,
		LINK_DEP = @OwnDepLink
	FROM @T_DEP TTT
	GROUP BY
		TTT.OKTMO
	) AS T1
LEFT JOIN dbo.OKTMO T2 ON 
	T2.CODE = T1.CODE
	AND T2.LINK_DEP = T1.LINK_DEP 
WHERE T2.LINK IS NULL

-- 2.     
UPDATE DEP
SET OKTMO = T2.LINK
FROM @T_DEP T1 
INNER JOIN dbo.DEPARTMENTS DEP ON DEP.LINK = T1.DEP_LINK
INNER JOIN dbo.OKTMO T2 ON
	T2.CODE = T1.OKTMO
	AND T2.LINK_DEP = @OwnDepLink
WHERE DEP.OKTMO IS NULL

GO

COMMIT TRAN

GO

