set xact_abort on
BEGIN TRAN

--  
USE [{Variable_TempDb}]
GO
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENT_GROUPS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENT_GROUPS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENT_GROUPS_]
	

SELECT DISTINCT O.[Ref], O.[Description],O.
INTO #CA
FROM [{Variable_TempDb}].dbo.[CatalogObject|] O
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] CHILD ON convert(uniqueidentifier,CHILD.Parent) = O.Ref
WHERE O.IsFolder = 'true' AND  CHILD. = '' AND o.DeletionMark = 'false'

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_DEP_GROUPS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_DEP_GROUPS]

SELECT
    = left(isnull(O.,o.[Description]),60),
  = '  '
INTO [{Variable_TempDb}].dbo.[__JOURNAL_DEP_GROUPS]
FROM [{Variable_TempDb}].dbo.[CatalogObject|] O
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] CHILD ON convert(uniqueidentifier,CHILD.Parent) = O.Ref
WHERE O.IsFolder = 'true' AND  CHILD. = '' AND o.DeletionMark = 'true'
ORDER BY 

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_DEP_GROUPS',ISNULL(@iROWS_NOT_COPIED,0))
--

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_] ([LINK], [Ref])
SELECT
	G.LINK,
	O.[Ref]
FROM 
	#CA O
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G ON G.LINK_DEP = {LINK_DEP} AND G.[NAME] = left(isnull(O.,o.[Description]),60)
GO

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS
(SNAME,[NAME],SYS,LINK_DEP,[INSERTED_UIDS])
    OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
    INTO [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_]
SELECT
	SNAME       = left(O.[Description],10),
	[NAME]      = left(isnull(O.,o.[Description]),60),
	SYS         = 0,
	LINK_DEP    = {LINK_DEP},
	[INSERTED_UIDS] = O.[Ref]
FROM 
	#CA O
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G 
				WHERE G.LINK_DEP = {LINK_DEP} 
					AND G.[NAME] = left(isnull(O.,o.[Description]),60))	
GO
					

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS DROP COLUMN [INSERTED_UIDS]
GO



IF exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENT_GROUPS__LINKS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].[__DEPARTMENT_GROUPS__LINKS] 
GO
SELECT LINK
INTO [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS__LINKS]
FROM [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_]

--            
DECLARE @uUID UNIQUEIDENTIFIER, @cNAME VARCHAR(254)
DECLARE the_cursor CURSOR FAST_FORWARD
FOR SELECT [Ref], LEFT([Description],254) FROM #CA

OPEN the_cursor
FETCH NEXT FROM the_cursor INTO @uUID, @cNAME


WHILE @@FETCH_STATUS = 0
BEGIN

    UPDATE dbo.[__DEPARTMENT_GROUPS_]
    SET link = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS WHERE [NAME] = LEFT(@cNAME,60) AND LINK_DEP = {LINK_DEP})
    WHERE [Ref] = @uUID
    FETCH NEXT FROM the_cursor INTO @uUID, @cNAME
END

CLOSE the_cursor
DEALLOCATE the_cursor
--
DROP TABLE #CA


COMMIT TRAN