
set xact_abort on
BEGIN TRAN
-- 
--   
USE [{Variable_TempDb}]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__DEPARTMENTS_]
		(
		[LINK] int ,
		[Ref] UNIQUEIDENTIFIER
		)
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

--     --
IF exists(select * from sysobjects where id = object_id('[dbo].[__PERSON_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	EXEC
		(
		'INSERT INTO [dbo].[__DEPARTMENTS_] ([LINK], [Ref]) '
		+ 'SELECT A.[LINK], A.[Ref] FROM [dbo].[__PERSON_] A '
		+ 'LEFT JOIN [dbo].[__DEPARTMENTS_] B ON B.[REF] = A.[REF] '
		+ 'WHERE B.LINK IS NULL'
		)
	
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO


--  , ,  
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE], INN,
			FULL_NAME = REPLACE (FULL_NAME, SPACE (1), ''),
			TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE], INN,
									REPLACE (FULL_NAME, SPACE (1), ''), DT.CODE
									ORDER BY D.[LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
	) D	ON D.NUM = 1 AND
		D.[TYPE] = (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND
		D.INN = LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)
		AND D.FULL_NAME = REPLACE (LEFT(b.[],254), SPACE (1), '')
		AND D.TYPE_CODE = A.CODE
WHERE
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)		
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) >= 10
	AND LEN(LEFT(b.[],254)) > 0


--  
--  , ,  
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE], INN, KPP,
			TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE], INN, KPP, DT.CODE
									ORDER BY D.LINK)
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
		--WHERE LINK_DEP = {LINK_DEP}
	) D	ON D.NUM = 1 
		AND D.[TYPE]	= (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND	D.INN		= LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13) 
		AND	D.KPP		= LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),9)
		AND D.TYPE_CODE = A.CODE

WHERE
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)		
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) >= 10
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),9)) = 9

--    ,  
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE], INN, PERS_FNAME, PERS_NAME, PERS_SECNAME,
			TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE], INN,
										PERS_FNAME, PERS_NAME, PERS_SECNAME, DT.CODE
									ORDER BY D.LINK)	
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
		--WHERE LINK_DEP = {LINK_DEP}
	) D	ON D.NUM = 1 
		AND D.[TYPE] = (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND D.INN = LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)
		AND D.PERS_FNAME = b. AND LEN(ISNULL(LTRIM(RTRIM(b.)),'')) >= 1
		AND D.PERS_NAME = b. AND LEN(ISNULL(LTRIM(RTRIM(b.)),'')) >= 1
		AND	D.PERS_SECNAME = ISNULL(b.,'')
		AND D.TYPE_CODE = A.CODE
WHERE
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) >= 10
	AND LEN(ISNULL(LTRIM(RTRIM(b.)),'')) >= 1
	AND LEN(ISNULL(LTRIM(RTRIM(b.)),'')) >= 1

--  ,   -   .
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE], INN, TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE], INN, DT.CODE ORDER BY D.LINK)	
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
		--WHERE LINK_DEP = {LINK_DEP}
	) D	ON D.NUM = 1 
		AND D.[TYPE] = (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND D.INN = LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13) 
		AND D.TYPE_CODE = A.CODE
WHERE
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) = 12
--GROUP BY
--	b.Ref
--HAVING
--	COUNT(*) > 1		

--  ,   
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE],
			FULL_NAME = REPLACE (FULL_NAME, SPACE (1), ''), TYPE_CODE = ISNULL(DT.CODE,'0'), 
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE],
										REPLACE (FULL_NAME, SPACE (1), ''), DT.CODE
									ORDER BY D.[LINK])	
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
	) D	ON D.NUM = 1 
		AND D.[TYPE] = (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND D.FULL_NAME = REPLACE (LEFT(b.[],254), SPACE (1), '') 
		AND D.TYPE_CODE = A.CODE
WHERE
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN( LEFT(b.[],254) ) > 1

--  Description,  
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE],
			FULL_NAME = REPLACE (FULL_NAME, SPACE (1), ''), TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE],
										REPLACE (FULL_NAME, SPACE (1), ''), DT.CODE
									ORDER BY D.[LINK])	
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
		--WHERE LINK_DEP = {LINK_DEP}
	) D	ON D.NUM = 1 
		AND D.[TYPE] = (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND D.FULL_NAME = REPLACE (LEFT(b.[Description],254), SPACE (1), '')
		AND D.TYPE_CODE = A.CODE
WHERE
	b.IsFolder = 'false' 
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) < 10
	AND LEN( LEFT(b.[],254) ) < 1
	AND LEN( LEFT(b.[Description],254) ) > 1
--GROUP BY
--	b.Ref
--HAVING
--	COUNT(*) > 1	

--  , , ,     
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON A.Ref = B.[]
	INNER JOIN 
	(
		SELECT D.[LINK], [TYPE] = DPT.[DEP_TYPE],
			PERS_FNAME, PERS_NAME, PERS_SECNAME, TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY DPT.[DEP_TYPE], PERS_FNAME, PERS_NAME, PERS_SECNAME,
											DT.CODE
									ORDER BY D.LINK)	
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = D.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
		--WHERE LINK_DEP = {LINK_DEP}
	) D	ON D.NUM = 1 
		AND D.[TYPE] = (CASE WHEN b. = '' THEN 1 ELSE 0 END)
		AND D.PERS_FNAME = b.
		AND D.PERS_NAME = b.
		AND D.PERS_SECNAME = ISNULL(b.,'')
		AND D.TYPE_CODE = A.CODE
WHERE
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) < 10
	AND LEN( LEFT(b.[],254) ) < 1
	AND LEN( LEFT(b.[Description],254) ) < 1
	AND LEN(ISNULL(LTRIM(RTRIM(b.)),'')) >= 1
	AND LEN(ISNULL(LTRIM(RTRIM(b.)),'')) >= 1
--GROUP BY
--	b.Ref
--HAVING
--	COUNT(*) > 1

DECLARE
	@OWN_DEP_LINK		INT

SET @OWN_DEP_LINK = [{Variable_WorkDb}].dbo.getOwnDepLink()

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
	VED_LINK,
 	MAIN_LINK,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	UCHR_LINK,
 	CODE_TOFK,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE],
    PERS_FNAME,
    PERS_NAME,
    PERS_SECNAME,
	TYPES_LINK,
 	[LINK_DEP], [INSERTED_UIDS]) 
OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
	INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_]
SELECT 
	CODE          = RIGHT(ISNULL(LTRIM(RTRIM( b.Code )),rtrim([{Variable_WorkDb}].dbo.XB_GET_NEXT_CCODE('DEPARTMENTS', 10, default))),10), 
	[NAME]        = LEFT(CASE WHEN b.[Description] = '' THEN b.[] ELSE  b.[Description] END ,50),
	FULL_NAME     = LEFT(CASE WHEN b.[] = '' THEN b.[Description] ELSE b.[] END ,254),
	INN           = LEFT(ISNULL(LTRIM(RTRIM( b.[] )),''),13), 
 	KPP           = LEFT(ISNULL(LTRIM(RTRIM( b.[] )),''),9),
 	OKPO          = LEFT(ISNULL(LTRIM(RTRIM( b.[] )),''),20),
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = LEFT(ISNULL(LTRIM(RTRIM( b.[] )),''),13),
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = RIGHT(ISNULL(LTRIM(RTRIM( b.Code )),''),4),
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = CASE WHEN b. = '' THEN 1 ELSE 0 END,
    PERS_FNAME    = b.,
    PERS_NAME     = b.,
    PERS_SECNAME  = b.,
	TYPES_LINK		= DT.LINK, -- ,
 	[LINK_DEP]    = @OWN_DEP_LINK,-- {LINK_DEP},
 	[INSERTED_UIDS]   = b.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	LEFT JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] A ON B.Ref = B.[]
	LEFT JOIN
		(
		SELECT DT.*, DPT.DEP_TYPE
		FROM [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT 
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON DPT.LINK = DT.[TYPE]
		) AS DT ON DT.[CODE] = A.[CODE]
			AND	(
				 b. = '' AND DT.DEP_TYPE = 1
				 OR b. <> '' AND DT.DEP_TYPE = 0
				 )
WHERE 
	b.IsFolder = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)
	AND LEN (CASE WHEN b.[Description] = '' THEN b.[] ELSE  b.[Description] END) <> 0
	AND LEN (CASE WHEN b.[] = '' THEN b.[Description] ELSE b.[] END) <> 0
ORDER BY 
	B.Code  
      
--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '',0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
GO

 ---     
    DECLARE @iGROUP_LINK INT, @iERROR INT
    SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
    WHERE dg.SYS = 4
    
		INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
		SELECT DISTINCT sb.link, @iGROUP_LINK
		FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_] sb 
		WHERE NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.link AND T.GROUP_LINK = @iGROUP_LINK)
		
		SELECT @iError = @@ERROR
		IF @iError <> 0
		BEGIN
			ROLLBACK
	 		PRINT('  ' + convert(varchar(254),@iERROR) )
			RAISERROR('      ', 11,1)
		END
		
		---     
		INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
 		SELECT DISTINCT
 			DEP_LINK      = d.LINK,
 			GROUP_LINK    = s.LINK
 		FROM 
 			[{Variable_WorkDb}].dbo.DEPARTMENTS d
 			INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dc ON dc.link = d.link
 			INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] c ON c.Ref = dc.Ref
 			INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS_] s ON s.Ref = c.Parent
		WHERE 
			NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = d.LINK AND T.GROUP_LINK = s.LINK) 			
 					
		SELECT @iError = @@ERROR
		IF @iError <> 0
		BEGIN
			ROLLBACK
	 	PRINT('  ' + convert(varchar(254),@iERROR))
	  RAISERROR('     ', 11,1)
		END
		---

--    ,  
DELETE dg FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
inner JOIN [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS__LINKS] dl ON dl.link = dg.LINK
WHERE NOT EXISTS(SELECT 1 FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF dgr INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg2 ON dg.LINK = dgr.GROUP_LINK)

DROP TABLE [{Variable_TempDb}].dbo.[__DEPARTMENT_GROUPS__LINKS]
--

GO
		
COMMIT TRAN


