
set xact_abort on
BEGIN TRAN

-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

SELECT B.BIK, B.LINK
INTO #T0
FROM 
	(
		SELECT B.LINK, B.BIK, NUM = ROW_NUMBER() OVER (PARTITION BY B.BIK ORDER BY B.LINK)
		FROM 
			[{Variable_WorkDb}].dbo.BANKS B
			INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = B.LINK
		--WHERE 	D.LINK_DEP = {LINK_DEP}
	) B 
WHERE
	B.NUM = 1
GO

DECLARE
	@OWN_DEP_LINK		INT

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	SET @OWN_DEP_LINK = [{Variable_WorkDb}].dbo.getOwnDepLink()

	INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK)
		(
 		-- LINK -- this column value is auto-generated
 		CODE,
 		[NAME],
 		FULL_NAME,
 		INN,
 		KPP,
 		OKPO,
 		VED_LINK,
 		MAIN_LINK,
 		FIN_CODE,
 		TOFK_LINK,
 		PFNUMBER,
 		BUDG,
 		BRON,
 		PREFIX,
 		OGRN,
 		IMNS_LINK,
 		ORD_HEAD,
 		SBK_REGNUM,
 		SBK_DOCNUM,
 		SBK_DOCDATE,
 		SBK_LINK,
 		ZB,
 		HIGH_LINK,
 		PERS_LINK,
 		INN_DOP,
 		IS_RBS,
 		FO_LINK,
 		N_ACC_LINK,
 		EGRUL,
 		CODE_UBP,
 		FSS_REG_NUM,
 		FSS_KOD_P,
 		FSS_KOD_DOP,
 		OKOPF,
 		OKFS,
 		TFOMS_REG_NUM,
 		TFOMS_KT,
 		FSS_KP_P1,
 		FSS_KP_P2,
 		FSS_KP_P3,
 		UCHR_LINK,
 		CODE_TOFK,
 		-- STAMP -- this column value is auto-generated
 		[GUID],
 		ROW_ID,
 		[ACTION],
 		[TYPE], [LINK_DEP],[INSERTED_UIDS]
		) 
 	OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
 		INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_]
	SELECT 
		CODE          = RIGHT(ISNULL(LTRIM(RTRIM( b.[Code] )),''),10), 
		[NAME]        = LEFT(ISNULL(LTRIM(RTRIM( b.[Description] )),''),50),
		FULL_NAME     = LEFT(ISNULL(LTRIM(RTRIM( b.[Description] )),''),254),
		INN           = '',
 		KPP           = '',
 		OKPO          = '',
 		VED_LINK      = NULL,
 		MAIN_LINK     = NULL,
 		FIN_CODE      = '',
 		TOFK_LINK     = NULL,
 		PFNUMBER      = '',
 		BUDG          = '',
 		BRON          = 0,
 		PREFIX        = '',
 		OGRN          = '',
 		IMNS_LINK     = NULL,
 		ORD_HEAD      = '',
 		SBK_REGNUM    = NULL,
 		SBK_DOCNUM    = '',
 		SBK_DOCDATE   = NULL,
 		SBK_LINK      = NULL,
 		ZB            = NULL,
 		HIGH_LINK     = NULL,
 		PERS_LINK     = NULL,
 		INN_DOP       = '',
 		IS_RBS        = 0,
 		FO_LINK       = NULL,
 		N_ACC_LINK    = NULL,
 		EGRUL         = '',
 		CODE_UBP      = '',
 		FSS_REG_NUM   = '',
 		FSS_KOD_P     = '',
 		FSS_KOD_DOP   = '',
 		OKOPF         = '',
 		OKFS          = '',
 		TFOMS_REG_NUM = '',
 		TFOMS_KT      = '',
 		FSS_KP_P1     = NULL,
 		FSS_KP_P2     = NULL,
 		FSS_KP_P3     = NULL,
 		UCHR_LINK     = NULL,
 		CODE_TOFK     = '',
 		[GUID]        = NULL,
 		ROW_ID        = NULL,
 		[ACTION]      = NULL,
 		[TYPE]        = 0,
 		[LINK_DEP]    = @OWN_DEP_LINK,-- {LINK_DEP},
 		[INSERTED_UIDS] = b.Ref
	  FROM 
			[{Variable_TempDb}].dbo.[CatalogObject|] b
	  WHERE 
			b.IsFolder = 'false' AND b.DeletionMark = 'false' AND b.Code <> '' AND b.[Description] <> ''
			AND b.Code NOT IN (SELECT BIK FROM #T0)
	  ORDER BY 
			B.Code
	  
		--    
		DECLARE @iROWCOUNT INT
		SET @iROWCOUNT = @@ROWCOUNT

	  --      ,    
	  INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK],[Ref])
	  SELECT 
		A.LINK, b.Ref		
	  FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
		INNER JOIN #T0 A ON A.BIK = b.Code
	  WHERE b.IsFolder = 'false' AND b.DeletionMark = 'false' AND b.Code <> '' AND b.[Description] <> ''
	  
	  
	  
	IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_BANKS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_BANKS]

	SELECT
	    = b.[Description],
	             = b.Code,
	  = CASE WHEN b.[Description] = '' THEN '  '
						WHEN b.Code = '' THEN '  '
						WHEN b.DeletionMark = 'true' THEN '  '
						WHEN b.Code IN (SELECT BIK FROM #T0) THEN '       ' END 
	INTO [{Variable_TempDb}].dbo.[__JOURNAL_BANKS]
	  FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
	  WHERE b.IsFolder = 'false' AND (b.DeletionMark = 'true' OR b.Code = '' OR b.[Description] = ''
	  OR b.Code IN (SELECT BIK FROM #T0))
	ORDER BY 

	DECLARE @iROWS_NOT_COPIED BIGINT
	SET @iROWS_NOT_COPIED = @@ROWCOUNT
	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_BANKS',ISNULL(@iROWS_NOT_COPIED,0))
	--

	  ---

	  INSERT INTO [{Variable_WorkDb}].dbo.BANKS WITH (ROWLOCK) (LINK, BIK, KS, CITY, OSB, FILIAL, FILIAL_NAME, [NAME]) 
	  SELECT 
	  LINK          = SB.LINK, 
	  BIK           = RIGHT(ISNULL(LTRIM(RTRIM( b.[Code] )),''),10),
	  KS            = LEFT(ISNULL(LTRIM(RTRIM( b. )),''),20),
	  CITY          = LEFT(ISNULL(LTRIM(RTRIM( b. )),''),100),
	  OSB           = '',
	  FILIAL        = '',
	  FILIAL_NAME   = '',
	  [NAME]        = LEFT(ISNULL(LTRIM(RTRIM( b.[Description] )),''),100)
	  FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
	  INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] sb ON sb.Ref = B.Ref
	  WHERE b.IsFolder = 'false' AND b.DeletionMark = 'false' AND b.Code  <> '' AND b.Description <> ''
	  AND b.Code NOT IN (SELECT BIK FROM [{Variable_WorkDb}].dbo.BANKS)
	  ORDER BY B.Code

		DECLARE @iGROUP_LINK INT, @IERROR INT
		SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
		WHERE dg.SYS = 6
	    
			INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
			SELECT DISTINCT sb.link, @iGROUP_LINK
			FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_] sb
			WHERE NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.link AND T.GROUP_LINK = @iGROUP_LINK)			

			SELECT @iError = @@ERROR
			IF @iError <> 0
			BEGIN
				ROLLBACK
	 		PRINT('  ' + convert(varchar(254),@iERROR) )
		  RAISERROR('     ', 11,1)
			END
END
GO
		
DROP TABLE #T0
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
GO
	

    
COMMIT TRAN


