set xact_abort on
BEGIN TRAN

-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--  CODE  FULL_NAME
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN 
	(
		SELECT [LINK], CODE, FULL_NAME, NUM = ROW_NUMBER() OVER (PARTITION BY CODE, FULL_NAME ORDER BY [LINK])	
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS_TYPE_FN(2)
		WHERE LINK_DEP = {Variable_WorkDb}.dbo.getowndeplink()
	) D	ON D.NUM = 1 
		AND D.CODE = b.[CODE]
		AND D.FULL_NAME = LEFT(case when LEN(b.[]) > 0 THEN b.[] ELSE b.[Description] END,254)
WHERE
	b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND ISNULL(LTRIM(RTRIM( b.[CODE])),'') <> ''
	AND LEN( LEFT(case when LEN(b.[]) > 0 THEN b.[] ELSE b.[Description] END,254) ) > 1
GO

DECLARE
	@OWN_DEP_LINK		INT

SET @OWN_DEP_LINK = [{Variable_WorkDb}].dbo.getOwnDepLink()

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
 	VED_LINK,
 	MAIN_LINK,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	UCHR_LINK,
 	CODE_TOFK,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE], [LINK_DEP],
 	[INSERTED_UIDS]) 
OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS] INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_]
SELECT 
	CODE          = ISNULL(LTRIM(RTRIM(b.[Code])),''),  
	[NAME]        = LEFT(case when LEN(b.[Description]) > 0 THEN b.[Description] else b.[] END,254),
	FULL_NAME     = LEFT(case when LEN(b.[]) > 0 THEN b.[] ELSE b.[Description] END,254),
	INN           = '', 
 	KPP           = '',
 	OKPO          = '',
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = '',
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	LINK_DEP      = @OWN_DEP_LINK,
 	[INSERTED_UIDS]   = b.Ref
  FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
  WHERE 
	b.DeletionMark = 'false' AND b.Code <> '' AND b.[Description] <> ''
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
  ORDER BY 
	B.Code

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_BUDG]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_BUDG]
SELECT
             = b.Code,
    = b.[Description],
  = CASE WHEN b.[Description] = '' THEN '  '
                    WHEN b.Code = '' THEN '  '
                    WHEN b.DeletionMark = 'true' THEN '  ' END 
INTO [{Variable_TempDb}].dbo.[__JOURNAL_BUDG]
  FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
  WHERE (b.DeletionMark = 'true' OR b.Code = '' OR b.[Description] = '')
ORDER BY 

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_BUDG', ISNULL(@iROWS_NOT_COPIED,0))
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]

--   
UPDATE D SET 
	D.LINK_BUDG = B.LINK
FROM
	{Variable_TempDb}.dbo.[CatalogObject|] O
	INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] OO ON OO.REF = O.REF
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = OO.LINK
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_] B ON B.Ref = O.
WHERE
	D.LINK_BUDG IS NULL
GO
   
  ---

DECLARE @iGROUP_LINK INT, @IERROR INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 2
    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT DISTINCT sb.link, @iGROUP_LINK
FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_] sb
WHERE NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.link AND T.GROUP_LINK = @iGROUP_LINK)		

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
PRINT('  ' + convert(varchar(254),@iERROR) )
RAISERROR('     ', 11,1)
END

GO

	

--   
USE {Variable_TempDb}

INSERT INTO [{Variable_WorkDb}].dbo.BUDGET_TYPE ([CODE], [SNAME], [NAME], [CODE_EL], [LINK_DEP])
SELECT DISTINCT 
	[CODE] = RIGHT(LTRIM(RTRIM(E.CODE)),2),
	[SNAME] = LEFT(LTRIM(RTRIM(E.)),50),
	[NAME] = LEFT(LTRIM(RTRIM(E.)),254),
	[CODE_EL] =RIGHT(LTRIM(RTRIM(E.CODE)),2),
	[LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] O ON O.REF = T.REF
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON O. = B.REF
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] E ON E.REF = B.
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.BUDGET_TYPE A WHERE LTRIM(LTRIM(A.[CODE_EL])) = LTRIM(RTRIM(E.CODE)))

--   
IF OBJECT_ID ('TEMPDB..#TMP_BU') IS NOT NULL
	EXEC ('DROP TABLE #TMP_BU')

--UPDATE D SET D.imns_LINK = I.LINK
SELECT DISTINCT
	B_LINK = T.LINK, U_LINK = I.LINK,
	REC_NUM = ROW_NUMBER () OVER (PARTITION BY T.LINK ORDER BY I.[CODE_EL])
	INTO #TMP_BU
FROM
	[{Variable_TempDb}].dbo.[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON T.REF = B.REF
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] E ON E.REF = B.

	INNER JOIN (SELECT [LINK], [CODE_EL], NUM = ROW_NUMBER() OVER (PARTITION BY [CODE_EL] ORDER BY [LINK])
					FROM [{Variable_WorkDb}].dbo.BUDGET_TYPE WHERE [CODE_EL] IS NOT NULL
				) I ON I.NUM = 1 AND LTRIM(RTRIM(E.[CODE])) LIKE LTRIM(RTRIM(I.[CODE_EL]))
WHERE
	I.[LINK] IS NOT NULL
GO

DELETE [{Variable_WorkDb}].dbo.BUDGET WHERE EXISTS (SELECT * FROM #TMP_BU WHERE BUDG = B_LINK)

INSERT INTO [{Variable_WorkDb}].dbo.BUDGET (BUDG, [TYPE])
SELECT
	B_LINK, U_LINK
FROM #TMP_BU 
WHERE REC_NUM = 1

GO

--   
USE {Variable_TempDb}

IF OBJECT_ID('TEMPDB..#DEP','U') IS NOT NULL DROP TABLE #DEP CREATE TABLE #DEP (LINK INT)

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS ([CODE], [CODE_FO], [OKPO], [NAME], [FULL_NAME], [INN], [KPP], [LINK_DEP])
	OUTPUT INSERTED.[LINK] INTO #DEP (LINK)
SELECT DISTINCT 
	[CODE] = LEFT(,20),
	[CODE_FO] = LEFT(,5),
	[OKPO] = LEFT(,20),
	[NAME] = CASE
				WHEN ISNULL (, '') = ''
					THEN '  '
				ELSE LEFT(,254)
			END,
	[FULL_NAME] = CASE
				WHEN ISNULL (, '') = ''
					THEN '   '
				ELSE LEFT(,254)
			END,
	[INN] = REPLICATE('0',10),
	[KPP] = REPLICATE('0',9),
	[LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()
FROM
	[{Variable_TempDb}].dbo.[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON T.REF = B.REF
WHERE
	LEN(LTRIM(RTRIM())) > 0
	AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENTS_TYPE_FN(9) WHERE LTRIM(LTRIM([OKPO])) = LTRIM(RTRIM()))

DECLARE @GROUP_LINK INT SET @GROUP_LINK = (SELECT LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS WHERE [SYS] = 9)
   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT DISTINCT A.LINK, @GROUP_LINK
FROM #DEP A WHERE @GROUP_LINK IS NOT NULL AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = A.LINK AND T.GROUP_LINK = @GROUP_LINK)
GO

--   
UPDATE D SET D.FO_LINK = I.LINK
FROM
	[{Variable_TempDb}].dbo.[__DEPARTMENTS_] T
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = T.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON T.REF = B.REF
	INNER JOIN (SELECT D.[LINK], D.[OKPO], NUM = ROW_NUMBER() OVER (PARTITION BY D.[OKPO] ORDER BY D.LINK)
					FROM  [{Variable_WorkDb}].dbo.DEPARTMENTS D
							INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
							INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 9
					WHERE EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[CatalogObject|] WHERE LTRIM(RTRIM()) LIKE LTRIM(RTRIM(D.[OKPO]))) 
				) I ON I.NUM = 1 AND LTRIM(LTRIM(I.[OKPO])) = LTRIM(RTRIM())	
WHERE
	I.[LINK] IS NOT NULL AND D.FO_LINK IS NULL
GO


COMMIT TRAN


