--  
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__ACCOUNTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__ACCOUNTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__ACCOUNTS_]
GO

set xact_abort on
BEGIN TRAN

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

----    

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_DEP1_ACCOUNTS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_DEP1_ACCOUNTS]

CREATE TABLE [dbo].[__JOURNAL_DEP1_ACCOUNTS] (
	[] varchar(max) ,
	[] VARCHAR(MAX) ,
	[] VARCHAR(MAX) ,
 [] VARCHAR(MAX))
GO
----
----
UPDATE S
SET
	s.[] = '00000000-0000-0000-0000-000000000000'
FROM [{Variable_TempDb}].dbo.[CatalogObject|] s
WHERE s.[] = ''

DECLARE @iLINK INT, @iError int

INSERT INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_] ([LINK], [Ref])
SELECT DISTINCT
	DA.LINK,
	s.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] b ON b.Ref = convert(uniqueidentifier,s.)
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co1 ON co1.Ref = convert(uniqueidentifier,s.)
	
	LEFT JOIN 
	(
		SELECT B.LINK, B.BIK, NUM = ROW_NUMBER() OVER (PARTITION BY B.BIK ORDER BY B.LINK)
		FROM 
			[{Variable_WorkDb}].dbo.BANKS B
			INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = B.LINK
		WHERE
			D.LINK_DEP = {LINK_DEP}
	) b2 ON B2.NUM = 1 AND b2.BIK = RIGHT(co1.Code,9)

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])

	INNER JOIN 
		(
			SELECT LINK, LINK_UP, DEP, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_UP, DEP, CODE ORDER BY LINK)
			FROM 
				[{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
			WHERE
				[TYPE] = 1
		) DA ON DA.NUM = 1 AND DA.LINK_UP = isnull(cazn.LINK,cag.link) AND DA.DEP = ISNULL(b.LINK,b2.LINK) AND DA.CODE = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),'')

WHERE 
	s.DeletionMark = 'false' 
	AND S. IN ('', '')
	AND isnull(cazn.LINK,cag.link) IS NOT NULL
	AND ISNULL(b.LINK,b2.LINK) IS NOT NULL
	AND s.Code <> ''


---   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[INSERTED_UIDS])
 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_]
SELECT 
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),''),
	[TYPE]      = 1,
	DEP         = ISNULL(b.LINK,b2.LINK),
	ACC         = NULL,
	LINK_UP     = isnull(cazn.LINK,cag.link),
	[INSERTED_UIDS] = s.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] b ON b.Ref = convert(uniqueidentifier,s.)
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co1 ON co1.Ref = convert(uniqueidentifier,s.)
	
	LEFT JOIN 
	(
		SELECT B.LINK, B.BIK, NUM = ROW_NUMBER() OVER (PARTITION BY B.BIK ORDER BY B.LINK)
		FROM 
			[{Variable_WorkDb}].dbo.BANKS B
			INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = B.LINK
		WHERE
			D.LINK_DEP = {LINK_DEP}
	) b2 ON B2.NUM = 1 AND b2.BIK = RIGHT(co1.Code,9)	

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])
WHERE 
	s.DeletionMark = 'false' 
	AND S. IN ('', '')
	AND isnull(cazn.LINK,cag.link) IS NOT NULL
	AND ISNULL(b.LINK,b2.LINK) IS NOT NULL
	AND s.Code <> ''
	AND NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_] T WHERE T.[Ref] = s.Ref )
ORDER BY 
	s.Code

---   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[INSERTED_UIDS])
 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_]
SELECT 
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),''),
	[TYPE]      = 1,
	DEP         = ( SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENTS_TYPE_FN(6) ),
	ACC         = NULL,
	LINK_UP     = isnull(cazn.LINK,cag.link),
	[INSERTED_UIDS] = s.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])
WHERE 
	s.DeletionMark = 'false' 
	AND S. IN ('', '')
	AND isnull(cazn.LINK,cag.link) IS NOT NULL
	AND s.Code <> ''
	AND NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_] T WHERE T.[Ref] = s.Ref )
ORDER BY 
	s.Code

DECLARE @iROWCOUNT1 INT
SET @iROWCOUNT1 = @@ROWCOUNT

--    

DECLARE @iROWS_NOT_COPIED BIGINT

INSERT INTO [{Variable_TempDb}].[dbo].[__JOURNAL_DEP1_ACCOUNTS]
SELECT
[]               = s.Code,
[]          = s.[Description],
[]  = co.[Description],
[]    = CASE WHEN s.DeletionMark = 'true' THEN '  '
                        WHEN isnull(cazn.LINK,cag.link) IS NULL THEN '  ""  ,     ' 
               WHEN s.Code = '' THEN '  ' END
FROM [{Variable_TempDb}].dbo.[CatalogObject|] s
LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON co.Ref = s.[Owner]
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] b ON b.Ref = convert(uniqueidentifier,s.)
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])
WHERE S. = '' AND (s.DeletionMark = 'true' OR isnull(cazn.LINK,cag.link) IS NULL)
OR s.Code = ''
ORDER BY 

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', '  : ' + convert(nvarchar(100),@iROWCOUNT1), '__JOURNAL_DEP1_ACCOUNTS', ISNULL(@iROWS_NOT_COPIED,0))
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
GO

COMMIT TRAN