--  
--   
USE {Variable_TempDb}
GO

set xact_abort on
BEGIN TRAN

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

----    

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_DEP2_ACCOUNTS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_DEP2_ACCOUNTS]

CREATE TABLE [dbo].[__JOURNAL_DEP2_ACCOUNTS] (
	[] varchar(max) ,
	[] VARCHAR(MAX) ,
	[] VARCHAR(MAX) ,
 [] VARCHAR(MAX))
GO
----

DECLARE @iLINK INT, @iError int

---   
--   
INSERT INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_] ([LINK], [Ref])
SELECT DISTINCT
	DA.LINK,
	s.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dep ON dep.Ref = convert(uniqueidentifier, (CASE WHEN s. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE s. END))
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] AS ac ON ac.Ref = convert(uniqueidentifier,(CASE WHEN s. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE s. END))

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])

	INNER JOIN 
		(
			SELECT LINK, LINK_UP, ACC, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_UP, ACC, CODE ORDER BY LINK)
			FROM 
				[{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
			WHERE
				[TYPE] = 2
		) DA ON DA.NUM = 1 AND DA.LINK_UP = isnull(cazn.LINK,cag.link) AND DA.ACC = ac.link AND DA.CODE = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),'')
	
WHERE 
	s.DeletionMark = 'false' AND S. = '' AND isnull(cazn.LINK,cag.link) IS NOT NULL
	AND ac.link IS NOT NULL AND s.Code <> ''

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[INSERTED_UIDS])
 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_]
SELECT 
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),''),
	[TYPE]      = 2,
	DEP         = NULL,
	ACC         = ac.link,
	LINK_UP     = isnull(cazn.LINK,cag.link),
	[INSERTED_UIDS] = s.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dep ON dep.Ref = convert(uniqueidentifier,(CASE WHEN s. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE s. END))
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] AS ac ON ac.Ref = convert(uniqueidentifier,(CASE WHEN s. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE s. END))

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])

WHERE 
	s.DeletionMark = 'false' AND S. = '' AND isnull(cazn.LINK,cag.link) IS NOT NULL
	AND ac.link IS NOT NULL AND s.Code <> ''
	AND NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_] T WHERE T.[Ref] = s.Ref )
	and not exists(select * from [{Variable_WorkDb}].dbo.DEPARTMENTS D where d.LINK = cag.link and D.[type] = 1)
ORDER BY 
	s.Code

DECLARE @iROWCOUNT2 INT
SET @iROWCOUNT2 = @@ROWCOUNT

--   
INSERT INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_] ([LINK], [Ref])
SELECT DISTINCT
	DA.LINK,
	s.Ref
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_ d 
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] s ON s.[Owner] = d.Ref
	INNER JOIN (
		SELECT 
			[Owner], , NUM = ROW_NUMBER() OVER (PARTITION BY [Owner] ORDER BY  DESC)
		FROM
			[{Variable_TempDb}].dbo.[CatalogObject|]
	) co ON co.NUM = 1 
		AND co.[Owner] = s.Ref
	INNER JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] AS ac ON ac.Ref = convert(uniqueidentifier,(CASE WHEN CO. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE CO. END))
	INNER JOIN
			(
			SELECT LINK, LINK_UP, ACC, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_UP, ACC, CODE ORDER BY LINK)
			FROM 
				[{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
			WHERE
				[TYPE] = 2
		) DA ON DA.NUM = 1
			AND DA.LINK_UP = d.LINK
			AND DA.ACC = ac.link
			AND DA.CODE = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),'')
WHERE 
	ac.LINK IS NOT NULL

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[INSERTED_UIDS])
 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_]
SELECT 
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),''),
	[TYPE]      = 2,
	DEP         = NULL,
	ACC         = ac.LINK,
	LINK_UP     = d.LINK,
	[INSERTED_UIDS] = s.Ref
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_ d 
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] s ON s.[Owner] = d.Ref
	INNER JOIN (
		SELECT 
			[Owner], , NUM = ROW_NUMBER() OVER (PARTITION BY [Owner] ORDER BY  DESC)
		FROM
			[{Variable_TempDb}].dbo.[CatalogObject|]
	) co ON co.NUM = 1 
		AND co.[Owner] = s.Ref
	INNER JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] AS ac ON ac.Ref = convert(uniqueidentifier,(CASE WHEN CO. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE CO. END))
WHERE 
	ac.LINK IS NOT NULL
	AND NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_] T WHERE T.[Ref] = s.Ref )


--    -  
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[INSERTED_UIDS])
 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_]
SELECT 
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( s.Code )),20),''),
	[TYPE]      = 2,
	DEP         = NULL,
	ACC         = (SELECT TOP 1 A.LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS A INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_TYPE_FN(7) B ON A.LINK_UP = B.LINK),
	LINK_UP     = d.LINK,
	[INSERTED_UIDS] = s.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d ON s.[Owner] = d.Ref
WHERE 
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_] T WHERE T.[Ref] = s.Ref )

SET @iROWCOUNT2 = ISNULL(@iROWCOUNT2,0) + @@ROWCOUNT

 
---
DECLARE @iROWS_NOT_COPIED BIGINT

INSERT INTO [{Variable_TempDb}].[dbo].[__JOURNAL_DEP2_ACCOUNTS]
SELECT
[]               = s.Code,
[]          = s.[Description],
[]  = co.[Description],
[]    = CASE WHEN s.DeletionMark = 'true' THEN '  '
                        WHEN isnull(cazn.LINK,cag.link) IS NULL THEN '  ""  ,     '
                        WHEN ac.link IS NULL THEN '   ' 
                    WHEN s.Code = '' THEN '  ' END
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] s
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON co.Ref = s.[Owner]
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dep ON dep.Ref = convert(uniqueidentifier,(CASE WHEN s. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE s. END))
	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] AS ac ON ac.Ref = convert(uniqueidentifier,(CASE WHEN s. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE s. END))

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cazn ON cazn.Ref = convert(uniqueidentifier,s.[Owner])
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] cag ON cag.Ref = convert(uniqueidentifier,s.[Owner])

WHERE 
	S. = '' AND (s.DeletionMark = 'true' OR isnull(cazn.LINK,cag.link) IS NULL
	OR ac.link IS NULL)
	OR s.Code = ''
ORDER BY 

SET @iROWS_NOT_COPIED = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].[dbo].[__JOURNAL_DEP2_ACCOUNTS]
SELECT
[]               = s.Code,
[]          = s.[Description],
[]  = co.[Description],
[]    =  '   ' 
FROM [{Variable_TempDb}].dbo.[CatalogObject|] s
INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d ON s.[Owner] = d.Ref
LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON co.[Owner] = s.Ref
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dep ON dep.Ref = convert(uniqueidentifier,(CASE WHEN CO. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE CO. END))
LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] AS ac ON ac.Ref = convert(uniqueidentifier,(CASE WHEN CO. = '' THEN '00000000-0000-0000-0000-000000000000' ELSE CO. END))
WHERE ac.LINK IS NULL
ORDER BY 

SET @iROWS_NOT_COPIED = isnull(@iROWS_NOT_COPIED,0) + @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', '  : ' + convert(nvarchar(100),@iROWCOUNT2) , '__JOURNAL_DEP2_ACCOUNTS', ISNULL(@iROWS_NOT_COPIED,0))
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
GO

COMMIT TRAN