USE {Variable_TempDb}
GO

SET XACT_ABORT ON
BEGIN TRAN

IF OBJECT_ID('TEMPDB..#ADD_ACC','U') IS NOT NULL
	DROP TABLE #ADD_ACC
GO

SELECT DISTINCT cSource = , acc.cSinth, cAnalit = acc.cAnalit,--RIGHT('00' + ISNULL(acc.cAnalit,'00'),2),
[description] = LEFT([description],150), 
	[type], offbalance, 
	, ,,,
	, , , [Order]
INTO #ADD_ACC
FROM (
    SELECT (ar. + '.' + acc.Code) AS CODE1, ar.
    ,acc.*
    FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
    LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] acc ON acc.Ref = ar.AccountDr
    LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C sa ON sa.CODE = ar. + '.' + acc.Code AND sa.LINK_DEP = {LINK_DEP}
    WHERE sa.LINK IS NULL
    UNION ALL
    SELECT (ar. + '.' + acc.Code) AS CODE, ar.
    ,acc.*
    FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
    LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] acc ON acc.Ref = ar.AccountCr
    LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C sa ON sa.CODE = ar. + '.' + acc.Code AND sa.LINK_DEP = {LINK_DEP}
    WHERE sa.LINK IS NULL) AS s
    cross apply ( select string = code + '..' ) f1
    cross apply ( select p1 = charindex( '.', string ) ) ap1
    cross apply ( select p2 = charindex( '.', string, p1 + 1 ) ) ap2
	cross apply ( select cSinth = substring( string, 1, p1-1 )                  
                     , cAnalit = substring( string, p1+1, p2-p1-1 )                  
              ) acc    
WHERE s.CODE1 IS NOT NULL
	AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS_NASTR N WHERE N.[SINTH] = acc.cSinth AND N.[ANALITH] = RIGHT('00' + ISNULL(acc.cAnalit,'00'),2))
GO

--     ( ) --
UPDATE T1
SET [description] =	SUBSTRING (
				(
				SELECT
					', ' + RTRIM (A1.[description])	
				FROM #ADD_ACC A1
				WHERE
					A1.cSinth = T1.cSinth
					AND A1.cAnalit = T1.cAnalit
					AND A1.cSOURCE = T1.cSOURCE
				ORDER BY A1.[description]
				FOR XML PATH ('')
				), 3, 3000)
FROM #ADD_ACC T1
INNER JOIN
	(
	SELECT
		cSOURCE, cSINTH, cANALIT
	FROM #ADD_ACC
	GROUP BY
		cSOURCE, cSINTH, cANALIT
	HAVING
		COUNT (*) > 1
	) T2 ON
	T2.cSinth = T1.cSinth
	AND T2.cAnalit = T1.cAnalit
	AND T2.cSOURCE = T1.cSOURCE
GO

USE [{Variable_TempDb}]
GO

----     
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_ADD_DOP_ACC]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_ADD_DOP_ACC]

IF not exists(select * from sysobjects where id = object_id('[dbo].[__JOURNAL_ADD_DOP_ACC]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__JOURNAL_ADD_DOP_ACC] (
	[LINK1] int ,
	[cSource] varchar(1) NOT NULL,
	[cSinth] varchar(3) NOT NULL,
	[cAnalit] varchar(2) NOT NULL,
	[NAME] varchar(150),
	[LINK_DEP] int NOT NULL
 )
ELSE 
	DELETE FROM [dbo].[__JOURNAL_ADD_DOP_ACC]
GO

INSERT INTO [{Variable_WorkDb}].dbo.S_ACCOUNTS
(
NAME,
KSU,
LINK_SELF,
ORDERS,
ZABALANS,
s_active,
s_passive,
s_packed,
s_kassa,
p_DVZ,
ap_KBK,
ap_EKR,
ap_DEP,
ap_SUB,
ap_EMP,
ap_NOMEN,
ap_INV,
ap_KAU,
ap_DEP_ACC,
ap_TMC,
ap_INDATE,
ap_AP1,
ap_AP2,
ap_AP3,
ap_AP4,
ap_AP5,
ap_AP6,
p_NOCONTROL,
cSource,
cSinth,
cAnalit,
cUser,
p_UZAB,
KBK_TYPE,
ANALIT_EKR,
p_EKR,
p_KASSA,
NOMEN_TYPE,
p_DATE,
B_YEAR0,
OB_AP1,
OB_AP2,
OB_AP3,
OB_AP4,
OB_AP5,
OB_AP6,
OB_DEP,
OB_DEP_ACC,
OB_EKR,
OB_EMP,
OB_INV,
OB_KAU,
OB_KBK,
OB_NOMEN,
OB_SUB,
OB_TMC,
BUH_TYPE,
ISUSED,
CH_KBK,
CH_EKR,
CH_DEP,
CH_SUB,
CH_EMP,
CH_NOMEN,
CH_INV,
CH_KAU,
CH_DEP_ACC,
CH_TMC,
CH_INDATE,
CH_AP1,
CH_AP2,
CH_AP3,
CH_AP4,
CH_AP5,
CH_AP6,
LINK_DEP)
SELECT DISTINCT
	NAME = '+' + (
			SELECT TOP 1 string
			FROM
				(select TOP 1 
				string, count(*) CNT, LEN(string) l
				from 
				#ADD_ACC T
				join master..spt_values SPT on substring( ' '+[description], Number, 1 ) = ' '
											   and Number < len( [description] ) + 1
				cross apply ( select string = CASE WHEN substring ( [description], 1, Number - 1 ) = '' THEN [description] ELSE substring ( [description], 1, Number - 1 ) END) f5				
				where 
					SPT.[Type] = 'P' and Number > 0 and len(string) > 0
					AND T.cSinth = AA.cSinth
				group by string
				ORDER BY 2 desc, 3 desc		
				) A
			),	
	KSU = 0,
	LINK_SELF = CASE WHEN ISNULL(offbalance,'') = 'true' THEN 
				(SELECT TOP 1 LINK 
				FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS 
				WHERE LINK_DEP = {LINK_DEP} AND LINK_SELF IS NULL AND NAME LIKE '%')
			ELSE NULL END,
	ORDERS = 0,
	ZABALANS = 1,
	s_active = CASE WHEN ISNULL(AA.[TYPE],'') LIKE '%Active%' THEN 1 ELSE 0 END,
	s_passive = CASE WHEN ISNULL(AA.[TYPE],'') LIKE '%Passive%' THEN 1 ELSE 0 END,
	s_packed = 0,
	s_kassa = 0,
	p_DVZ = 0,
	ap_KBK = 0,
	ap_EKR = 0,
	ap_DEP = 0,
	ap_SUB = 0,
	ap_EMP = 0,
	ap_NOMEN = 0,
	ap_INV = 0,
	ap_KAU = 0,
	ap_DEP_ACC = 0,
	ap_TMC = 0,
	ap_INDATE = 0,
	ap_AP1 = 0,
	ap_AP2 = 0,
	ap_AP3 = 0,
	ap_AP4 = 0,
	ap_AP5 = 0,
	ap_AP6 = 0,
	p_NOCONTROL = 0,
	cSource = '',
	cSinth = AA.cSinth,
	cAnalit = '',
	cUser = '',
	p_UZAB = 0,
	KBK_TYPE = 14,
	ANALIT_EKR = NULL,
	p_EKR = 0,
	p_KASSA = 0,
	NOMEN_TYPE = 0,
	p_DATE = 0,
	B_YEAR0 = 0,
	OB_AP1 = 0,
	OB_AP2 = 0,
	OB_AP3 = 0,
	OB_AP4 = 0,
	OB_AP5 = 0,
	OB_AP6 = 0,
	OB_DEP = 0,
	OB_DEP_ACC = 0,
	OB_EKR = 0,
	OB_EMP = 0,
	OB_INV = 0,
	OB_KAU = 0,
	OB_KBK = 0,
	OB_NOMEN = 0,
	OB_SUB = 0,
	OB_TMC = 0,
	BUH_TYPE = 7,
	ISUSED = 1,
	CH_KBK = 0,
	CH_EKR = 0,
	CH_DEP = 0,
	CH_SUB = 0,
	CH_EMP = 0,
	CH_NOMEN = 0,
	CH_INV = 0,
	CH_KAU = 0,
	CH_DEP_ACC = 0,
	CH_TMC = 0,
	CH_INDATE = 0,
	CH_AP1 = 0,
	CH_AP2 = 0,
	CH_AP3 = 0,
	CH_AP4 = 0,
	CH_AP5 = 0,
	CH_AP6 = 0,
	LINK_DEP = {LINK_DEP}
FROM 
	#ADD_ACC AA
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS SA WHERE LINK_DEP = {LINK_DEP} AND SA.cSource = '' AND SA.cSinth = AA.cSinth AND SA.cAnalit = '')


INSERT INTO [{Variable_WorkDb}].dbo.S_ACCOUNTS
(
NAME,
KSU,
LINK_SELF,
ORDERS,
ZABALANS,
s_active,
s_passive,
s_packed,
s_kassa,
p_DVZ,
ap_KBK,
ap_EKR,
ap_DEP,
ap_SUB,
ap_EMP,
ap_NOMEN,
ap_INV,
ap_KAU,
ap_DEP_ACC,
ap_TMC,
ap_INDATE,
ap_AP1,
ap_AP2,
ap_AP3,
ap_AP4,
ap_AP5,
ap_AP6,
p_NOCONTROL,
cSource,
cSinth,
cAnalit,
cUser,
p_UZAB,
KBK_TYPE,
ANALIT_EKR,
p_EKR,
p_KASSA,
NOMEN_TYPE,
p_DATE,
B_YEAR0,
OB_AP1,
OB_AP2,
OB_AP3,
OB_AP4,
OB_AP5,
OB_AP6,
OB_DEP,
OB_DEP_ACC,
OB_EKR,
OB_EMP,
OB_INV,
OB_KAU,
OB_KBK,
OB_NOMEN,
OB_SUB,
OB_TMC,
BUH_TYPE,
ISUSED,
CH_KBK,
CH_EKR,
CH_DEP,
CH_SUB,
CH_EMP,
CH_NOMEN,
CH_INV,
CH_KAU,
CH_DEP_ACC,
CH_TMC,
CH_INDATE,
CH_AP1,
CH_AP2,
CH_AP3,
CH_AP4,
CH_AP5,
CH_AP6,
LINK_DEP)
SELECT DISTINCT
	NAME = '+' + (
			SELECT TOP 1 string
			FROM
				(select TOP 1 
				string, count(*) CNT, LEN(string) l
				from 
				#ADD_ACC T
				join master..spt_values SPT on substring( ' '+[description], Number, 1 ) = ' '
											   and Number < len( [description] ) + 1
				cross apply ( select string = CASE WHEN substring ( [description], 1, Number - 1 ) = '' THEN [description] ELSE substring ( [description], 1, Number - 1 ) END) f5				
				where 
					SPT.[Type] = 'P' and Number > 0 and len(string) > 0
					AND T.cSinth = AA.cSinth
					AND T.cAnalit = AA.cAnalit
				group by string
				ORDER BY 2 desc, 3 desc		
				) A
			),
	KSU = 0,
	LINK_SELF = (SELECT MAX(A.LINK) FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS A WHERE A.LINK_DEP = {LINK_DEP} AND A.cSource = '' AND A.cSinth = AA.cSinth AND A.cAnalit = ''),
	ORDERS = 0,
	ZABALANS = 1,
	s_active = CASE WHEN ISNULL(AA.[TYPE],'') LIKE '%Active%' THEN 1 ELSE 0 END,
	s_passive = CASE WHEN ISNULL(AA.[TYPE],'') LIKE '%Passive%' THEN 1 ELSE 0 END,
	s_packed = 0,
	s_kassa = 0,
	p_DVZ = 0,
	ap_KBK = 0,
	ap_EKR = 0,
	ap_DEP = 0,
	ap_SUB = 0,
	ap_EMP = 0,
	ap_NOMEN = 0,
	ap_INV = 0,
	ap_KAU = 0,
	ap_DEP_ACC = 0,
	ap_TMC = 0,
	ap_INDATE = 0,
	ap_AP1 = 0,
	ap_AP2 = 0,
	ap_AP3 = 0,
	ap_AP4 = 0,
	ap_AP5 = 0,
	ap_AP6 = 0,
	p_NOCONTROL = 0,
	cSource = '',
	cSinth = AA.cSinth,
	cAnalit = AA.cAnalit,
	cUser = '',
	p_UZAB = 0,
	KBK_TYPE = 14,
	ANALIT_EKR = NULL,
	p_EKR = 0,
	p_KASSA = 0,
	NOMEN_TYPE = 0,
	p_DATE = 0,
	B_YEAR0 = 0,
	OB_AP1 = 0,
	OB_AP2 = 0,
	OB_AP3 = 0,
	OB_AP4 = 0,
	OB_AP5 = 0,
	OB_AP6 = 0,
	OB_DEP = 0,
	OB_DEP_ACC = 0,
	OB_EKR = 0,
	OB_EMP = 0,
	OB_INV = 0,
	OB_KAU = 0,
	OB_KBK = 0,
	OB_NOMEN = 0,
	OB_SUB = 0,
	OB_TMC = 0,
	BUH_TYPE = 7,
	ISUSED = 1,
	CH_KBK = 0,
	CH_EKR = 0,
	CH_DEP = 0,
	CH_SUB = 0,
	CH_EMP = 0,
	CH_NOMEN = 0,
	CH_INV = 0,
	CH_KAU = 0,
	CH_DEP_ACC = 0,
	CH_TMC = 0,
	CH_INDATE = 0,
	CH_AP1 = 0,
	CH_AP2 = 0,
	CH_AP3 = 0,
	CH_AP4 = 0,
	CH_AP5 = 0,
	CH_AP6 = 0,
	LINK_DEP = {LINK_DEP}
FROM 
	#ADD_ACC AA
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS SA WHERE LINK_DEP = {LINK_DEP} AND SA.cSource = '' AND SA.cSinth = AA.cSinth AND SA.cAnalit = AA.cAnalit)

INSERT INTO [{Variable_WorkDb}].dbo.S_ACCOUNTS
(
NAME,
KSU,
LINK_SELF,
ORDERS,
ZABALANS,
s_active,
s_passive,
s_packed,
s_kassa,
p_DVZ,
ap_KBK,
ap_EKR,
ap_DEP,
ap_SUB,
ap_EMP,
ap_NOMEN,
ap_INV,
ap_KAU,
ap_DEP_ACC,
ap_TMC,
ap_INDATE,
ap_AP1,
ap_AP2,
ap_AP3,
ap_AP4,
ap_AP5,
ap_AP6,
p_NOCONTROL,
cSource,
cSinth,
cAnalit,
cUser,
p_UZAB,
KBK_TYPE,
ANALIT_EKR,
p_EKR,
p_KASSA,
NOMEN_TYPE,
p_DATE,
B_YEAR0,
OB_AP1,
OB_AP2,
OB_AP3,
OB_AP4,
OB_AP5,
OB_AP6,
OB_DEP,
OB_DEP_ACC,
OB_EKR,
OB_EMP,
OB_INV,
OB_KAU,
OB_KBK,
OB_NOMEN,
OB_SUB,
OB_TMC,
BUH_TYPE,
ISUSED,
CH_KBK,
CH_EKR,
CH_DEP,
CH_SUB,
CH_EMP,
CH_NOMEN,
CH_INV,
CH_KAU,
CH_DEP_ACC,
CH_TMC,
CH_INDATE,
CH_AP1,
CH_AP2,
CH_AP3,
CH_AP4,
CH_AP5,
CH_AP6,
LINK_DEP)
OUTPUT INSERTED.LINK, INSERTED.cSource, INSERTED.cSinth, INSERTED.cAnalit, INSERTED.NAME, INSERTED.LINK_DEP INTO [{Variable_TempDb}].[dbo].[__JOURNAL_ADD_DOP_ACC] (LINK1,cSource,cSinth,cAnalit,NAME,LINK_DEP)
SELECT DISTINCT
	NAME = '+' + AA.[description],
	KSU = CASE WHEN ISNULL(,'') = 'true' THEN 1 ELSE 0 END,
	LINK_SELF = (SELECT MAX(A.LINK) FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS A WHERE A.LINK_DEP = {LINK_DEP} AND A.cSource = '' AND A.cSinth = AA.cSinth AND A.cAnalit = AA.cAnalit),
	ORDERS = 0,
	ZABALANS = CASE WHEN ISNULL(offbalance,'') = 'true' THEN 1 ELSE 0 END,
	s_active = CASE WHEN ISNULL([TYPE],'') LIKE '%Active%' THEN 1 ELSE 0 END,
	s_passive = CASE WHEN ISNULL([TYPE],'') LIKE '%Passive%' THEN 1 ELSE 0 END,
	s_packed = 0,
	s_kassa = 0,
	p_DVZ = 0,
	ap_KBK = 0,
	ap_EKR = 0,
	ap_DEP = 0,
	ap_SUB = 0,
	ap_EMP = 0,
	ap_NOMEN = 0,
	ap_INV = 0,
	ap_KAU = 0,
	ap_DEP_ACC = 0,
	ap_TMC = 0,
	ap_INDATE = 0,
	ap_AP1 = 0,
	ap_AP2 = 0,
	ap_AP3 = 0,
	ap_AP4 = 0,
	ap_AP5 = 0,
	ap_AP6 = 0,
	p_NOCONTROL = 0,
	cSource = AA.cSource,
	cSinth = AA.cSinth,
	cAnalit = AA.cAnalit,
	cUser = '',
	p_UZAB = 0,
	KBK_TYPE = 14,
	ANALIT_EKR = NULL,
	p_EKR = 0,
	p_KASSA = 0,
	NOMEN_TYPE = 0,
	p_DATE = 0,
	B_YEAR0 = 0,
	OB_AP1 = 0,
	OB_AP2 = 0,
	OB_AP3 = 0,
	OB_AP4 = 0,
	OB_AP5 = 0,
	OB_AP6 = 0,
	OB_DEP = 0,
	OB_DEP_ACC = 0,
	OB_EKR = 0,
	OB_EMP = 0,
	OB_INV = 0,
	OB_KAU = 0,
	OB_KBK = 0,
	OB_NOMEN = 0,
	OB_SUB = 0,
	OB_TMC = 0,
	BUH_TYPE = CASE WHEN ISNULL(,'') = 'true' THEN 1 ELSE 0 END
			+ CASE WHEN ISNULL(,'') = 'true' THEN 2 ELSE 0 END
			+ CASE WHEN ISNULL(,'') = 'true' THEN 4 ELSE 0 END,
	ISUSED = 1,
	CH_KBK = 0,
	CH_EKR = 0,
	CH_DEP = 0,
	CH_SUB = 0,
	CH_EMP = 0,
	CH_NOMEN = 0,
	CH_INV = 0,
	CH_KAU = 0,
	CH_DEP_ACC = 0,
	CH_TMC = 0,
	CH_INDATE = 0,
	CH_AP1 = 0,
	CH_AP2 = 0,
	CH_AP3 = 0,
	CH_AP4 = 0,
	CH_AP5 = 0,
	CH_AP6 = 0,
	LINK_DEP = {LINK_DEP}
FROM 
	#ADD_ACC AA
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS SA WHERE LINK_DEP = {LINK_DEP} AND SA.cSource = AA.cSource AND SA.cSinth = AA.cSinth AND SA.cAnalit = AA.cAnalit)

---
DECLARE @iROWCOUNT INT
set @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', '   : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_ADD_DOP_ACC', @iROWCOUNT)
---
UPDATE SA
SET
	CODE =	CASE
				WHEN ISNULL (SA.cSource, '') = '' THEN ''
				ELSE LTRIM (RTRIM (SA.cSource)) + '.'
			END
			+
			LTRIM (RTRIM (SA.cSinth))
			+
			CASE
				WHEN ISNULL (SA.cAnalit, '') = '' THEN ''
				ELSE '.' + LTRIM (RTRIM (SA.cAnalit))
			END
FROM
	(
	SELECT
		A.cSinth
	FROM #ADD_ACC A
	GROUP BY
		A.cSinth
	) AS T1
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON
	SA.cSINTH = T1.cSinth 
	AND ISNULL (SA.CODE, '') = ''
---
COMMIT TRAN
