
set xact_abort on
BEGIN TRAN
-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__NOMENCLATURE_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__NOMENCLATURE_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__NOMENCLATURE_]

GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--    ,  
DECLARE @iLINK_DEP INT,@iLINK_UNKNOWN_GROUP INT
SET @iLINK_DEP = [{Variable_WorkDb}].dbo.[getOwnDepLink]()

SELECT TOP 1 @iLINK_UNKNOWN_GROUP = ga.LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.CODE_GRP = '00000'

SELECT 
    CODE        = CASE WHEN ISNULL(n.,'') = '' THEN RIGHT(n.Code,20) ELSE RIGHT(n.,20) END,
    [NAME]      = CASE WHEN LEN(n.) > 254 THEN left(n.[Description],254)
                    WHEN ISNULL(n.,'') = '' THEN left(n.[Description],254) ELSE n. END,
    GROUP_INV   = COALESCE(
    	(SELECT TOP 1 LINK FROM [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__] g WHERE g.Ref = convert(uniqueidentifier,n.Parent) AND g. = CASE WHEN REPLACE(n.,'.','') = '' THEN '00000' ELSE LEFT(REPLACE(n.,'.',''),5) END),
    (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE WHERE CODE_GRP = LEFT(REPLACE(n.,'.',''),5) AND (LINK_DEP = @iLINK_DEP OR LINK_DEP = {LINK_DEP})),
    @iLINK_UNKNOWN_GROUP),
    UM          = ml.LINK,
    SERIES      = '',
    IS_EXTRA    = 0,
    LINK_OKDP   = NULL,
    COEFF       = CONVERT(NUMERIC(18,9),1),
    PRICE_TYPE  = 0,
    ISUSED      = 1,
    LINK_DEP    = {LINK_DEP},
    [REF] = n.Ref
INTO #T0
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] n
	LEFT JOIN [{Variable_TempDb}].dbo.[__MEASURE_] ml ON ml.[Ref] = convert(uniqueidentifier,n.)
WHERE 
	n.IsFolder = 'false' AND n. NOT IN ('','')
ORDER BY 
	RIGHT(n.Code,20)

--   
INSERT INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_] (LINK,[Ref]) 
SELECT DISTINCT
	N.LINK, T.[REF]
FROM 
	#T0 T
	INNER JOIN 
	(	
	SELECT LINK, [GROUP_INV], [NAME],
		NUM = ROW_NUMBER() OVER (PARTITION BY [GROUP_INV], [NAME] ORDER BY [GROUP_INV], [NAME])
	FROM 
		{Variable_WorkDb}.dbo.NOMENCLATURE
	WHERE 
		[LINK_DEP] = {LINK_DEP}
	) N ON N.[GROUP_INV] = T.[GROUP_INV] AND N.[NAME] = T.[NAME]
WHERE
	N.NUM = 1	


--    
INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
	(CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF, PRICE_TYPE, ISUSED, LINK_DEP, [INSERTED_UIDS])
OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
    INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_]
SELECT 
	CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF, PRICE_TYPE, ISUSED, LINK_DEP, [REF]
FROM 
	#T0 A
WHERE 
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__NOMENCLATURE_] T WHERE T.[Ref] = A.Ref )
ORDER BY 
	CODE

---
DECLARE @iROWCOUNT INT 
SET @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
---

DROP TABLE #T0

---- !!!       
--EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH

COMMIT TRAN