
set xact_abort on
BEGIN TRAN
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__GROUP_ACTIVE__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__GROUP_ACTIVE__]
		(
		[LINK] int ,
		[Ref] UNIQUEIDENTIFIER
		)
ELSE 
	DELETE FROM [dbo].[__GROUP_ACTIVE__]
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where [Name] = N'INSERTED_UIDS' and [Object_ID] = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_UIDS]
GO

ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

DECLARE
	@iOBJECT INT,
	@iLINK_DEP INT,
	@GROUP_SERVICES INT

--    
SET @iLINK_DEP = [{Variable_WorkDb}].dbo.[getOwnDepLink] ()

--  
SET @iOBJECT = [{Variable_WorkDb}].dbo.OBJ_ID ('DICT_SERVICES')

--      
SELECT TOP 1
	@GROUP_SERVICES = LINK
FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga
WHERE ga.CODE_GRP = '90000'
	AND ga.[OBJECT] = @iOBJECT
	AND ga.CODE_PRF IS NULL

IF @GROUP_SERVICES IS NULL
BEGIN
	INSERT INTO [{Variable_WorkDb}].dbo.GROUP_ACTIVE
		(
		CODE_GRP, [NAME], ACCOUNT_B, [SYSTEM], [TYPE], ACCOUNT_AM, ISUSED,
		LINK_SELF, CODE_PRF, [OBJECT], LINK_DEP
		)
	VALUES('90000', '', NULL, 1, 2,NULL,1,NULL,NULL,@iOBJECT,{LINK_DEP})

	SELECT TOP 1
		@GROUP_SERVICES = LINK
	FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga
	WHERE ga.CODE_GRP = '90000'
		AND ga.[OBJECT] = @iOBJECT
		AND CODE_PRF IS NULL
END

--   
INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
	(
	CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF,
	PRICE_TYPE, ISUSED, LINK_DEP,[INSERTED_UIDS]
	)
OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
    INTO [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__]
SELECT 
	CODE        = CASE
						WHEN ISNULL (RIGHT (P.[], 20), '') = ''
							THEN ISNULL (RIGHT (P.CODE, 20), '')
						ELSE
							RIGHT (P.[], 20)
					END,
	[NAME]      = LEFT(P.[Description],254), 
	GROUP_INV   = @GROUP_SERVICES, 
	UM          = UM.LINK, 
	SERIES      = NULL, 
	IS_EXTRA    = 0, 
	LINK_OKDP   = NULL, 
	COEFF       = CONVERT(NUMERIC(18,9), 1), 
	PRICE_TYPE  = 0, 
	ISUSED      = 1,
	LINK_DEP    = {LINK_DEP},
	INSERTED_UIDS = P.Ref
FROM
	(
	SELECT
		AAA.PARENT
	FROM [{Variable_TempDb}].[dbo].[CatalogObject|] AAA
	WHERE
		AAA.[] IN ('', '')
	GROUP BY
		AAA.PARENT
	) AS C
INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] P ON
	P.REF = C.PARENT
	AND P.[DeletionMark] = 'false'

LEFT JOIN [{Variable_TempDb}].[dbo].[__MEASURE_] UM_REF ON 
	UM_REF.Ref = P.[]
LEFT JOIN [{Variable_WorkDb}].[dbo].[MEASURE] UM ON UM.LINK = UM_REF.LINK

--  --
UPDATE NOM
SET LINK_SELF = NOM_P.LINK
FROM [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__] T1
INNER JOIN [{Variable_WorkDb}].dbo.NOMENCLATURE NOM ON NOM.LINK = T1.LINK 
INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] C ON C.REF = T1.REF
INNER JOIN [{Variable_TempDb}].[dbo].[__GROUP_ACTIVE__] P ON P.REF = T1.REF
INNER JOIN [{Variable_WorkDb}].dbo.NOMENCLATURE NOM_P ON NOM_P.LINK = P.LINK 

GO


COMMIT TRAN
