
USE {Variable_TempDb}
GO
set xact_abort on
BEGIN TRAN
----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_UIDS]
GO

ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__NOMENCLATURE_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__NOMENCLATURE_]
		(
		[LINK] int ,
		[Ref] UNIQUEIDENTIFIER
		)
ELSE 
	DELETE FROM [dbo].[__NOMENCLATURE_]

GO

---- 
DECLARE
	@iROWCOUNT INT,
	@iOBJECT INT,
	@iLINK_DEP INT,
	@GROUP_SERVICES INT

SET @iROWCOUNT = 0
----
SET @iOBJECT = [{Variable_WorkDb}].dbo.OBJ_ID ('DICT_SERVICES')

--    
SET @iLINK_DEP = [{Variable_WorkDb}].dbo.[getOwnDepLink]()

--      
SELECT TOP 1
	@GROUP_SERVICES = LINK
FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga
WHERE
	ga.CODE_GRP = '90000'
	AND ga.[OBJECT] = @iOBJECT
	AND CODE_PRF IS NULL

IF @GROUP_SERVICES IS NULL
BEGIN
	INSERT INTO [{Variable_WorkDb}].dbo.GROUP_ACTIVE
		(
		CODE_GRP, [NAME], ACCOUNT_B, [SYSTEM], [TYPE], ACCOUNT_AM, ISUSED,
		LINK_SELF, CODE_PRF, [OBJECT], LINK_DEP
		)
	VALUES('90000', '', NULL, 1, 2,NULL,1,NULL,NULL,@iOBJECT,{LINK_DEP})

	SELECT TOP 1
		@GROUP_SERVICES = LINK
	FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga
	WHERE
		ga.CODE_GRP = '90000'
		AND ga.[OBJECT] = @iOBJECT
		AND CODE_PRF IS NULL
END

INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
	(
	CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF,
	PRICE_TYPE, ISUSED, LINK_DEP,[INSERTED_UIDS], LINK_SELF
	)
OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
	INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_]
SELECT 
	CODE        = CASE
					WHEN ISNULL (RIGHT (N.[], 20), '') = ''
						THEN ISNULL (RIGHT (N.CODE, 20), '')
					ELSE
						RIGHT (N.[], 20)
				END,
	[NAME]      = LEFT(n.[Description],254), 
	GROUP_INV   = @GROUP_SERVICES, 
	UM          = m.LINK, 
	SERIES      = NULL, 
	IS_EXTRA    = 0, 
	LINK_OKDP   = NULL, 
	COEFF       = CONVERT(NUMERIC(18,9),1), 
	PRICE_TYPE  = 0, 
	ISUSED      = 1,
	LINK_DEP    = {LINK_DEP},
	INSERTED_UIDS = n.Ref,
	LINK_SELF	= GA.LINK
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] n
	LEFT JOIN [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__] NGR ON NGR.Ref = n.Ref
	LEFT JOIN [{Variable_TempDb}].dbo.[__GROUP_ACTIVE__] ga ON ga.Ref = n.Parent
	LEFT JOIN [{Variable_TempDb}].dbo.[__MEASURE_] m ON m.Ref = n.[]
WHERE 
	n.[] IN ('','')
	AND NGR.LINK IS NULL

SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iUM INT

SELECT TOP 1
	@iUM = LINK 
FROM [{Variable_WorkDb}].dbo.MEASURE m 
WHERE m.CODE = '796' --

IF exists(select * from sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
		(
		CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF,
		PRICE_TYPE, ISUSED, LINK_DEP,[INSERTED_UIDS]
		)
    OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
		INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_]
    SELECT 
		CODE        = ISNULL(RIGHT(n.Code,20),''),
		[NAME]      = LEFT(n.[Description],254), 
		GROUP_INV   = @GROUP_SERVICES,
		UM          = @iUM, 
		SERIES      = NULL, 
		IS_EXTRA    = 0, 
		LINK_OKDP   = NULL, 
		COEFF       = CONVERT(NUMERIC(18,9),1), 
		PRICE_TYPE  = 0, 
		ISUSED      = 1,
		LINK_DEP    = {LINK_DEP},
		INSERTED_UIDS = n.Ref
    FROM [{Variable_TempDb}].dbo.[CatalogObject|] n

    SET @iROWCOUNT = @iROWCOUNT + @@ROWCOUNT
END
---

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100), @iROWCOUNT), '', 0)

ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_UIDS]
GO
    
---- !!!       
--EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH
---
COMMIT TRAN
