/*     ,      */
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[INVENTORY]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] DROP COLUMN [INSERTED_UIDS]
	END
GO
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK2' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[INVENTORY]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] DROP COLUMN [LINK2]
	END
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] ADD [LINK2] INT NULL
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'REF' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[INVENTORY]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] DROP COLUMN [REF]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] ADD [REF] UNIQUEIDENTIFIER NULL
GO

--   
USE [{Variable_TempDb}]
GO

SET XACT_ABORT ON
BEGIN TRAN

--   ,     --
IF OBJECT_ID ('TEMPDB..#INV_GRP_LIST_DEL') IS NOT NULL
	EXEC ('DROP TABLE #INV_GRP_LIST_DEL')

CREATE TABLE #INV_GRP_LIST_DEL
	(
	LINK	INT
	)

IF not exists(select * from sysobjects where id = object_id('[dbo].[__INVENTORY__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__INVENTORY__] (
	[LINK] int ,
	[LINK_MAIN] int ,
	[REF] UNIQUEIDENTIFIER )
ELSE
BEGIN
	INSERT INTO #INV_GRP_LIST_DEL (LINK)
	SELECT 
		LINK
	FROM [dbo].[__INVENTORY__]
	
	DELETE FROM [dbo].[__INVENTORY__]
END

--     --
DELETE T1
FROM [{Variable_WorkDb}].dbo.INVENTORY_GRP_LIST T1
INNER JOIN #INV_GRP_LIST_DEL T2 ON T2.LINK = T1.INV_DEPEND

DELETE T1
FROM [{Variable_WorkDb}].dbo.INVENTORY T1
WHERE EXISTS
		(
		SELECT 1 FROM #INV_GRP_LIST_DEL TTT WHERE TTT.LINK = T1.LINK
		)
	AND NOT EXISTS
				(
				SELECT 1 FROM [{Variable_WorkDb}].dbo.SALDO TTT WHERE TTT.INV = T1.LINK
				)
	AND NOT EXISTS
				(
				SELECT 1 FROM [{Variable_WorkDb}].dbo.G_PROV_AP TTT WHERE TTT.INV = T1.LINK
				)

--   --
CREATE TABLE #INS_LINKS (LINK INT, [LINK2] INT, [REF] UNIQUEIDENTIFIER NULL)

INSERT INTO [{Variable_WorkDb}].dbo.[INVENTORY] 
   ([CODE], 
   [NAME], 
   [COST], 
   [COMMENTS], 
   [STOCK], 
   [DEP_LINK],
   [TYPE_INV],
   [ATTACH],
   [GROUP_ACTIVE],
   [LINK2],
   [REF]
   )
OUTPUT INSERTED.LINK, INSERTED.[LINK2], INSERTED.[REF]
INTO #INS_LINKS
SELECT 
	isnull(right(tt.inv_num,20),''), i2.NAME, i2.COST, i2.COMMENTS, i2.STOCK,
       i2.DEP_LINK, i2.TYPE_INV, i2.[ATTACH], i2.[GROUP_ACTIVE], i.LINK, Tt.INV_REF
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] co
	--INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co2 ON co2. = co.Ref
	inner join
		(select co.ref, inv_ref = co2.ref, CO2.CODE AS INV_NUM	,NUM = ROW_NUMBER() OVER (PARTITION BY CO.REF ORDER BY CO2.CODE)
			FROM
				[{Variable_TempDb}].dbo.[CatalogObject|] co
				INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] CO2 ON co2. = co.Ref
		) Tt on Tt.NUM > 1 and Tt.ref=co.ref

	INNER JOIN [{Variable_TempDb}].dbo.__INVENTORY__ i ON i.INSERTED_UIDS = co.Ref
	INNER JOIN [{Variable_WorkDb}].dbo.INVENTORY i2 ON i2.LINK = i.LINK
WHERE co. = 'true'


INSERT INTO [{Variable_WorkDb}].dbo.[ASSETS] (LINK_UP, WEAR_OS, OKOF, DATE_FILLING,
            EMP_FILLING, CARD_NO, GRP_CALC, PASSPORT, PLANT_NUM, OTHER_NUM,
            WEAR_FLAG, DATE_PROD, MANUFACT, LOCATION, FIXING, NO_TAX, DATE_BEGIN,
            DOC_NUM, DEPRE_SUM, DEPRE_DATE_CALC, DEPRE_GROUP, PER_USED,
            INV_NO, INV_CODE, ACC_LINK_R, [FREE], IMPORT, DOC_NAME)
SELECT
    [LINK_UP]       = i.LINK,
    WEAR_OS, OKOF, DATE_FILLING,
    EMP_FILLING, CARD_NO, GRP_CALC, PASSPORT, PLANT_NUM, OTHER_NUM,
    WEAR_FLAG, DATE_PROD, MANUFACT, LOCATION, FIXING, NO_TAX, DATE_BEGIN,
    DOC_NUM, DEPRE_SUM, DEPRE_DATE_CALC, DEPRE_GROUP, ISNULL(PER_USED,0), 
    INV_NO, INV_CODE, ACC_LINK_R, [FREE], IMPORT, DOC_NAME
FROM 
	#INS_LINKS i 
	INNER JOIN [{Variable_WorkDb}].dbo.INVENTORY i2 ON i2.LINK = i.LINK2
	INNER JOIN [{Variable_WorkDb}].dbo.ASSETS a ON a.LINK_UP = i2.LINK

DECLARE @iROWCOUNT INT 
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (    )"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_GRP_LIST
	(INV_MAIN, INV_DEPEND)
SELECT LINK2, LINK 
FROM #INS_LINKS

INSERT INTO [{Variable_TempDb}].[dbo].[__INVENTORY__]
	(LINK, LINK_MAIN, REF)
SELECT LINK, LINK2, [REF]
FROM #INS_LINKS

--   -   --
INSERT INTO [{Variable_TempDb}].[dbo].[__INVENTORY__]
	(LINK, LINK_MAIN, REF)
SELECT
	INV_1C.LINK, INV_1C.LINK, INV_NUM.[REF]
FROM [{Variable_TempDb}].dbo.[CatalogObject|] INV_NUM
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] OS ON
	OS.Ref = INV_NUM.

INNER JOIN [{Variable_TempDb}].dbo.__INVENTORY__ INV_1C ON
	INV_1C.INSERTED_UIDS = OS.Ref

LEFT JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] INV_NUM_1C ON 
	INV_NUM_1C.LINK_MAIN = INV_1C.LINK
	AND INV_NUM_1C.REF = INV_NUM.Ref
WHERE INV_NUM_1C.LINK IS NULL

-- ,     " "   
UPDATE A SET A.GRP_CALC = 0 
FROM
	#INS_LINKS R
	INNER JOIN [{Variable_WorkDb}].dbo.[INVENTORY] I ON R.LINK = I.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.[ASSETS] A ON I.LINK = A.LINK_UP
WHERE
	EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.INVENTORY_GRP_LIST G WHERE G.INV_DEPEND = I.LINK)
	AND
	A.GRP_CALC = 1

DROP TABLE #INS_LINKS
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	INSERT INTO #EXEC ([text]) SELECT
	'
	UPDATE A 
	SET DATE_COME = S.
	from 
		{Variable_TempDb}.dbo.[CatalogObject|] co
		INNER JOIN {Variable_TempDb}.dbo.[CatalogObject|] co2 ON co2. = co.Ref
		inner join {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] S on S. = co2.Ref
		INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] I ON I.INSERTED_UIDS = co.ref
		INNER JOIN {Variable_WorkDb}.dbo.INVENTORY_GRP_LIST GL ON GL.INV_MAIN = I.LINK
		inner join {Variable_WorkDb}.dbo.INVENTORY I1 ON I1.CODE = LTRIM(RTRIM(co2.[Code])) AND I1.LINK = GL.INV_DEPEND
		INNER JOIN {Variable_WorkDb}.dbo.ASSETS A ON A.LINK_UP = I.LINK
	where 
		 = ''''
		AND
		ISDATE() = 1	

	UPDATE A 
	SET DATE_BEGIN = S.
	from 
		{Variable_TempDb}.dbo.[CatalogObject|] co
		INNER JOIN {Variable_TempDb}.dbo.[CatalogObject|] co2 ON co2. = co.Ref
		inner join {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] S on S. = co2.Ref
		INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] I ON I.INSERTED_UIDS = co.ref
		INNER JOIN {Variable_WorkDb}.dbo.INVENTORY_GRP_LIST GL ON GL.INV_MAIN = I.LINK
		inner join {Variable_WorkDb}.dbo.INVENTORY I1 ON I1.CODE = LTRIM(RTRIM(co2.[Code])) AND I1.LINK = GL.INV_DEPEND
		INNER JOIN {Variable_WorkDb}.dbo.ASSETS A ON A.LINK_UP = I.LINK
	where 
		 = ''''
		AND
		ISDATE() = 1		

	UPDATE A 
	SET DATE_END = S.
	from 
		{Variable_TempDb}.dbo.[CatalogObject|] co
		INNER JOIN {Variable_TempDb}.dbo.[CatalogObject|] co2 ON co2. = co.Ref
		inner join {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] S on S. = co2.Ref
		INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] I ON I.INSERTED_UIDS = co.ref
		INNER JOIN {Variable_WorkDb}.dbo.INVENTORY_GRP_LIST GL ON GL.INV_MAIN = I.LINK
		inner join {Variable_WorkDb}.dbo.INVENTORY I1 ON I1.CODE = LTRIM(RTRIM(co2.[Code])) AND I1.LINK = GL.INV_DEPEND
		INNER JOIN {Variable_WorkDb}.dbo.ASSETS A ON A.LINK_UP = I.LINK
	where 
		 = ''''
		AND
		ISDATE() = 1		
	'

	DECLARE @err INT
	EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

END

ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] DROP COLUMN [LINK2]
GO


---- !!!       
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH
GO

INSERT INTO [{Variable_WorkDb}].dbo.ASSETS (LINK_UP,CARD_NO) 
select LINK,'' FROM [{Variable_WorkDb}].dbo.INVENTORY I 
WHERE NOT EXISTS (select 1 FROM [{Variable_WorkDb}].dbo.ASSETS WHERE LINK_UP = I.LINK )
GO

--     103          
UPDATE A
SET
	A.[WEAR_FLAG] = 0
FROM [{Variable_WorkDb}].[dbo].[GROUP_ACTIVE] G
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS S ON
	S.[LINK] = G.[ACCOUNT_B]
	AND S.cSINTH = '103'
INNER JOIN [{Variable_WorkDb}].[dbo].[INVENTORY] I ON I.[GROUP_ACTIVE] = G.[LINK]
INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY__] I1 ON I1.LINK = I.LINK
INNER JOIN [{Variable_WorkDb}].[dbo].[ASSETS] A ON
	A.[LINK_UP] = I.[LINK]
	AND A.[WEAR_FLAG] <> 0

COMMIT TRAN

GO

