SET NOCOUNT ON
GO

USE [{Variable_TempDb}]
GO

SET XACT_ABORT ON

BEGIN TRAN

--   --
IF NOT exists(select * from sysobjects where id = object_id('[dbo].[__DICT_VID_IMU_TAX_RATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	EXEC (
	'
	CREATE TABLE [dbo].[__DICT_VID_IMU_TAX_RATE]
		(
		TYPE_TAX_NAME	VARCHAR (1000),
		TYPE_TAX	TINYINT,
		TAX_RATE	NUMERIC (10,2),
		DISCOUNT_CODE	VARCHAR (10),
		INV_TYPE	VARCHAR (5),
		BEGIN_DATE	DATETIME,
		COUNT_REC	INT,
		LINK	INT DEFAULT (0)
		)
	'
	)
ELSE
	EXEC (
	'
	DELETE FROM [dbo].[__DICT_VID_IMU_TAX_RATE]
		'
	)

GO

--       --
IF NOT exists(select * from sysobjects where id = object_id('[dbo].[__DICT_IMU_TAX_RATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	EXEC (
	'
	CREATE TABLE [dbo].[__DICT_IMU_TAX_RATE]
		(
		LINK	INT,
		VID_LINK	INT,
		INV_LINK	INT
		)
	'
	)
ELSE
BEGIN
	EXEC (
	'
	DELETE T1
	FROM [{Variable_WorkDb}].[dbo].[DICT_IMU_TAX_RATE] T1
	WHERE EXISTS
			(
			SELECT 1 FROM [dbo].[__DICT_IMU_TAX_RATE] TTT
			WHERE TTT.LINK = T1.LINK
			)
	'
	)

	EXEC (
	'
	DELETE FROM [dbo].[__DICT_IMU_TAX_RATE]
	'
	)
END

GO

DECLARE
	@SQL_EXEC	VARCHAR (8000),
	@ADD_FIELD1	VARCHAR (100)

--     --
IF OBJECT_ID ('TEMPDB..#TYPE_TAX_1C_SMETA') IS NOT NULL
	EXEC ('DROP TABLE #TYPE_TAX_1C_SMETA')

CREATE TABLE #TYPE_TAX_1C_SMETA
	(
	TYPE_TAX_NAME	VARCHAR (1000),
	TYPE_TAX	TINYINT
	)

INSERT INTO #TYPE_TAX_1C_SMETA
	(
	TYPE_TAX_NAME,
	TYPE_TAX
	)
SELECT TYPE_TAX_NAME = '', TYPE_TAX = 3 UNION ALL
SELECT TYPE_TAX_NAME = '', TYPE_TAX = 2 UNION ALL
SELECT TYPE_TAX_NAME = '', TYPE_TAX = 1

--      --
IF OBJECT_ID ('TEMPDB..#INV_TAX_RATE') IS NOT NULL
	EXEC ('DROP TABLE #INV_TAX_RATE')

CREATE TABLE #INV_TAX_RATE
	(
	ROW_NUM	INT,
	TYPE_TAX_NAME	VARCHAR (1000),
	TYPE_TAX	TINYINT,
	TAX_RATE	NUMERIC (10,2),
	DISCOUNT_CODE	VARCHAR (10),
	INV_TYPE	VARCHAR (5),
	BEGIN_DATE	DATETIME,
	INV_LINK	INT,
	INV_NUM		INT
	)

IF COLUMNPROPERTY(object_id('[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|]'),
			'', 'AllowsNull') IS NOT NULL
	SET @ADD_FIELD1 = 'T1.[]'
ELSE
	SET @ADD_FIELD1 = '03'

SET @SQL_EXEC =
'
INSERT INTO #INV_TAX_RATE
	(
	ROW_NUM,
	TYPE_TAX_NAME,
	TYPE_TAX,
	TAX_RATE,
	DISCOUNT_CODE,
	INV_TYPE,
	BEGIN_DATE,
	INV_LINK,
	INV_NUM
	)
SELECT
	ROW_NUMBER () OVER (PARTITION BY INV.LINK ORDER BY T1.PERIOD DESC),
	T1.[],
	ISNULL (T2.TYPE_TAX, 0),
	CASE
		WHEN CONVERT (NUMERIC (28,2), T1.[]) > 100 THEN 20
		ELSE CONVERT (NUMERIC (10,2), T1.[])
	END,
	T1.[],
'
+
@ADD_FIELD1 + ', '
+	
'
	T1.PERIOD,
	INV.LINK,
	INV_NUM.LINK
FROM [dbo].[InformationRegisterRecordSet|] T1
INNER JOIN [dbo].[__INVENTORY__] INV ON INV.INSERTED_UIDS = T1.

LEFT JOIN [dbo].[__INVENTORY__] INV_NUM ON
	INV_NUM.REF = T1.[]

LEFT JOIN #TYPE_TAX_1C_SMETA T2 ON T2.TYPE_TAX_NAME = T1.[]
'

IF EXISTS
		(
		select 1 from dbo.sysobjects
		where id = object_id('[InformationRegisterRecordSet|]')
			and OBJECTPROPERTY(id, N'IsUserTable') = 1
		)
	EXEC (@SQL_EXEC)

UPDATE T1
SET INV_TYPE = '03'
FROM #INV_TAX_RATE T1
WHERE ISNULL (T1.INV_TYPE, '') = ''

--SELECT '#INV_TAX_RATE', * FROM #INV_TAX_RATE

INSERT INTO [dbo].[__DICT_VID_IMU_TAX_RATE]
	(
	TYPE_TAX_NAME,
	TYPE_TAX,
	TAX_RATE,
	DISCOUNT_CODE,
	INV_TYPE,
	BEGIN_DATE,
	COUNT_REC
	)
SELECT 
	T1.TYPE_TAX_NAME,
	T1.TYPE_TAX,
	T1.TAX_RATE,
	T1.DISCOUNT_CODE,
	T1.INV_TYPE,
	MAX (T1.BEGIN_DATE),
	COUNT (*)
FROM #INV_TAX_RATE T1
GROUP BY 
	T1.TYPE_TAX_NAME,
	T1.TYPE_TAX,
	T1.TAX_RATE,
	T1.DISCOUNT_CODE,
	T1.INV_TYPE

--       --
INSERT INTO {Variable_WorkDb}.dbo.DICT_VID_IMU_TAX_RATE
	(
	[TYPE],
	[DISCOUNT_CODE],
	TAX_RATE_DEF,
	CODE
	)
SELECT
	T1.[TYPE_TAX],
	T1.[DISCOUNT_CODE],
	T1.TAX_RATE,
	T1.INV_TYPE
FROM dbo.__DICT_VID_IMU_TAX_RATE T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.dbo.DICT_VID_IMU_TAX_RATE TTT
	WHERE TTT.[TYPE] = T1.[TYPE_TAX]
		AND ISNULL (TTT.[DISCOUNT_CODE], '') = ISNULL (T1.[DISCOUNT_CODE], '')
		AND ISNULL (TTT.TAX_RATE_DEF, 0 ) = ISNULL (T1.TAX_RATE, 0 )
		AND ISNULL (TTT.CODE, '') = ISNULL (T1.INV_TYPE, '') 
	)

UPDATE T1
SET LINK = T2.LINK
FROM dbo.__DICT_VID_IMU_TAX_RATE T1
INNER JOIN {Variable_WorkDb}.dbo.DICT_VID_IMU_TAX_RATE T2 ON
	T1.[TYPE_TAX] = T2.[TYPE]
	AND ISNULL (T2.[DISCOUNT_CODE], '') = ISNULL (T1.[DISCOUNT_CODE], '')
	AND ISNULL (T2.TAX_RATE_DEF, 0 ) = ISNULL (T1.TAX_RATE, 0 )
	AND ISNULL (T2.CODE, '') = ISNULL (T1.INV_TYPE, '') 

--      ({Variable_WorkDb}..DICT_IMU_TAX_RATE) --
INSERT INTO {Variable_WorkDb}.dbo.DICT_IMU_TAX_RATE
	(
	VID_LINK,
	INV_LINK
	)
OUTPUT INSERTED.LINK, INSERTED.VID_LINK, INSERTED.INV_LINK
	INTO [dbo].[__DICT_IMU_TAX_RATE] (LINK, VID_LINK, INV_LINK)

SELECT
	T2.LINK,
	T1.INV 
FROM 
	(
	SELECT
		ROW_NUM,
		TYPE_TAX,
		INV_TYPE,
		TAX_RATE,
		DISCOUNT_CODE,
		INV = INV_NUM
	FROM #INV_TAX_RATE 

	UNION 

	SELECT
		ROW_NUM,
		TYPE_TAX,
		INV_TYPE,
		TAX_RATE,
		DISCOUNT_CODE,
		INV = INV_LINK
	FROM #INV_TAX_RATE 
	) AS T1
INNER JOIN dbo.__DICT_VID_IMU_TAX_RATE T2 ON
	T1.ROW_NUM = 1
	AND T1.INV IS NOT NULL
	AND T2.TYPE_TAX = T1.TYPE_TAX
	AND ISNULL (T2.TAX_RATE, 0) = ISNULL (T1.TAX_RATE, 0)
	AND ISNULL (T2.DISCOUNT_CODE, '') = ISNULL (T1.DISCOUNT_CODE, '')
	AND T2.INV_TYPE = T1.INV_TYPE
LEFT JOIN [{Variable_WorkDb}].dbo.DICT_IMU_TAX_RATE TTT ON TTT.INV_LINK = T1.INV
WHERE TTT.LINK IS NULL

IF OBJECT_ID ('TEMPDB..#INV_TAX_RATE') IS NOT NULL
	EXEC ('DROP TABLE #INV_TAX_RATE')

COMMIT TRAN

GO

--select top 1 LINK from {Variable_WorkDb}.dbo.DEPARTMENTS where NAME = ''
