SET XACT_ABORT ON
BEGIN TRAN


---        
--- AP1
DECLARE @T_ACC TABLE
	(
	ACC_CODE	VARCHAR (20)
	)

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND ISNULL(ar.AP1_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	OR
	ch.Ref = ar.AccountCr
		AND ISNULL(ar.AP1_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.ap_AP1 = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_AP1 = 0

--- KBK
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND ISNULL(ar.Dr,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	OR
	ch.Ref = ar.AccountCr
		AND ISNULL(ar.Cr,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.ap_KBK = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_KBK = 0

--- DEP
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND ISNULL(ar.DEP_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	OR
	ch.Ref = ar.AccountCr
		AND ISNULL(ar.DEP_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.ap_DEP = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_DEP = 0

--- EMP
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND ISNULL(ar.EMP_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	OR
	ch.Ref = ar.AccountCr
		AND  ISNULL(ar.EMP_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.ap_EMP = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_EMP = 0

--- NOMEN, BSO, ND
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND
			(
			ISNULL(ar.NOMEN_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
			OR
			ISNULL(ar.ND_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
			OR
			ISNULL(ar.BSO_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
			)
	OR
	ch.Ref = ar.AccountCr
		AND
			(
			ISNULL(ar.NOMEN_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
			OR
			ISNULL(ar.ND_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
			OR
			ISNULL(ar.BSO_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
			)
GROUP BY ar.,ch.Code

UPDATE sa
SET 
sa.NOMEN_TYPE = 3,
sa.ap_NOMEN = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_NOMEN = 0

--- INV
--         ,       ,    
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND ISNULL(ar.INV_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	OR
	ch.Ref = ar.AccountCr
		AND ISNULL(ar.INV_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.ap_TMC = 0
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_INV = 0 AND sa.ap_TMC = 1

--  
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
  FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
		AND ISNULL(ar.INV_DR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
	OR
	ch.Ref = ar.AccountCr
		AND ISNULL(ar.INV_CR,'00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.ap_INV = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
	AND sa.ap_INV = 0

--- EKR
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
FROM 
	[{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
	INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountDr
WHERE 
	(CASE WHEN ch.OffBalance = 'true' THEN ISNULL(ar.EKR_DR, ISNULL(ar.SGU_DR,'00000000-0000-0000-0000-000000000000')) 
										ELSE ISNULL(ar.EKR_DR,'00000000-0000-0000-0000-000000000000') 
				END) <> '00000000-0000-0000-0000-000000000000'

UNION

SELECT ACC_CODE = (ar. + '.' + ch.CODE)
FROM 
	[{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
	INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON ch.Ref = ar.AccountCr
WHERE 
	(CASE WHEN ch.OffBalance = 'true' 
							THEN ISNULL(ar.EKR_CR, ISNULL(ar.SGU_CR,'00000000-0000-0000-0000-000000000000')) 
							ELSE ISNULL(ar.EKR_CR,'00000000-0000-0000-0000-000000000000') 
				END) <> '00000000-0000-0000-0000-000000000000'

UPDATE sa
SET sa.ap_EKR = 1
FROM @T_ACC ss
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
		sa.CODE = ss.ACC_CODE AND sa.LINK_DEP = {LINK_DEP}
		AND sa.ap_EKR = 0

--- AP2
DELETE FROM @T_ACC

INSERT INTO @T_ACC 
	(
	ACC_CODE
	)
SELECT ACC_CODE = (ar. + '.' + ch.CODE)
FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] ar
INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] ch ON
	ch.Ref = ar.AccountDr
	AND
		(
		ISNULL(ar.AP2_Dr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
		OR ISNULL(ar.ND_Dr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
		)
	OR		
	ch.Ref = ar.AccountCr
	AND
		(
		ISNULL(ar.AP2_Cr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
		OR ISNULL(ar.ND_Cr, '00000000-0000-0000-0000-000000000000') <> '00000000-0000-0000-0000-000000000000'
		)
GROUP BY ar.,ch.Code

UPDATE sa
SET sa.AP_AP2 = 1
FROM @T_ACC ss
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa ON
	SA.AP_AP2 = 0
	AND sa.CODE = ss.ACC_CODE
	AND sa.LINK_DEP = {LINK_DEP}

GO

        
COMMIT TRAN

