
set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO


/***************************************************************/
---
IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC ([text] varchar(8000), id int identity(1,1))
GO

INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS ([LINK_UP], [NUMBER], [NAME], [DATE], [DATE_PROV], [SUMMA], [COMMENT], [HOZ_OPER])
SELECT 
		T.LINK,
		R.[],
		R.[],
		CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END AS ,
		CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END AS ,
		0,
		'''',
		XO.LINK 
FROM 
	{Variable_TempDb}.[dbo].[__DEPARTMENTS_] A
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = A.LINK
	INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] R ON R. = A.Ref
	INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] T ON T.INSERTED_UIDS = R.
	INNER JOIN {Variable_WorkDb}.dbo.INVENTORY OS ON OS.LINK = T.LINK'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
	LEFT JOIN {Variable_TempDb}.dbo.[DocumentObject|_] R1 ON R1.Ref = R.Recorder'

INSERT INTO #EXEC ([text]) SELECT '
	INNER JOIN
		(SELECT XO.LINK_DEP, XO.LINK, [FULLCODE] = XOG.CODE +''.'' + XO.CODE 
		FROM
			{Variable_WorkDb}.dbo.XOZ_OPER XO 
			INNER JOIN {Variable_WorkDb}.dbo.XOZ_OPER_GROUP XOG ON XO.GROUP_LINK = XOG.LINK
		) XO ON LINK_DEP = VD.LINK_CB'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
AND XO.FULLCODE = (CASE WHEN R1.REF IS NOT NULL THEN ''17.02'' ELSE ''17.06'' END)'
ELSE
INSERT INTO #EXEC ([text]) SELECT '
AND XO.FULLCODE = ''17.06'''

INSERT INTO #EXEC ([text]) SELECT '
WHERE
	R.Active = 1
	AND
	R. = ''''
	AND
	CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END <= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1
ORDER BY
	R., R.[]
'

--select [text] from #EXEC order by id
DECLARE @err INT
EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'
GO

/***************************************************************/
--

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [INSERTED_LINK] INT NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(2000) NULL
GO

IF OBJECT_ID('TEMPDB..#INVENTORY_HIS','U') IS NOT NULL
	DROP TABLE #INVENTORY_HIS

CREATE TABLE #INVENTORY_HIS (LINK INT, INSERTED_LINK INT,  VARCHAR(2000))
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC ([text] varchar(8000), id int identity(1,1))
GO

INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS ([LINK_UP], [NUMBER], [NAME], [DATE], [DATE_PROV], [SUMMA], [COMMENT], [HOZ_OPER], INSERTED_LINK, [])
OUTPUT INSERTED.LINK, INSERTED.INSERTED_LINK, INSERTED. INTO #INVENTORY_HIS (LINK, INSERTED_LINK, )
SELECT 
		T.LINK,
		R.[],
		R.[],
		CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END AS ,
		CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END AS ,
		0,
'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
		LTRIM(RTRIM(ISNULL(R1.[],''''))) + '' '' + LTRIM(RTRIM(ISNULL('' '' + R1.,''''))) + '' '' + LTRIM(RTRIM(ISNULL('' '' + CONVERT(VARCHAR(10),R1.,104),''''))),'
ELSE
INSERT INTO #EXEC ([text]) SELECT '
		'''','

INSERT INTO #EXEC ([text]) SELECT '
		XO.LINK,
		R.LINK,
'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
		R1.'
ELSE
INSERT INTO #EXEC ([text]) SELECT '
		'''' AS '

INSERT INTO #EXEC ([text]) SELECT ' 
FROM 
	{Variable_TempDb}.[dbo].[__DEPARTMENTS_] A
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = A.LINK
	INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] R ON R. = A.Ref
	INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] T ON T.INSERTED_UIDS = R.
	INNER JOIN {Variable_WorkDb}.dbo.INVENTORY OS ON OS.LINK = T.LINK
	INNER JOIN
		(SELECT XO.LINK_DEP, XO.LINK, [FULLCODE] = XOG.CODE +''.'' + XO.CODE 
		FROM
			{Variable_WorkDb}.dbo.XOZ_OPER XO 
			INNER JOIN {Variable_WorkDb}.dbo.XOZ_OPER_GROUP XOG ON XO.GROUP_LINK = XOG.LINK
		) XO ON LINK_DEP = VD.LINK_CB AND XO.FULLCODE = ''17.11'''

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
	LEFT JOIN {Variable_TempDb}.dbo.[DocumentObject|_] R1 ON R1.Ref = R.Recorder'

INSERT INTO #EXEC ([text]) SELECT '
WHERE
	R.Active = 1
	AND
	R. = ''''
	AND
	CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END <= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1
ORDER BY
	R., R.[]
'
INSERT INTO #EXEC ([text]) SELECT '

INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '''', LEFT(LTRIM(RTRIM(ISNULL(,''''))),2000)
FROM #INVENTORY_HIS A
WHERE LEN([]) > 0 AND NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.INVENTORY_HIS_DETAILS T WHERE T.LINK_UP = A.LINK)
'

--select [text] from #EXEC order by id
DECLARE @err INT
EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO



/***************************************************************/
---

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [INSERTED_LINK] INT NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Description' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [Description]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [Description] varchar(2000) NULL
GO

IF OBJECT_ID('TEMPDB..#INVENTORY_HIS','U') IS NOT NULL
	DROP TABLE #INVENTORY_HIS

CREATE TABLE #INVENTORY_HIS (LINK INT, INSERTED_LINK INT, [Description] VARCHAR(2000))
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC ([text] varchar(8000), id int identity(1,1))
GO

INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS ([LINK_UP], [NUMBER], [NAME], [DATE], [DATE_PROV], [SUMMA], [COMMENT], [HOZ_OPER], INSERTED_LINK, [Description])
OUTPUT INSERTED.LINK, INSERTED.INSERTED_LINK, INSERTED.[Description] INTO #INVENTORY_HIS (LINK, INSERTED_LINK, [Description])
SELECT 
		T.LINK,
		R.[],
		R.[],
		CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END AS ,
		CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END AS ,
		0,
'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
		LTRIM(RTRIM(ISNULL(R1.[],''''))),'
ELSE
INSERT INTO #EXEC ([text]) SELECT '
		'''','

INSERT INTO #EXEC ([text]) SELECT '
		XO.LINK,
		R.LINK,
'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
		R1.[Description]'
ELSE
INSERT INTO #EXEC ([text]) SELECT '
		'''' AS [Description]'

INSERT INTO #EXEC ([text]) SELECT ' 
FROM 
	{Variable_TempDb}.[dbo].[__DEPARTMENTS_] A
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = A.LINK
	INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] R ON R. = A.Ref
	INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] T ON T.INSERTED_UIDS = R.
	INNER JOIN {Variable_WorkDb}.dbo.INVENTORY OS ON OS.LINK = T.LINK
	INNER JOIN
		(SELECT XO.LINK_DEP, XO.LINK, [FULLCODE] = XOG.CODE +''.'' + XO.CODE 
		FROM
			{Variable_WorkDb}.dbo.XOZ_OPER XO 
			INNER JOIN {Variable_WorkDb}.dbo.XOZ_OPER_GROUP XOG ON XO.GROUP_LINK = XOG.LINK
		) XO ON LINK_DEP = VD.LINK_CB AND XO.FULLCODE = ''17.07'''

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
	LEFT JOIN {Variable_TempDb}.dbo.[DocumentObject|_] R1 ON R1.Ref = R.Recorder'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
INSERT INTO #EXEC ([text]) SELECT '
	LEFT JOIN {Variable_TempDb}.dbo.[DocumentObject|CatalogObject|] R2 ON R1.Ref = R.Recorder'

INSERT INTO #EXEC ([text]) SELECT '
WHERE
	R.Active = 1
	AND
	R. = ''''
	AND
	CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END <= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1
ORDER BY
	R., R.[]
'
INSERT INTO #EXEC ([text]) SELECT '
INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '''', LEFT(LTRIM(RTRIM(ISNULL([Description],''''))),2000)
FROM #INVENTORY_HIS A
WHERE LEN([Description]) > 0 AND NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.INVENTORY_HIS_DETAILS T WHERE T.LINK_UP = A.LINK)
'

--select [text] from #EXEC order by id
DECLARE @err INT
EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Description' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [Description]
GO


/***************************************************************/
----- 

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [INSERTED_LINK] INT NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO


IF OBJECT_ID('TEMPDB..#INVENTORY_HIS','U') IS NOT NULL
	DROP TABLE #INVENTORY_HIS

CREATE TABLE #INVENTORY_HIS (LINK INT, INSERTED_LINK INT, [] VARCHAR(20), [] VARCHAR(20), [] VARCHAR(20), [] VARCHAR(20), [] VARCHAR(20))
GO

-- InformationRegisterRecordSet|
IF exists(select 1 from dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] UNIQUEIDENTIFIER NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), 'Recorder', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [Recorder] UNIQUEIDENTIFIER NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] UNIQUEIDENTIFIER NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), 'Active', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [Active] INT NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] NUMERIC (20,4) NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] DATETIME NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] NUMERIC (20,4) NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] NUMERIC (20,4) NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] NUMERIC (20,4) NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] VARCHAR (20) NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] NUMERIC (20,4) NULL')

	--  InformationRegisterRecordSet|
	IF COLUMNPROPERTY(object_id('[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
	   EXEC ('ALTER TABLE [dbo].[InformationRegisterRecordSet|] ADD [] NUMERIC (20,4) NULL')
END

GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)

	INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS ([LINK_UP], [NUMBER], [NAME], [DATE], [DATE_PROV], [SUMMA], [COMMENT], [HOZ_OPER], INSERTED_LINK, [], [], [], [], [])
	OUTPUT INSERTED.LINK, INSERTED.INSERTED_LINK, INSERTED.[], INSERTED.[], INSERTED.[], INSERTED.[], INSERTED.[] 
		INTO #INVENTORY_HIS (LINK, INSERTED_LINK, [], [], [], [], [])
	SELECT 
			[LINK_UP] = T.LINK,
			[NUMBER] = R1.[Number],
			[NAME] = R1.[],
			[DATE] = CASE WHEN isdate(R1.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R1.[Date])), 0) ELSE NULL END,
			[DATE_PROV] = CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END,
			[SUMMA] = R.[],
			[COMMENT] = R1.[],
			[HOZ_OPER] = XO.LINK,
			[INSERTED_LINK] = R.LINK,
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[])
	FROM
		{Variable_TempDb}.[dbo].[__DEPARTMENTS_] A
		INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = A.LINK
		INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] R ON R. = A.Ref
			INNER JOIN {Variable_TempDb}.dbo.[DocumentObject|] R1 ON R1.Ref = R.Recorder
		INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] T ON T.INSERTED_UIDS = R.
		INNER JOIN {Variable_WorkDb}.dbo.INVENTORY OS ON OS.LINK = T.LINK
		INNER JOIN
			(SELECT XO.LINK_DEP, XO.LINK, [FULLCODE] = XOG.CODE +'.' + XO.CODE 
			FROM
				{Variable_WorkDb}.dbo.XOZ_OPER XO 
				INNER JOIN {Variable_WorkDb}.dbo.XOZ_OPER_GROUP XOG ON XO.GROUP_LINK = XOG.LINK
			) XO ON LINK_DEP = VD.LINK_CB AND XO.FULLCODE = '17.15'
	WHERE
		R.Active = 1
		AND
		CONVERT(NUMERIC(18,10),R.[]) > 1
		AND
		CASE WHEN isdate(R1.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R1.[Date])), 0) ELSE NULL END <= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1
	ORDER BY
		R., R1.[Date]
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO


/***************************************************************/
-- 

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [INSERTED_LINK] INT NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS ADD [] varchar(20) NULL
GO


IF OBJECT_ID('TEMPDB..#INVENTORY_HIS','U') IS NOT NULL
	DROP TABLE #INVENTORY_HIS

CREATE TABLE #INVENTORY_HIS (LINK INT, INSERTED_LINK INT, [] VARCHAR(20), [] VARCHAR(20), [] VARCHAR(20), [] VARCHAR(20), [] VARCHAR(20))
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)

	INSERT INTO {Variable_WorkDb}.dbo.INVENTORY_HIS ([LINK_UP], [NUMBER], [NAME], [DATE], [DATE_PROV], [SUMMA], [COMMENT], [HOZ_OPER], INSERTED_LINK, [], [], [], [], [])
	OUTPUT INSERTED.LINK, INSERTED.INSERTED_LINK, INSERTED.[], INSERTED.[], INSERTED.[], INSERTED.[], INSERTED.[] 
		INTO #INVENTORY_HIS (LINK, INSERTED_LINK, [], [], [], [], [])
	SELECT 
			[LINK_UP] = T.LINK,
			[NUMBER] = R1.[Number],
			[NAME] = R1.[],
			[DATE] = CASE WHEN isdate(R1.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R1.[Date])), 0) ELSE NULL END,
			[DATE_PROV] = CASE WHEN isdate(R.[]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R.[])), 0) ELSE NULL END,
			[SUMMA] = R.[],
			[COMMENT] = R1.[],
			[HOZ_OPER] = XO.LINK,
			[INSERTED_LINK] = R.LINK,
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[]), 
			[] = CONVERT(VARCHAR(20),R.[])
	FROM
		{Variable_TempDb}.[dbo].[__DEPARTMENTS_] A
		INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = A.LINK
		INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] R ON R. = A.Ref
			INNER JOIN {Variable_TempDb}.dbo.[DocumentObject|] R1 ON R1.Ref = R.Recorder
		INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY__] T ON T.INSERTED_UIDS = R.
		INNER JOIN {Variable_WorkDb}.dbo.INVENTORY OS ON OS.LINK = T.LINK
		INNER JOIN
			(SELECT XO.LINK_DEP, XO.LINK, [FULLCODE] = XOG.CODE +'.' + XO.CODE 
			FROM
				{Variable_WorkDb}.dbo.XOZ_OPER XO 
				INNER JOIN {Variable_WorkDb}.dbo.XOZ_OPER_GROUP XOG ON XO.GROUP_LINK = XOG.LINK
			) XO ON LINK_DEP = VD.LINK_CB AND XO.FULLCODE = '17.17'
	WHERE
		R.Active = 1
		AND
		CONVERT(NUMERIC(18,10),R.[]) > 1
		AND
		CASE WHEN isdate(R1.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,R1.[Date])), 0) ELSE NULL END <= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1
	ORDER BY
		R., R1.[Date]
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS_DETAILS (LINK_UP, NAME, VALUE)
SELECT LINK, '', LEFT([],20) FROM #INVENTORY_HIS A WHERE LEN([]) > 0
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN [INSERTED_LINK]
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].INVENTORY_HIS'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].INVENTORY_HIS DROP COLUMN []
GO

--    --
DECLARE
	@TAB_ID	INT,
	@SQL_EXEC VARCHAR (8000)

SELECT TOP 1
	@TAB_ID = [OBJECT_ID]
FROM [{Variable_TempDb}].[SYS].[TABLES]
WHERE [NAME] = 'InformationRegisterRecordSet|'

IF @TAB_ID IS NOT NULL
BEGIN
	SET @SQL_EXEC =
'
INSERT INTO [{Variable_WorkDb}].dbo.INVENTORY_HIS
	(
	LINK_UP, NUMBER, [DATE], [NAME], SUMMA, COMMENT
	)
SELECT
	INV = ISNULL (INV2_1C.LINK, INV1_1C.LINK),
	T1.[],
	T1.[], 
	DOC_NAME = T1.[],
	SUMMA = ISNULL (T1.[] , 0),
	EVENT_NAME = ''''
FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] T1 
INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] INV1 ON INV1.REF =  T1.[]
INNER JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] INV1_1C ON INV1_1C.INSERTED_UIDS = INV1.REF

LEFT JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] INV2 ON INV2.REF = T1.[]
LEFT JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] INV2_1C ON INV2_1C.REF = T1.[]
WHERE T1.[] <> ''''
'

	EXEC (@SQL_EXEC)
END

GO

COMMIT TRAN
GO
