SET XACT_ABORT ON

BEGIN TRAN

USE {Variable_TempDb}
GO


IF not exists(select * from sysobjects where id = object_id('[dbo].[__DOP_CLASSIF_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DOP_CLASSIF_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DOP_CLASSIF_]

GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DOP_CLASSIF'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[DOP_CLASSIF] DROP COLUMN [Ref]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[DOP_CLASSIF] ADD [Ref] UNIQUEIDENTIFIER NULL
GO


IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

DECLARE @err INT

IF exists(
	select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1
	)
BEGIN

	DELETE FROM #EXEC

	INSERT INTO #EXEC ([text]) SELECT
	'--  
	INSERT INTO [{Variable_TempDb}].dbo.[__DOP_CLASSIF_] (LINK,[Ref]) 
	SELECT 
		P.LINK,
		[Ref]   = convert(uniqueidentifier,co.Ref)
	FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] co
	INNER JOIN (
		SELECT LINK, [SNAME], NUM = ROW_NUMBER() OVER (PARTITION BY [SNAME] ORDER BY [LINK])
		FROM [{Variable_WorkDb}].dbo.DOP_CLASSIF P 
		WHERE LINK_DEP = {LINK_DEP} AND LEN(SNAME) > 0
	) P ON P.NUM = 1 AND P.[SNAME] = LEFT(co.[Description],254)
	'
	
	INSERT INTO #EXEC ([text]) SELECT

	'----   
	INSERT INTO [{Variable_WorkDb}].dbo.DOP_CLASSIF
	(CODE, SNAME, [NAME], DATEB, DATEE, LINK_DEP, [GUID], [ACTION], Ref)
			 OUTPUT INSERTED.LINK, INSERTED.[Ref]
			 INTO [{Variable_TempDb}].dbo.[__DOP_CLASSIF_]
	SELECT
	CODE    = LEFT(co.[Description],20),
	SNAME   = LEFT(co.[Description],254),
	[NAME]  = LEFT(co.[Description],2000),
	DATEB   = NULL,
	DATEE   = NULL,
	LINK_DEP= {LINK_DEP},
	[GUID]  = NULL,
	[ACTION]= NULL,
	Ref     = co.Ref
	FROM [{Variable_TempDb}].dbo.[CatalogObject|] co
	WHERE 
		NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DOP_CLASSIF_] T WHERE T.Ref =co.Ref )

	--    
	DECLARE @iROWCOUNT INT
	SET @iROWCOUNT = @@ROWCOUNT

	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES ('' " "'', '' : '' + convert(nvarchar(100),@iROWCOUNT), '''',0)
	'
	IF EXISTS (SELECT * FROM #EXEC)
		EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'
END

ALTER TABLE [{Variable_WorkDb}].[dbo].[DOP_CLASSIF] DROP COLUMN [Ref]
GO
    
COMMIT TRAN