-- 
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__G_PROV_]
GO

update  [{Variable_TempDb}].dbo.[CatalogObject|]
set  = '1900-01-01T00:00:00' 
where   = '0001-01-01T00:00:00'

----   
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_DOGOVOR]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_DOGOVOR]
---
----    INSERTED_UIDS,     1,         
USE {Variable_WorkDb}
GO

IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[G_PROV]','U'), 'INSERTED_UIDS', 'AllowsNull') is not NULL
	ALTER TABLE {Variable_WorkDb}.[dbo].[G_PROV] DROP COLUMN [INSERTED_UIDS]
GO
IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[G_PROV]'), 'INSERTED_UIDS', 'AllowsNull') is NULL
   ALTER TABLE {Variable_WorkDb}.[dbo].[G_PROV] ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

DECLARE @err INT

INSERT INTO #EXEC ([text]) SELECT
'
DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id(''FINANS_CONTRACT'')

---
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
            DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, INSERTED_UIDS)
 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
 INTO [{Variable_TempDb}].dbo.[__G_PROV_]
 
SELECT 
NUMBER          = RIGHT(LTRIM(RTRIM(ISNULL(co.,''''))),30)
,DATE           = case when isdate(co.) = 1 then convert(datetime,co.) ELSE DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1 END
,[OBJECT]       = @iOBJECT
,DATE_PROV      = NULL'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
AND exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
AND COLUMNPROPERTY(object_id('[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NOT NULL
	INSERT INTO #EXEC ([text]) SELECT
	',SUMMA          = SUM(convert(numeric(28,4),ISNULL(ir.,0)))'
ELSE
	INSERT INTO #EXEC ([text]) SELECT
	',SUMMA          = 0'

INSERT INTO #EXEC ([text]) SELECT
'
,COMMENT        = LEFT(LTRIM(RTRIM(ISNULL(CO.,''''))),254)
,GET_STORE      = 0
,DEP            = du.LINK
,ACC            = d.MAIN_LINK
,[GUID]         = NULL
,INSERTED_UIDS  = co.Ref
FROM [{Variable_TempDb}].dbo.[CatalogObject|] co
INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
'

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
AND exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #EXEC ([text]) SELECT 
'
LEFT JOIN [{Variable_TempDb}].dbo.[DocumentObject|] do ON do. = co.Ref
LEFT JOIN [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] ir ON ir.Recorder = do.Ref
'

INSERT INTO #EXEC ([text]) SELECT 
'
GROUP BY co., co., CO., CO.[Description], co.Ref, du.LINK, d.MAIN_LINK
'

INSERT INTO #EXEC ([text]) SELECT 
'
UPDATE G
SET NUMBER = ''#'' + CONVERT (VARCHAR (20), G.LINK)
FROM [{Variable_WorkDb}].dbo.G_PROV G
INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] T1 ON T1.LINK = G.LINK
WHERE ISNULL (G.NUMBER, '''') = ''''
'

IF EXISTS (SELECT * FROM #EXEC)
	EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

IF @err <> 0
BEGIN
	IF @@TRANCOUNT > 0	
	ROLLBACK
END

---


IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

DECLARE @err INT
INSERT INTO #EXEC ([text]) SELECT 
'
INSERT INTO [{Variable_WorkDb}].dbo.FINANSE_CONTRACT_HEAD WITH (ROWLOCK) (LINK_UP, CON_PAY,
            DATE_BEGIN, DATE_END, DATE_ACCEPT, DATE_NA, SUMMA_F,
            DOG_LINK, NUMBER_BO, BO_NUMS, FIN_SOURCE, [TYPE], GZ, GZ_LINK, GZ_NUM, GZ_DATE)
SELECT 
	LINK_UP         = gp.LINK
	,CON_PAY        = 0
	,DATE_BEGIN     = case when isdate(co.) = 1 then convert(datetime,co.) ELSE DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)-1 END
	,DATE_END       = case when isdate(co.) = 1 then convert(datetime,co.) ELSE null END
	,DATE_ACCEPT    = NULL
	,DATE_NA        = NULL
	,SUMMA_F        = 0
	,DOG_LINK       = NULL
'
-----------------     
IF EXISTS (select * from [{Variable_TempDb}].sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_TempDb}].[dbo].[CatalogObject|]'))
INSERT INTO #EXEC ([text]) SELECT 
'	,NUMBER_BO      = RIGHT(LTRIM(RTRIM(ISNULL(co.,''''))),19)
	,BO_NUMS      = RIGHT(LTRIM(RTRIM(ISNULL(co.,''''))),19)
'
ELSE
INSERT INTO #EXEC ([text]) SELECT 
'	,NUMBER_BO      = '''' 
	,BO_NUMS      = '''' 
'
----------------
INSERT INTO #EXEC ([text]) SELECT 
'
	,FIN_SOURCE     = NULL
	,[TYPE]         = NULL
	,GZ             = 0
	,GZ_LINK        = NULL
	,GZ_NUM         = ''''
	,GZ_DATE        = NULL
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] co
	INNER JOIN [{Variable_TempDb}].dbo.__G_PROV_ gp ON gp.Ref = co.Ref
'
IF EXISTS (SELECT * FROM #EXEC)
	EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

IF @err <> 0
BEGIN
	IF @@TRANCOUNT > 0	
	ROLLBACK
END
GO

-----------------------------------------------
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR (LINK_UP,SUPPLIER_LINK,BUYER_LINK)
SELECT
	LINK_UP         = gp.LINK,
	SUPPLIER_LINK   = d.LINK,
	BUYER_LINK      = NULL
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] co
	INNER JOIN [{Variable_TempDb}].dbo.__G_PROV_ gp ON gp.Ref = co.Ref
	LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d ON d.ref = co.

---
DECLARE @iROWCOUNT INT
set @iROWCOUNT = @@ROWCOUNT


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
---
DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	IF @@TRANCOUNT > 0
	ROLLBACK
END
---

USE {Variable_WorkDb}
GO
IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[G_PROV]','U'), 'INSERTED_UIDS', 'AllowsNull') is not NULL
	ALTER TABLE {Variable_WorkDb}.[dbo].[G_PROV] DROP COLUMN [INSERTED_UIDS]
GO
USE {Variable_TempDb}
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

DECLARE @err INT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND COLUMNPROPERTY(object_id('[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|]'), '', 'AllowsNull') is NOT NULL

INSERT INTO #EXEC ([text]) SELECT
'
---   
INSERT INTO [{Variable_WorkDb}].dbo.FINANSE_CONTRACT
([LINK_UP],[RECORD_NO],[RECORD_CH_NO],[VKR],[EKR],[P1],[P2],[P3],[P4],[P5],[P6],[P7],[P8],[P9],[P10],[P11],[P12],
[DOP_CLASSIF],[OKDP],[QUANTITY],[COST],[SUMMA],[SOURCE],[KAU_LINK],[KL_REG_LINK],[NOMEN],[STAVKA_NDS], [NO_NDS], [SUMMA_NDS], [SUMMA_ALL])
SELECT
	[LINK_UP]       = g.LINK,
	[RECORD_NO]     = '''',
	[RECORD_CH_NO]  = NULL,
	[VKR]           = kbk.LINK,
	[EKR]           = k.LINK,
	[P1]            = 0,
	[P2]            = 0,
	[P3]            = 0,
	[P4]            = 0,
	[P5]            = 0,
	[P6]            = 0,
	[P7]            = 0,
	[P8]            = 0,
	[P9]            = 0,
	[P10]           = 0,
	[P11]           = 0,
	[P12]           = 0,
	[DOP_CLASSIF]   = dcl.LINK,
	[OKDP]          = NULL,
	[QUANTITY]      = CONVERT(NUMERIC(19,4),p.),
	[COST]          = CASE WHEN CONVERT(NUMERIC(19,4),p.) = 0 THEN 0 ELSE CONVERT(NUMERIC(19,4),p.) / CONVERT(NUMERIC(19,4),p.) END,
	[SUMMA]         = CONVERT(NUMERIC(19,2),p.),
	[SOURCE]        = fs.LINK,
	[KAU_LINK]      = NULL,
	[KL_REG_LINK]   = NULL,
	[NOMEN]         = n.LINK,
	[STAVKA_NDS]=0, 
	[NO_NDS]=0, 
	[SUMMA_NDS]=0, 
	[SUMMA_ALL]=0	
FROM [{Variable_TempDb}].dbo.[__G_PROV_] g
INNER JOIN [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] p ON p. = g.Ref
INNER JOIN [{Variable_WorkDb}].dbo.FIN_SOURCE fs ON fs.CODE = p. AND fs.LINK_DEP = [{Variable_WorkDb}].dbo.getowndeplink()
LEFT JOIN [{Variable_TempDb}].dbo.__KL_KBK_ kbk ON kbk.Ref = p.
LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON co.Ref = p.
LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU k ON RIGHT(co.Code,3) = k.CODE
LEFT JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_] dcl ON dcl.Ref = p.
LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_ n ON n.Ref = CASE WHEN p. = '''' THEN NULL ELSE p. END
WHERE p.Active = 1
'
IF EXISTS (SELECT * FROM #EXEC)
	EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

IF @@TRANCOUNT > 0
	COMMIT TRAN

