set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__EMPL_POST_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__EMPL_POST_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__EMPL_POST_]

GO

---    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].POST'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].POST DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].POST ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	--   
	INSERT INTO [{Variable_TempDb}].dbo.__EMPL_POST_ (LINK,[Ref]) 
	SELECT 
		P.LINK,
		[Ref]   = convert(uniqueidentifier,d.Ref)
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] d
		INNER JOIN (
			SELECT LINK, [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY [NAME])
			FROM [{Variable_WorkDb}].[dbo].POST P 
			WHERE LINK_DEP = {LINK_DEP} 
		) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.[Description],254)
	END	
GO

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	--    
	INSERT INTO [{Variable_WorkDb}].[dbo].POST
	(CODE, [NAME], LINK_DEP, [INSERTED_UIDS])
		OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
		INTO [{Variable_TempDb}].dbo.__EMPL_POST_
	SELECT 
		CODE        = RIGHT(d.Code,6), 
		[NAME]      = LEFT(d.[Description],254), 
		LINK_DEP    = {LINK_DEP}, 
		[INSERTED_UIDS]   = convert(uniqueidentifier,d.Ref)
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] d
	WHERE
		NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.__EMPL_POST_ T WHERE T.[Ref] = d.Ref )

	--    
	DECLARE @iROWCOUNT INT
	SET @iROWCOUNT = @@ROWCOUNT
	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

END	
GO

--

ALTER TABLE [{Variable_WorkDb}].[dbo].POST DROP COLUMN [INSERTED_UIDS]
GO

COMMIT TRAN
