
SET XACT_ABORT ON

USE {Variable_TempDb}
GO

---    ( RecordRef  AccountingRegisterRecordSet)
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DOC_TYPES_RecordRef]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DOC_TYPES_RecordRef] (
	[LINK] INT ,
	[RecordRef] VARCHAR(MAX) )
ELSE 
	DELETE FROM [dbo].[__DOC_TYPES_RecordRef]
GO
BEGIN TRAN
		DECLARE @cTITLE VARCHAR(MAX), @iOBJECT INT
        SET @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DICTIONARY_DOC_TYPES')

		DECLARE CURS CURSOR SCROLL FOR SELECT DISTINCT RecordRef FROM [{Variable_TempDb}].dbo.[AccountingRegisterRecordSet|] 
		OPEN CURS
		FETCH FIRST FROM CURS INTO @cTITLE
		WHILE @@FETCH_STATUS=0
		BEGIN
			DECLARE @cREAL_TITLE VARCHAR(MAX), @Link INT, @CODE VARCHAR(100)
			SET @Link = 0
			SELECT @cREAL_TITLE = LEFT ([VALUE],254)
			FROM [{Variable_WorkDb}].dbo.split2(REPLACE(@cTITLE,'_',' '),'.')
			WHERE orders = 2
			
			SELECT @CODE = CONVERT(VARCHAR(100),MAX(CONVERT(FLOAT,too.CODE)) + 1)
			FROM [{Variable_WorkDb}].dbo.TYPE_OTHER_OPER too
			WHERE [{Variable_WorkDb}].dbo.CheckIsNumeric(too.CODE) = 1
			
			--select @CODE = '1_' + @CODE
			
	    /***************/
	    EXEC [{Variable_WorkDb}].dbo.BK_UPDATE_TYPE_OTHER_OPER 
					    @intLINK		= @Link OUTPUT  
					    ,@strCODE		= @CODE
					    ,@strNAME		= @cREAL_TITLE
					    ,@strBKS_CODE	= NULL
					    ,@bitSYSTEM		= 0
					    ,@LINK_DEP = {LINK_DEP}
	    /***************/
		
	INSERT INTO [{Variable_TempDb}].dbo.[__DOC_TYPES_RecordRef]
	(LINK, RecordRef)
	VALUES (@Link, @cTITLE)
			 
			FETCH NEXT FROM CURS INTO @cTITLE
		END
		CLOSE CURS
		DEALLOCATE CURS

COMMIT TRAN
GO
--   1   
update dt
set dt.CODE = '1C_' + dt.CODE
from [{Variable_TempDb}].dbo.[__DOC_TYPES_RecordRef] dtr
inner join [{Variable_WorkDb}].dbo.TYPE_OTHER_OPER dt on dt.LINK = dtr.LINK


---    (  )
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DOC_TYPES_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DOC_TYPES_] (
	[LINK] INT ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DOC_TYPES_]
GO

--   --
IF OBJECT_ID ('TEMPDB..#DOC_TYPES') IS NOT NULL
	EXEC ('DROP TABLE #DOC_TYPES')

CREATE TABLE #DOC_TYPES
	(
	REF	UNIQUEIDENTIFIER,
	[Description]	VARCHAR (254)
	)
	
IF EXISTS (
			SELECT 1 FROM [{Variable_TempDb}].dbo.sysobjects
			where id = object_id('dbo.[CatalogObject|]')
				and OBJECTPROPERTY(id, N'IsUserTable') = 1
			)
	EXEC (
		'INSERT INTO #DOC_TYPES (REF, [Description])'
		+ ' SELECT REF, [Description]'
		+ ' FROM [{Variable_TempDb}].dbo.[CatalogObject|]'
		+ ' WHERE DeletionMark = ''false'''
		)	
GO

SET LOCK_TIMEOUT 30000
DECLARE @inttrancount int
SET @inttrancount = @@TRANCOUNT
SET IMPLICIT_TRANSACTIONS ON
BEGIN TRAN
COMMIT TRAN

		DECLARE @gREF UNIQUEIDENTIFIER, @cTITLE VARCHAR(MAX), @iOBJECT INT
        SET @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DICTIONARY_DOC_TYPES')

		DECLARE CURS CURSOR SCROLL FOR SELECT Ref, LEFT([Description],254) FROM #DOC_TYPES
		OPEN CURS
		FETCH FIRST FROM CURS INTO @gREF, @cTITLE
		WHILE @@FETCH_STATUS=0
		BEGIN
			DECLARE @Link INT, @CODE VARCHAR(100)
			SET @Link = 0
			SET @CODE = ''
			--SELECT @CODE = CONVERT(VARCHAR(100),MAX(CONVERT(FLOAT,too.CODE)) + 1)
			--FROM [{Variable_WorkDb}].dbo.TYPE_OTHER_OPER too
			--WHERE [{Variable_WorkDb}].dbo.CheckIsNumeric(too.CODE) = 1
			
			--select @CODE = '1_' + @CODE
			
	    /***************/
	    EXEC [{Variable_WorkDb}].dbo.BK_UPDATE_TYPE_OTHER_OPER 
					    @intLINK		= @Link OUTPUT  
					    ,@strCODE		= @CODE
					    ,@strNAME		= @cTITLE
					    ,@strBKS_CODE	= NULL
					    ,@bitSYSTEM		= 0
					    ,@LINK_DEP = {LINK_DEP}
	    /***************/
	    
		
	INSERT INTO [{Variable_TempDb}].dbo.[__DOC_TYPES_]
	(LINK, Ref)
	VALUES (@Link, @gREF)
			 
			FETCH NEXT FROM CURS INTO @gREF, @cTITLE
		END
		CLOSE CURS
		DEALLOCATE CURS

	
IF @@TRANCOUNT > @inttrancount
	COMMIT TRAN
GO

IF OBJECT_ID ('TEMPDB..#DOC_TYPES') IS NOT NULL
	EXEC ('DROP TABLE #DOC_TYPES')
GO

