set xact_abort on
BEGIN TRAN
-- 
--   
USE [{Variable_TempDb}]
GO

/*   */

IF exists(select * from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE #COMP (LINK INT)

	INSERT INTO {Variable_WorkDb}.dbo.PF_COMPENSATIONS ([CODE],[NAME],[ROUNDING],[ROUNDING_WAY],[LINK_DEP])
	OUTPUT
		inserted.LINK INTO #COMP (LINK)
	SELECT DISTINCT
		[CODE] = CONVERT(VARCHAR(10),CONVERT (NUMERIC (10,2), A.)),
		[NAME] = ' ' + CONVERT(VARCHAR(10),CONVERT (NUMERIC (10,2), A.)) + '%',
		[ROUNDING] = 1,
		[ROUNDING_WAY] = 1,
		[LINK_DEP] = {LINK_DEP}
	FROM 
		[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|] A
	WHERE
		CONVERT (NUMERIC (10,2), A.) > 0
		AND
		NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.PF_COMPENSATIONS C WHERE C.CODE = CONVERT(VARCHAR(10),	CONVERT (NUMERIC (10,2), A.)) AND C.LINK_DEP = {LINK_DEP})


	-------------------------
	INSERT INTO {Variable_WorkDb}.dbo.[PF_COMPENSATIONS_TABLE] ([LINK_UP],[DATE],[PERCENT])
	SELECT 
		[LINK_UP] = A.LINK, 
		[DATE] = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0), --   
		[PERCENT] = CONVERT(NUMERIC(5,2),B.CODE)
	FROM
		#COMP A
		INNER JOIN {Variable_WorkDb}.dbo.PF_COMPENSATIONS B ON A.LINK = B.LINK
		where CONVERT(NUMERIC(5,2),B.CODE) >=0 and CONVERT(NUMERIC(5,2),B.CODE) <= 100

	/*    */
	INSERT INTO {Variable_WorkDb}.dbo.[PF_SERVICE_REC_COMPENS] ([LINK_UP],[DATE_BEG],[COMPENS],[KOR_ACC_LINK])
	SELECT 
		[LINK_UP] = TD.LINK,
		[DATE_BEG] = ISNULL(A.Period,DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)),
		[COMPENS] = C.LINK,
		[KOR_ACC_LINK] = TA.LINK
	FROM 
		[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|] A
		INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] TD ON TD.REF = A.
		INNER JOIN {Variable_WorkDb}.dbo.PF_COMPENSATIONS C ON C.LINK_DEP = {LINK_DEP} AND C.CODE = CONVERT(VARCHAR(10),CONVERT (NUMERIC (10,2), A.))
		INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] TK ON TK.Ref = A.
		LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_] TA ON TA.Ref = A.
	WHERE
		CONVERT (NUMERIC (10,2), A.) > 0

	--  ,        
	UPDATE A SET A.DATE_END = C.EDATE
	FROM
		{Variable_WorkDb}.dbo.[PF_SERVICE_REC_COMPENS] A
		OUTER APPLY (SELECT EDATE = min(date_beg)-1 FROM {Variable_WorkDb}.dbo.[PF_SERVICE_REC_COMPENS] B
					WHERE A.link_up=B.link_up and B.link<>A.link and B.date_beg>A.date_beg) C
	WHERE
		C.EDATE IS NOT NULL

	--,       
	DECLARE @G_SERVICE_COM_LINK INT
	SELECT @G_SERVICE_COM_LINK = LINK FROM {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS WHERE [SYS] = 16

	--    
	INSERT INTO {Variable_WorkDb}.[dbo].[DEPARTMENT_GROUPS_REF] (GROUP_LINK,DEP_LINK)
	SELECT DISTINCT @G_SERVICE_COM_LINK, TK.LINK
	FROM
		[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|] A
		INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] TD ON TD.REF = A.
		INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] TK ON TK.Ref = A.
	WHERE
		@G_SERVICE_COM_LINK IS NOT NULL
		AND
		CONVERT (NUMERIC (10,2), A.) > 0
		AND
		NOT EXISTS (
			SELECT * FROM 
				{Variable_WorkDb}.[dbo].DEPARTMENT_GROUPS_REF GR
			WHERE 
				GR.GROUP_LINK = @G_SERVICE_COM_LINK
				AND 
				GR.[DEP_LINK] = TK.LINK
		)

END
GO


----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
	END
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].PF_SERVICE_REC'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].PF_SERVICE_REC DROP COLUMN [INSERTED_UIDS]
	END
GO


COMMIT TRAN

GO



	
	