set xact_abort on
BEGIN TRAN

---- PERSONS
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__PERSON_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__PERSON_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__PERSON_]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[CatalogObject|](
	[Ref] [uniqueidentifier] NOT NULL,
	[DeletionMark] [nvarchar](max) NULL,
	[Code] [nvarchar](max) NULL,
	[Description] [nvarchar](max) NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO


IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__DEPARTMENTS_]
		(
		[LINK] int ,
		[Ref] UNIQUEIDENTIFIER
		)
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO
	ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO


--   1
INSERT INTO [{Variable_TempDb}].[dbo].[__PERSON_] ([LINK],[Ref])
SELECT 
	P.LINK,
	T.Ref
FROM
	(	
	SELECT 
		INN         = isnull(A.[],''), 
		A.Ref,
		TYPE_CODE	= ISNULL(B.CODE,'0')
	FROM 
		[{Variable_TempDb}].[dbo].[CatalogObject|] A
		INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] B ON B.Ref = A.[]
	WHERE 
		a.[] = ''
		and not exists(select 1 from [{Variable_TempDb}].dbo.[CatalogObject|] S where S. = A.Ref)
	) T
	INNER JOIN
		(
		SELECT 
			P.LINK, 
			P.INN, 
			TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY P.INN, DT.CODE ORDER BY P.LINK) 
		FROM 
			[{Variable_WorkDb}].dbo.DEPARTMENTS P
			INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = P.[TYPES_LINK]
			INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON
				DPT.LINK = DT.[TYPE]
				AND DPT.DEP_TYPE = 1
		) P 
			ON P.NUM = 1 AND P.INN = T.INN AND P.TYPE_CODE = T.TYPE_CODE
WHERE
	LTRIM(RTRIM(ISNULL(P.INN,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(T.INN,''))) <> ''
GO

--   --
IF OBJECT_ID ('TEMPDB..#PERSON_DOC') IS NOT NULL
	EXEC ('DROP TABLE #PERSON_DOC')

CREATE TABLE #PERSON_DOC
	(
	REF	UNIQUEIDENTIFIER,
	DOC_SER	VARCHAR (100),
	DOC_NUM	VARCHAR (100),
	DOC_WHOM	VARCHAR (254),
	DOC_DATE	DATETIME,
	[PERIOD]	DATETIME,
	DOC_CODE	VARCHAR (20),
	DIV	VARCHAR (20)
	)
	
IF EXISTS (
			select 1 from [{Variable_TempDb}].dbo.sysobjects
						where id = object_id('[dbo].[InformationRegisterRecordSet|]')
							and OBJECTPROPERTY(id, N'IsUserTable') = 1
			)
	AND EXISTS (
			select 1 from [{Variable_TempDb}].dbo.sysobjects
						where id = object_id('[dbo].[CatalogObject|]')
							and OBJECTPROPERTY(id, N'IsUserTable') = 1
			)
	EXEC (
		'INSERT INTO #PERSON_DOC (REF, DOC_SER, DOC_NUM, DOC_WHOM, DOC_DATE, PERIOD,DOC_CODE,DIV)'
		+ ' SELECT PD.[], PD.[],PD.[],LEFT (LTRIM (PD.[]), 254),'
		+ ' case when isdate(PD.[]) = 1 then convert(datetime, PD.[]) ELSE NULL END,'
		+ ' Period, vd.,PD.'
		+ ' FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] PD'
		+ ' LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] vd ON vd.Ref = PD.'
		)
		
UPDATE A
SET DOC_CODE = '21'
FROM #PERSON_DOC A
WHERE A.DOC_CODE = ''
			
GO

--   FACE_DOCUMENT --
IF OBJECT_ID ('TEMPDB..#FACE_DOCUMENT') IS NOT NULL
	EXEC ('DROP TABLE #FACE_DOCUMENT')

CREATE TABLE #FACE_DOCUMENT
	(
	DEP_LINK	INT,
	DOC_NUM	VARCHAR (100),
	DOC_DATE	DATETIME
	)

INSERT INTO #FACE_DOCUMENT
	(
	DEP_LINK,
	DOC_NUM,
	DOC_DATE
	)
SELECT
	DEP_LINK = FDI.DEP,
	DOC_NUM = REPLACE (ISNULL (FDI.SER,'') + ISNULL (FDI.NUM,''), '-', ''),
	DOC_DATE = FDI.[DATE]
FROM [{Variable_WorkDb}].dbo.FACE_DOCUMENT FD
INNER JOIN [{Variable_WorkDb}].dbo.FACE_DOCUMENT_INFO FDI ON
	FD.CODE_SYS = ''
	AND FDI.[TYPE] = FD.LINK

--   2
INSERT INTO [{Variable_TempDb}].[dbo].[__PERSON_] ([LINK],[Ref])
SELECT
	P.DEP_LINK,
	T.Ref
FROM
	(	
	SELECT 
		DOC_NUM         = REPLACE(isnull(pd.DOC_SER,'') + isnull(pd.DOC_NUM,''),'-',''),
		a.Ref,
		TYPE_CODE = ISNULL(B.CODE,'0')
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] A
		INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] B ON B.Ref = A.[]
		OUTER APPLY
		(
			SELECT TOP 1 * FROM #PERSON_DOC PD
			WHERE PD.REF = a.Ref
			ORDER BY PD.Period DESC
		) as PD 
	WHERE 
		a.[] = ''
		and not exists(select 1 from [{Variable_TempDb}].dbo.[CatalogObject|] S where S. = A.Ref)
	) T
	INNER JOIN
		(
		SELECT 
			DEP_LINK, 
			P.DOC_NUM, 
			TYPE_CODE = ISNULL(DT.CODE,'0'),
			NUM = ROW_NUMBER() OVER (PARTITION BY P.DOC_NUM, DT.CODE ORDER BY P.DEP_LINK) 
		FROM 
			#FACE_DOCUMENT P
			INNER JOIN [{Variable_WorkDb}].[dbo].[DEPARTMENTS] D ON D.[LINK] = P.[DEP_LINK]
			INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.[LINK] = D.[TYPES_LINK]
			INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON
				DPT.LINK = DT.[TYPE]
				AND DPT.DEP_TYPE = 1
		) P
		ON P.NUM = 1 AND LTRIM(RTRIM(ISNULL(P.DOC_NUM,''))) = LTRIM(RTRIM(ISNULL(T.DOC_NUM,''))) 
			AND P.[TYPE_CODE] = T.[TYPE_CODE]
WHERE
	LTRIM(RTRIM(ISNULL(P.DOC_NUM,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(T.DOC_NUM,''))) <> ''	
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__PERSON_] R WHERE R.REF = T.Ref)
GO

--   
INSERT INTO [{Variable_TempDb}].[dbo].[__PERSON_] ([LINK],[Ref])
SELECT 
	P.LINK,
	T.Ref
FROM
	(	
	SELECT 
		FM              = isnull(a.[],''), 
		IM              = isnull(a.[],''),
		OT              = isnull(a.[],''), 
		a.Ref,
		TYPE_CODE		= ISNULL(B.CODE,'0')
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] A
		INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] B ON B.Ref = A.[]
		OUTER APPLY
		(
		SELECT TOP 1 * FROM #PERSON_DOC PD
		WHERE PD.REF = a.Ref
		ORDER BY PD.Period DESC
		) as PD 
	WHERE 
		a.[] = ''
		AND
		isnull(A.[],'') = ''				
		and not exists(select 1 from [{Variable_TempDb}].dbo.[CatalogObject|] S where S. = A.Ref)
	) T
	INNER JOIN (
	SELECT 
		P.LINK, P.PERS_FNAME, P.PERS_NAME, P.PERS_SECNAME, TYPE_CODE = ISNULL(DT.CODE,'0'),
		NUM = ROW_NUMBER() OVER (PARTITION BY P.PERS_FNAME, P.PERS_NAME, P.PERS_SECNAME, DT.CODE
									ORDER BY P.LINK DESC) 
	FROM 
		[{Variable_WorkDb}].dbo.DEPARTMENTS P
		INNER JOIN [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT ON DT.LINK = P.[TYPES_LINK]
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON
			DPT.LINK = DT.[TYPE]
			AND DPT.DEP_TYPE = 1
		LEFT JOIN #FACE_DOCUMENT FD ON FD.DEP_LINK = P.LINK
	WHERE
		P.[TYPE] = 1
		AND
		LTRIM(RTRIM(ISNULL(P.INN,''))) = ''
		AND
		LTRIM(RTRIM(ISNULL(FD.DOC_NUM,''))) = ''
	) P 
	ON P.NUM = 1 
		AND ISNULL(LTRIM(RTRIM(P.PERS_FNAME)),'') = ISNULL(LTRIM(RTRIM(T.FM)),'') 
		AND ISNULL(LTRIM(RTRIM(P.PERS_NAME)),'') = ISNULL(LTRIM(RTRIM(T.IM)),'') 
		AND ISNULL(LTRIM(RTRIM(P.PERS_SECNAME)),'') = ISNULL(LTRIM(RTRIM(T.OT)),'')
		AND P.[TYPE_CODE] = T.[TYPE_CODE]
WHERE
	LTRIM(RTRIM(ISNULL(T.FM,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(P.PERS_FNAME,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(P.PERS_NAME,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(T.IM,''))) <> ''
	AND	
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__PERSON_] R WHERE R.REF = T.Ref)	
GO

/********************************************************************************/

--    --
DECLARE
	@D_CORR_TYPES	INT,
	@DEP_CODE	VARCHAR (20)

SELECT TOP 1
	@D_CORR_TYPES = LINK
FROM [{Variable_WorkDb}].dbo.D_CORR_TYPES
WHERE CODE = '7'

SET @DEP_CODE = '#KS_CONV'

DECLARE
	@OWN_DEP_LINK		INT

SET @OWN_DEP_LINK = [{Variable_WorkDb}].dbo.getOwnDepLink()

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS
	(
	CODE, [NAME], FULL_NAME,
	PERS_FNAME, PERS_NAME, PERS_SECNAME,
	INN, [TYPE], TYPES_LINK,
	LINK_DEP, [INSERTED_UIDS]
	)
OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
	INTO [{Variable_TempDb}].[dbo].[__PERSON_]
SELECT
	CODE = @DEP_CODE,
	[NAME] = T.[NAME],
	FULL_NAME = FULL_NAME,
	FM, IM, OT,
	INN, 
	1, 
	DT.LINK, -- 
	LINK_DEP, [REF]
FROM	
	(	
	SELECT
		[NAME]			=	CASE
								WHEN ISNULL (A.[], '') <> '' THEN
									A.[]
								WHEN ISNULL (A.[Description], '') <> '' THEN
									A.[Description]
								ELSE ' '
							END,
		FULL_NAME	=	CASE
							WHEN ISNULL (A.[], '') <> '' THEN
								A.[]
							WHEN ISNULL (A.[Description], '') <> '' THEN
								A.[Description]
							ELSE ' '
						END,
		FM              = isnull(a.[],' '), 
		IM              = isnull(a.[],''),
		OT              = isnull(a.[],''), 
		INN             = isnull(A.[],''), 
		LINK_DEP        = @OWN_DEP_LINK,
		[REF] = a.Ref,
		TYPE_CODE = ISNULL(B.CODE,'0')
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] A
		LEFT JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] B ON B.Ref = A.[]
	WHERE 
		a.[] = ''
	) AS T
	LEFT JOIN
		(
		SELECT DT.*
		FROM [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT 
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON
			DPT.LINK = DT.[TYPE]
			AND DPT.DEP_TYPE = 1
		) AS DT ON DT.[CODE] = T.[TYPE_CODE]
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__PERSON_] R WHERE R.REF = T.REF)

DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

--  .  ,     . --
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS
	(
	CODE, [NAME], FULL_NAME,
	PERS_FNAME, PERS_NAME, PERS_SECNAME,
	INN, [TYPE], TYPES_LINK,
	[DESCRIPTION],
	LINK_DEP, [INSERTED_UIDS]
	)
OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
	INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_]
SELECT
	CODE = @DEP_CODE,
	[NAME] = A.FIO,
	FULL_NAME = A.FIO,
	PERS_FNAME =	CASE
						WHEN A.FM = '' THEN A.FIO
						ELSE A.FM
					END,
	PERS_NAME = '',
	PERS_SECNAME = '',
	'', 1, 
	DT.LINK, -- ,
	 A.FIO,
	@OWN_DEP_LINK, 
	A.[REF]
FROM 
	(
	SELECT
		FIO = LEFT (LTRIM (S.[Description]), 254),
		FM = SUBSTRING (LTRIM (S.[Description]), 1, CHARINDEX (' ', LTRIM (S.[Description]))),
		S.REF,
		TYPE_CODE = '7'
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] S
		LEFT JOIN [{Variable_TempDb}].[dbo].[__PERSON_] R ON R.REF = s.[]
	WHERE 
		s.IsFolder = 'false' AND R.LINK IS NULL 
	) AS A
	LEFT JOIN
		(
		SELECT DT.*
		FROM [{Variable_WorkDb}].[dbo].[D_CORR_TYPES] DT 
		INNER JOIN [{Variable_WorkDb}].[dbo].[DEP_PERSON_TYPE] DPT ON
			DPT.LINK = DT.[TYPE]
			AND DPT.DEP_TYPE = 1
		) AS DT ON DT.[CODE] = A.[TYPE_CODE]

SET @iROWCOUNT = @iROWCOUNT + @@ROWCOUNT

UPDATE P
SET PERS_NAME =
	LTRIM (
			SUBSTRING (P.[NAME], LEN (P.PERS_FNAME) + 1,
				CHARINDEX (' ', LTRIM (P.[NAME]), LEN (P.PERS_FNAME) + 2) - LEN (P.PERS_FNAME)
						)
			)
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T1
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS P ON P.LINK = T1.LINK
WHERE CHARINDEX (' ', LTRIM (P.[NAME]), LEN (P.PERS_FNAME) + 2) > LEN (P.PERS_FNAME)

UPDATE P
SET PERS_SECNAME =
	LTRIM (
			SUBSTRING (P.[NAME], LEN (P.PERS_FNAME + P.PERS_NAME) + 2, LEN (P.[NAME])
						)
			)
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T1
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS P ON P.LINK = T1.LINK

--    

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

--   --
--SELECT *
UPDATE B
SET CODE = CONVERT (VARCHAR (20), B.LINK)
FROM [{Variable_TempDb}].[dbo].[__PERSON_] A
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS B ON 
	B.[INSERTED_UIDS] = A.[Ref]
	AND B.CODE = @DEP_CODE

--SELECT *
UPDATE B
SET CODE = CONVERT (VARCHAR (20), B.LINK)
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS B ON 
	B.[INSERTED_UIDS] = A.[Ref]
	AND B.CODE = @DEP_CODE

GO
	
ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
GO

--   .    --
--SELECT *
UPDATE P
SET 
	PERS_FNAME = LEFT (LTRIM (A.[]), 100)
FROM [{Variable_TempDb}].[dbo].[__PERSON_] T1
INNER JOIN [{Variable_WorkDb}].[dbo].DEPARTMENTS P ON
	P.LINK = T1.LINK
	AND P.PERS_FNAME = ''
	AND P.PERS_NAME = ''
	AND P.PERS_SECNAME = ''
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] A ON
	A.REF = T1.REF
	AND ISNULL (A.[], '') <> ''

--SELECT *
UPDATE P
SET 
	PERS_FNAME = LEFT (LTRIM (A.[Description]), 100)
FROM [{Variable_TempDb}].[dbo].[__PERSON_] T1
INNER JOIN [{Variable_WorkDb}].[dbo].DEPARTMENTS P ON
	P.LINK = T1.LINK
	AND P.PERS_FNAME = ''
	AND P.PERS_NAME = ''
	AND P.PERS_SECNAME = ''
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] A ON
	A.REF = T1.REF
	AND ISNULL (A.[Description], '') <> ''
GO

--  ( ) -- 
INSERT INTO [{Variable_WorkDb}].[dbo].FACE_DOCUMENT_INFO
	(
	DEP, 
	[TYPE],
	SER,
	NUM,
	WHOM,
	[DATE],
	DIV
	)
SELECT
	P.LINK,
	DOC_TYPE = FD.LINK,
	PD.DOC_SER,
	PD.DOC_NUM,
	PD.DOC_WHOM,
	PD.DOC_DATE,
	PD.DIV
FROM
	(
	SELECT 
		DOC.*,
		PERS.LINK,
		NUM = ROW_NUMBER () OVER (PARTITION BY PERS.LINK, DOC.DOC_CODE ORDER BY PERS.LINK)
	FROM #PERSON_DOC DOC
	INNER JOIN [{Variable_TempDb}].[dbo].[__PERSON_] PERS ON PERS.REF = DOC.REF
	) AS PD
INNER JOIN [{Variable_WorkDb}].[dbo].DEPARTMENTS P ON
	PD.NUM = 1
	AND P.LINK = PD.LINK
INNER JOIN [{Variable_WorkDb}].[dbo].FACE_DOCUMENT FD ON FD.CODE = PD.DOC_CODE
LEFT JOIN [{Variable_WorkDb}].[dbo].FACE_DOCUMENT_INFO FDI ON
	FDI.DEP = PD.LINK
	AND FDI.[TYPE] = FD.LINK
WHERE FDI.LINK IS NULL

--   --
IF OBJECT_ID ('TEMPDB..#PERSON_DOC') IS NOT NULL
	EXEC ('DROP TABLE #PERSON_DOC')
GO

--   FACE_DOCUMENT --
IF OBJECT_ID ('TEMPDB..#FACE_DOCUMENT') IS NOT NULL
	EXEC ('DROP TABLE #FACE_DOCUMENT')
GO

--   ( ) --
DECLARE
	@DEP_GRP_PERS	INT

SELECT TOP 1
	@DEP_GRP_PERS = LINK
FROM [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS
WHERE [SYS] = 5

INSERT INTO [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS_REF
	(
	DEP_LINK, GROUP_LINK
	)
SELECT
	P.LINK, @DEP_GRP_PERS
FROM 
	(
	SELECT 
		LINK
	FROM [{Variable_TempDb}].[dbo].[__PERSON_]
	
	UNION

	SELECT 
		LINK
	FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_]
	) AS P
LEFT JOIN [{Variable_WorkDb}].[dbo].DEPARTMENT_GROUPS_REF DGR ON
	DGR.DEP_LINK = P.LINK
	AND DGR.GROUP_LINK = @DEP_GRP_PERS
WHERE DGR.LINK IS NULL

GO

COMMIT TRAN

