
--
EXEC [{Variable_WorkDb}].dbo.GEN_COR_ACC_GROUP 
-- 
EXEC [{Variable_WorkDb}].dbo.GEN_CORR_GROUPS_STR

--  NOMENSEARCH
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH
GO
---    ---
EXEC [{Variable_WorkDb}].dbo.XD_CORRECT_PROV_FULL_BY_XO_BUF
GO
---    
EXECUTE [{Variable_WorkDb}].dbo.XA_ADJUST_EMPL_POST
GO
---    
EXECUTE [{Variable_WorkDb}].dbo.XA_ADJUST_SUBDIV
GO

EXEC [{Variable_WorkDb}].dbo.GENERATE_ACCOUNT_SUBTREE
GO
--exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'NOMENCLATURE', 'name', 2
--GO
--exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'post', 'name', 2
--GO
--exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'DEPARTMENTS', 'full_name', 5
--GO

exec [{Variable_WorkDb}].dbo.GENERATE_NOMEN_SUBTREE
GO

exec [{Variable_WorkDb}].dbo.DEPARTMENTS_CHECK_DOUBLE 1
GO
exec [{Variable_WorkDb}].dbo.DEPARTMENTS_CHECK_DOUBLE 2
GO
exec [{Variable_WorkDb}].dbo.DEPARTMENTS_CHECK_DOUBLE 3
GO
exec [{Variable_WorkDb}].dbo.DICTIONARY_BANK_CHECK_DOUBLE 4
GO

USE {Variable_WorkDb}
GO

ALTER TABLE dbo.DEPARTMENTS DISABLE TRIGGER ALL
GO

	update [{Variable_WorkDb}].dbo.departments
	set KPP = '' 
	where type = 1 and ( isnull(kpp,'') <> '' OR isnull(kpp,'') <> '0' )

	--   ,   
	UPDATE D SET D.MAIN_LINK = SA.LINK
	FROM
		[{Variable_WorkDb}].dbo.DEPARTMENTS D
		INNER JOIN (SELECT LINK_UP, LINK, CNT = COUNT(*) OVER (PARTITION BY LINK_UP)
					 FROM [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS) SA ON D.LINK = SA.LINK_UP AND SA.CNT = 1
	WHERE
		D.MAIN_LINK IS NULL

ALTER TABLE dbo.DEPARTMENTS ENABLE TRIGGER ALL
GO


-- 
INSERT INTO [{Variable_WorkDb}].dbo.[MEASURE]([CODE], [SNAME], [NAME], [LINK_DEP])
SELECT 
	[CODE] = '796', [SNAME] = '', [NAME] = '', [LINK_DEP] = CB.[LINK_CB]
FROM
	(SELECT DISTINCT LINK_CB FROM [{Variable_WorkDb}].dbo.V_DEP) CB
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[MEASURE] M WHERE M.[LINK_DEP] = CB.[LINK_CB] AND M.[SNAME] = '')

--      
EXECUTE [{Variable_WorkDb}].dbo.XA_AUTO_FILL_KL_KBK_IVF
GO
EXECUTE [{Variable_WorkDb}].dbo.XA_AUTO_FILL_KL_KBK_KD
GO
EXECUTE [{Variable_WorkDb}].dbo.XA_AUTO_FILL_KL_VKR
GO

--     
UPDATE A SET A.EKR_R = EKR.LINK
FROM 
	[{Variable_WorkDb}].dbo.INVENTORY I
	INNER JOIN [{Variable_WorkDb}].dbo.ASSETS A ON I.LINK = A.LINK_UP
	INNER JOIN [{Variable_WorkDb}].dbo.GROUP_ACTIVE GA ON GA.LINK = I.GROUP_ACTIVE
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON GA.ACCOUNT_B = SA.LINK AND SA.[cSinth] = '101'
	CROSS APPLY (SELECT LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '271') EKR
WHERE
	A.EKR_R IS NULL
GO

--     
UPDATE A SET A.EKR_R = EKR.LINK
FROM 
	[{Variable_WorkDb}].dbo.INVENTORY I
	INNER JOIN [{Variable_WorkDb}].dbo.ASSETS A ON I.LINK = A.LINK_UP
	INNER JOIN [{Variable_WorkDb}].dbo.GROUP_ACTIVE GA ON GA.LINK = I.GROUP_ACTIVE
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON GA.ACCOUNT_B = SA.LINK AND SA.[cSinth] = '111'
	CROSS APPLY (SELECT LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '224') EKR
WHERE
	A.EKR_R IS NULL
GO

--     0 - 
UPDATE [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
SET [TYPE] = 3
WHERE [TYPE] = 1 AND LEFT(CODE, 1) = '0' AND CODE <> '00000000000000000000'
GO

--      
IF OBJECT_ID ('TEMPDB..#tDep') IS NOT NULL
	EXEC ('DROP TABLE #tDep')

CREATE TABLE #tDep (LINK INT)

INSERT INTO #tDep (LINK)
SELECT
	LINK
FROM [{Variable_WorkDb}].dbo.DEPARTMENTS

EXEC [{Variable_WorkDb}].dbo.RS_DEP_ACC_DOP_CALC @cTableName = '#tDep', @iMode = 2

IF OBJECT_ID ('TEMPDB..#tDep') IS NOT NULL
	EXEC ('DROP TABLE #tDep')
GO

--      
UPDATE DA
SET USED = 0
FROM [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS DA
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS DA_K ON
	DA.USED = 1
	AND DA_K.Link = DA.ACC
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = DA.LINK_UP
WHERE D.[TYPE] = 0
	AND DA.[TYPE] = 2
	AND DA_K.[TYPE] = 1
	
GO

--  
UPDATE DEP
SET
	TYPES_LINK = DCT.LINK
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T1
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS DEP ON
	DEP.LINK = T1.LINK
	AND DEP.TYPES_LINK IS NULL 
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] A ON A.Ref = T1.Ref 
INNER JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] B ON B.Ref = A.[]
INNER JOIN [{Variable_WorkDb}].[dbo].D_CORR_TYPES DCT ON DCT.CODE = B.CODE


GO

--      
exec [{Variable_WorkDb}].dbo.DEPARTMENTS_FIX_TYPE 
GO

-- 97.1    --
exec [{Variable_WorkDb}].dbo.UPDATE_DEP_TYPES_LINK
GO

--    61.
IF OBJECT_ID ('TEMPDB..#DEPARTMENTS_CONV') IS NOT NULL
	EXEC ('DROP TABLE #DEPARTMENTS_CONV')

CREATE TABLE #DEPARTMENTS_CONV
	(
	LINK	INT
	)

DECLARE
	@SQL_EXEC	VARCHAR (1000)

SET @SQL_EXEC = ''

--   --
IF EXISTS(SELECT * FROM [{Variable_TempDb}].SYS.SYSOBJECTS WHERE [NAME] = '__DEPARTMENTS_' AND XTYPE = 'U')
	SET @SQL_EXEC = 'SELECT A.[LINK] FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A '

--     --
IF EXISTS(SELECT * FROM [{Variable_TempDb}].SYS.SYSOBJECTS  WHERE [NAME] = '__PERSON_' AND XTYPE = 'U')
	SET @SQL_EXEC = 
		CASE
			WHEN @SQL_EXEC <> '' THEN @SQL_EXEC + ' UNION '
			ELSE ''
		END
		+ 'SELECT A.[LINK] FROM [{Variable_TempDb}].[dbo].[__PERSON_] A '

--    --
IF EXISTS(SELECT * FROM [{Variable_TempDb}].SYS.SYSOBJECTS WHERE [NAME] = '__DEPARTMENTS_' AND XTYPE = 'U')
	SET @SQL_EXEC = 
		CASE
			WHEN @SQL_EXEC <> '' THEN @SQL_EXEC + ' UNION '
			ELSE ''
		END
		+ 'SELECT A.[LINK] FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A '

--    --
IF EXISTS(SELECT * FROM [{Variable_TempDb}].SYS.SYSOBJECTS WHERE [NAME] = '__DEPARTMENTS_' AND XTYPE = 'U')
	SET @SQL_EXEC = 
		CASE
			WHEN @SQL_EXEC <> '' THEN @SQL_EXEC + ' UNION '
			ELSE ''
		END
		+ 'SELECT A.[LINK] FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A '

IF @SQL_EXEC <> ''
BEGIN
	SET @SQL_EXEC = 'INSERT INTO #DEPARTMENTS_CONV ([LINK]) ' + @SQL_EXEC
	EXEC (@SQL_EXEC)
END

IF EXISTS (SELECT TOP 1 1 FROM #DEPARTMENTS_CONV)
	EXEC [{Variable_WorkDb}].dbo.GENERATE_ID61N_CODE @TAB_NAME	= '#DEPARTMENTS_CONV'

IF OBJECT_ID ('TEMPDB..#DEPARTMENTS_CONV') IS NOT NULL
	EXEC ('DROP TABLE #DEPARTMENTS_CONV')

GO



