--       
USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO


SET NOCOUNT ON
SET XACT_ABORT ON

BEGIN TRAN


INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_ A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


-- ,     --
DECLARE @T_SA_SGU_REST TABLE (LINK	INT)

INSERT INTO @T_SA_SGU_REST
SELECT
	SA.LINK
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] DEP
INNER JOIN [{Variable_WorkDb}].[dbo].[SALDO] S ON
	S.DEP_LINK = DEP.LINK
	AND S.ISOBOROT = 2
INNER JOIN [{Variable_WorkDb}].[dbo].[S_ACCOUNTS] SA ON 
	SA.LINK = S.ACCOUNT 
	AND SA.SGU_REST = 1
GROUP BY
	SA.LINK

-- ,      --
DECLARE @T_SA_SGU1	TABLE
	(
	ACCOUNT	INT,
	SGU	INT
	)

INSERT INTO @T_SA_SGU1
	(
	ACCOUNT,
	SGU
	)
SELECT
	SA_SGU.ACCOUNT,
	ISNULL (SGU.REST_KOSGU, SGU.LINK)
FROM
	(
	SELECT
		SA.LINK,
		SA_SGU.DT_KT
	FROM @T_SA_SGU_REST T1
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON SA.LINK = T1.LINK 
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_SGU SA_SGU ON
		SA_SGU.ACCOUNT = SA.LINK
		AND
			(
			SA.S_ACTIVE = 1 AND  SA_SGU.DT_KT = 1
			OR SA.S_ACTIVE = 0 AND  SA_SGU.DT_KT = 2
			)
	GROUP BY
		SA.LINK,
		SA_SGU.DT_KT
	HAVING 
		COUNT (*) = 1
	) AS T1
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_SGU SA_SGU ON
	SA_SGU.ACCOUNT = T1.LINK
	AND SA_SGU.DT_KT = T1.DT_KT 
INNER JOIN [{Variable_WorkDb}].dbo.KOSGU SGU ON SGU.LINK = SA_SGU.LINK_SGU

--   --
UPDATE S
SET SGU = K.LINK
FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] DEP
INNER JOIN [{Variable_WorkDb}].[dbo].[SALDO] S ON
	S.DEP_LINK = DEP.LINK
	AND S.ISOBOROT = 2
INNER JOIN [{Variable_WorkDb}].[dbo].[S_ACCOUNTS] SA ON 
	SA.LINK = S.ACCOUNT 
	AND SA.SGU_REST = 1

LEFT JOIN @T_SA_SGU1 SGU1 ON SGU1.ACCOUNT = S.ACCOUNT

LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS DEP_ACC ON DEP_ACC.LINK = S.DEP_ACC
LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = ISNULL (S.DEP, DEP_ACC.LINK_UP)
LEFT JOIN [{Variable_WorkDb}].dbo.D_CORR_TYPES DT ON DT.LINK = D.TYPES_LINK
LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU K ON
	K.LINK = SGU1.SGU
	OR SGU1.SGU IS NULL AND K.CODE = ('00' + ISNULL (DT.CODE, '0'))


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

COMMIT TRAN

GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

