USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_ A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '19010101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = '20490101'
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


/***  ***/
USE [{Variable_TempDb}]
GO


/***************/

set xact_abort ON

BEGIN TRAN


USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__VIBOR_ECON_OPER]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__VIBOR_ECON_OPER] (
	[ACC_DT] INT,
	[ACC_KT] INT,
	[DEP] INT,
	[ECON_OPER] INT)
	
ELSE 
	DELETE FROM [dbo].[__VIBOR_ECON_OPER]
	GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER1')
CREATE INDEX [IX__VIBOR_ECON_OPER1] ON [dbo].[__VIBOR_ECON_OPER] (ACC_DT)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER2')
CREATE INDEX [IX__VIBOR_ECON_OPER2] ON [dbo].[__VIBOR_ECON_OPER] (ACC_KT)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER3')
CREATE INDEX [IX__VIBOR_ECON_OPER3] ON [dbo].[__VIBOR_ECON_OPER] (DEP)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER4')
CREATE INDEX [IX__VIBOR_ECON_OPER4] ON [dbo].[__VIBOR_ECON_OPER] (ECON_OPER)-- ON [INDEX]
GO

-- 
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_] (
	[LINK1] int ,
	[LINK2] int)
ELSE 
	DELETE FROM [dbo].[__G_PROV_]
GO

ALTER TABLE dbo.__G_PROV_ ADD CONSTRAINT
	IX___G_PROV_ UNIQUE CLUSTERED 
	(
	LINK1
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
CREATE NONCLUSTERED INDEX IX___G_PROV__1 ON dbo.__G_PROV_
	(
	LINK2
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
ALTER TABLE dbo.__G_PROV_ SET (LOCK_ESCALATION = TABLE)
GO
--------------------------------------------------
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV2_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV2_] (
	[LINK1] int ,
	[LINK2] INT ,
 [DB_KR] TINYINT)
ELSE 
	DELETE FROM [dbo].[__G_PROV2_]
GO

	
----  
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK2' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV2'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [LINK2]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 ADD [LINK2] NVARCHAR(MAX) NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK2' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK2]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK2] NVARCHAR(MAX) NULL
GO

USE {Variable_TempDb}

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

INSERT INTO #EXEC ([text]) SELECT
'
DECLARE @iOBJECT INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = ''DOCUMENTS_OPER''
DECLARE @dFIRST_DATE_OF_YEAR DATETIME
SET @dFIRST_DATE_OF_YEAR = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
'
--  G_PROV
INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC,
LINK2)
OUTPUT INSERTED.link, INSERTED.LINK2
INTO [{Variable_TempDb}].dbo.[__G_PROV_]
SELECT 
 NUMBER     = G.NUMBER
,DATE       = G.[DATE]
,[OBJECT]   = @iOBJECT
,DATE_PROV  = G.[DATE]
,SUMMA      = 0
,COMMENT    = G.COMMENT
,GET_STORE  = 0
,DEP        = D.LINK
,ACC        = D.MAIN_LINK
,LINK2      = G.LINK
FROM [{Variable_TempDb}].[dbo].[__PROV_HDR_1C] G
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = G.DEP_LINK
WHERE G.[DATE] BETWEEN @dFIRST_DATE_OF_YEAR  AND ''20250101''
AND G.RecordRef NOT IN (''DocumentRef._'', ''DocumentRef._'', /* ''DocumentRef.'' , */''DocumentRef.'')
'

--  G_PROV1
INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV1
(LINK_UP, OPER, NAME_OPER, ORDERS, LINK_DEP)
SELECT 
LINK_UP     = DOC.LINK
,OPER       = NULL
,NAME_OPER  = DOC.COMMENT
,ORDERS     = 1
,LINK_DEP   = NULL --DOC.DEP
FROM  [{Variable_WorkDb}].dbo.G_PROV DOC
INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] G ON G.LINK1 = DOC.LINK
'

--  G_PROV2
INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV2
(LINK_UP, SUMMA, QUANTITY, PRICE, STORNO, LINK_SELF, NAME, ORDERS, ECON_OPER, LINK2)
OUTPUT INSERTED.link, INSERTED.LINK2, 2
INTO [{Variable_TempDb}].dbo.[__G_PROV2_]
SELECT
LINK_UP     = G1.LINK
,SUMMA      = ISNULL(T1.SUMMA, 0)
,QUANTITY   = ISNULL (T1.QTY, 0)
,PRICE      = 0
,STORNO     = 0
,LINK_SELF  = NULL
,[NAME]     = T1.COMMENT
,ORDERS     = 1
,ECON_OPER  = NULL
,LINK2      = G.LINK2
FROM [{Variable_TempDb}].dbo.[__G_PROV_] G 
INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK1
INNER JOIN [{Variable_TempDb}].[dbo].[__PROV_HDR_1C] T1 ON T1.LINK = G.LINK2
'

--  G_PROV_AP
INSERT INTO #EXEC ([text]) SELECT
'
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_AP
(LINK_UP, DB_KR, ACCOUNT, KBK, EKR, DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC, TMC,
INDATE, SGU, AP1, AP2, AP3, AP4, AP5, AP6)
SELECT 
LINK_UP     = GP2.LINK1
,DB_KR      = T1.DB_KR
,ACCOUNT    = T1.ACCOUNT
,KBK        = T1.KBK
,EKR        = T1.EKR
,DEP        = T1.DEP
,SUB        = T1.SUB
,EMP        = T1.EMP
,NOMEN      = T1.NOMEN
,INV        = T1.INV
,KAU        = T1.KAU
,DEP_ACC    = T1.DEP_ACC
,TMC        = T1.TMC
,INDATE     = NULL
,SGU        = T1.SGU
,AP1        = T1.AP1
,AP2        = T1.AP2
,AP3        = T1.AP3
,AP4        = T1.AP4
,AP5        = T1.AP5
,AP6        = T1.AP6
FROM [{Variable_TempDb}].dbo.[__G_PROV2_] GP2
INNER JOIN [{Variable_TempDb}].[dbo].[__PROV_ANALIT_1C] T1 ON T1.LINK_UP = GP2.LINK2
WHERE T1.ACCOUNT IS NOT NULL

DECLARE @iROWCOUNT1 INT
SET @iROWCOUNT1 = @@ROWCOUNT
'

INSERT INTO #EXEC ([text]) SELECT
'
--    
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id(''[dbo].[__JOURNAL_PROVOD]'') and OBJECTPROPERTY(id, N''IsUserTable'') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_PROVOD]

CREATE TABLE [{Variable_TempDb}].dbo.[__JOURNAL_PROVOD]
( DATETIME,  VARCHAR(MAX),  NUMERIC(38,4),  VARCHAR(100),  VARCHAR(100),  VARCHAR(MAX)) 

DECLARE @iROWS_NOT_COPIED BIGINT
INSERT INTO [{Variable_TempDb}].dbo.[__JOURNAL_PROVOD]
(, , , , , )
SELECT
            = ar.DATE, 
     = isnull(ar.COMMENT,''''),
           = isnull(ar.SUMMA, 0),
          = GAP_D.ACC_CODE,
          = GAP_K.ACC_CODE,
         = CASE
					WHEN (SA_D.LINK IS NULL AND SA_K.LINK IS NULL)
						THEN ''        ''
                    ELSE ''''
				END
 FROM [{Variable_TempDb}].dbo.[__PROV_HDR_1C] ar
 INNER JOIN [{Variable_WorkDb}].dbo.V_DEP CB ON CB.LINK = AR.DEP_LINK

LEFT JOIN [{Variable_TempDb}].dbo.[__PROV_ANALIT_1C] GAP_D ON
	GAP_D.LINK_UP = AR.LINK
	AND GAP_D.DB_KR = 0
LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C SA_D ON
	SA_D.CODE = GAP_D.ACC_CODE
	AND SA_D.LINK_DEP = CB.LINK_CB
 
LEFT JOIN [{Variable_TempDb}].dbo.[__PROV_ANALIT_1C] GAP_K ON
	GAP_K.LINK_UP = AR.LINK
	AND GAP_K.DB_KR = 1
LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_1C SA_K ON
	SA_K.CODE = GAP_K.ACC_CODE
	AND SA_K.LINK_DEP = CB.LINK_CB
WHERE
	(
	SA_D.LINK IS NULL AND SA_K.ZABALANS = 0
	OR SA_K.LINK IS NULL AND SA_D.ZABALANS = 0
	)
	AND (ar.DATE >= (CONVERT(VARCHAR(4),YEAR(GETDATE())) + ''0101'') )
ORDER BY 

set @iROWS_NOT_COPIED = @@ROWCOUNT


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES ('' '', '' : '' + convert(nvarchar(100),ISNULL(@iROWCOUNT1,0)), ''__JOURNAL_PROVOD'', @iROWS_NOT_COPIED)
--
'

USE {Variable_TempDb}

DECLARE @err INT

IF EXISTS (SELECT text FROM #EXEC)
	EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'
GO

ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [LINK2]
GO

ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK2]
GO

COMMIT TRAN

----   
UPDATE g
SET g.SUMMA = ISNULL([{Variable_WorkDb}].dbo.CalcDocSumma(G.LINK), G.SUMMA)
FROM [{Variable_WorkDb}].dbo.G_PROV g
WHERE g.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')

GO

BEGIN TRAN

--  

INSERT INTO [{Variable_TempDb}].[dbo].[__VIBOR_ECON_OPER] ([ACC_DT], [ACC_KT], [DEP])
SELECT
	[ACC_DT] = gpa1.ACCOUNT,
	[ACC_KT] = gpa2.ACCOUNT,
	[DEP] = SA.LINK_DEP
FROM 
[{Variable_WorkDb}].dbo.G_PROV_AP gpa1
INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP gpa2 ON
	gpa1.LINK_UP = gpa2.LINK_UP AND gpa2.DB_KR = 1
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON SA.LINK = gpa1.ACCOUNT
WHERE gpa1.DB_KR = 0
GROUP BY
	gpa1.ACCOUNT,
	gpa2.ACCOUNT,
	SA.LINK_DEP
GO

UPDATE [{Variable_TempDb}].[dbo].[__VIBOR_ECON_OPER]
SET [ECON_OPER] = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.BX_BPROV_VIBOR_ECON_OPER([ACC_DT], [ACC_KT], DEFAULT, [DEP]))
GO

UPDATE gp2
SET 
	gp2.ECON_OPER = B.[ECON_OPER]
FROM 
	[{Variable_WorkDb}].dbo.G_PROV gp 
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = gp.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 gp1 ON gp1.LINK_UP = gp.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 gp2 ON gp2.LINK_UP = gp1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP gpa1 ON gpa1.LINK_UP = gp2.LINK AND gpa1.DB_KR = 0
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP gpa2 ON gpa2.LINK_UP = gp2.LINK AND gpa2.DB_KR = 1
	INNER JOIN [{Variable_TempDb}].[dbo].[__VIBOR_ECON_OPER] B ON gpa1.[ACCOUNT] = B.[ACC_DT]
																AND gpa2.[ACCOUNT] = B.[ACC_KT]
WHERE gp.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')
GO

--   
UPDATE gp1
SET gp1.NAME_OPER = ISNULL(xo.NAME,'')
FROM [{Variable_WorkDb}].dbo.G_PROV gp 
INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = gp.LINK
INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 gp1 ON gp1.LINK_UP = gp.LINK
INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 gp2 ON gp2.LINK_UP = gp1.LINK
INNER JOIN [{Variable_WorkDb}].dbo.XOZ_OPER xo ON xo.LINK = gp2.ECON_OPER
WHERE gp.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')

--  ,     
UPDATE GAP1 SET
	GAP1.KBK = GAP2.KBK 
FROM 
	[{Variable_WorkDb}].dbo.G_PROV gp 
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = gp.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 gp1 ON gp1.LINK_UP = gp.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 gp2 ON gp2.LINK_UP = gp1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP1 ON GAP1.LINK_UP = gp2.LINK AND GAP1.DB_KR = 0
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP2 ON GAP2.LINK_UP = gp2.LINK AND GAP2.DB_KR = 1
WHERE 
	gp.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')
	AND
	GAP1.KBK IS NULL AND GAP2.KBK IS NOT NULL

UPDATE GAP2 SET 
	GAP2.KBK = GAP1.KBK 
FROM 
	[{Variable_WorkDb}].dbo.G_PROV gp 
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = gp.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 gp1 ON gp1.LINK_UP = gp.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 gp2 ON gp2.LINK_UP = gp1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP1 ON GAP1.LINK_UP = gp2.LINK AND GAP1.DB_KR = 0
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP2 ON GAP2.LINK_UP = gp2.LINK AND GAP2.DB_KR = 1
WHERE 
	gp.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')
	AND
	GAP2.KBK IS NULL AND GAP1.KBK IS NOT NULL

COMMIT TRAN

GO

----   
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_OTHER_OPER
(DOC_LINK, TYPE_OPER)
select 
DOC_LINK    = GP.LINK,
TYPE_OPER   = dtr.LINK
from [{Variable_WorkDb}].dbo.G_PROV GP 
INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = GP.LINK
INNER JOIN [{Variable_TempDb}].dbo.[__PROV_HDR_1C] ar ON ar.LINK = gpp.LINK2
INNER JOIN [{Variable_TempDb}].dbo.[__DOC_TYPES_RecordRef] dtr ON dtr.RecordRef = ar.RecordRef
WHERE gp.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')

EXEC [{Variable_WorkDb}].[dbo].X_SALDO_COMMITCHANGES

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO






