USE {Variable_TempDb}
GO


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[GetNums]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION dbo.[GetNums]

GO
CREATE FUNCTION dbo.GetNums(@low AS BIGINT, @high AS BIGINT) RETURNS TABLE
AS
RETURN
WITH
L0 AS (SELECT c FROM (SELECT 1 UNION ALL SELECT 1) AS D(c)),
L1 AS (SELECT 1 AS c FROM L0 AS A CROSS JOIN L0 AS B),
L2 AS (SELECT 1 AS c FROM L1 AS A CROSS JOIN L1 AS B),
L3 AS (SELECT 1 AS c FROM L2 AS A CROSS JOIN L2 AS B),
L4 AS (SELECT 1 AS c FROM L3 AS A CROSS JOIN L3 AS B),
L5 AS (SELECT 1 AS c FROM L4 AS A CROSS JOIN L4 AS B),
Nums AS (SELECT ROW_NUMBER() OVER(ORDER BY (SELECT NULL)) AS rownum
FROM L5)
SELECT TOP(@high - @low + 1) (@low + rownum - 1) AS n
FROM Nums
ORDER BY rownum;
GO

GRANT SELECT ON dbo.[GetNums] TO PUBLIC
GO


IF OBJECT_ID('TEMPDB..#BALANCE','U') IS NOT NULL
	DROP TABLE #BALANCE
GO

CREATE TABLE #BALANCE (
	[] uniqueidentifier,
	[] uniqueidentifier,
	[] nvarchar(10),
	[] nvarchar(MAX),
	[] nvarchar(MAX),
	[] nvarchar(MAX),
	[] nvarchar(MAX),
	[N] bigint,
	[BALANCE] int)
GO

-- [AccumulationRegisterRecordSet|]
IF exists(select 1 from dbo.sysobjects where id = object_id('[dbo].[AccumulationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] VARCHAR (20) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] VARCHAR (20) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), 'ACTIVE', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [ACTIVE] INT NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), 'PERIOD', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [PERIOD] DATETIME NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] UNIQUEIDENTIFIER NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] UNIQUEIDENTIFIER NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] NVARCHAR (20) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] NVARCHAR (MAX) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] NVARCHAR (MAX) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] NVARCHAR (MAX) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), '', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [] NVARCHAR (MAX) NULL')
	--
	IF COLUMNPROPERTY(object_id('[dbo].[AccumulationRegisterRecordSet|]'), 'MovementType', 'AllowsNull') is NULL
		EXEC ('ALTER TABLE [dbo].[AccumulationRegisterRecordSet|] ADD [MovementType] VARCHAR (50) NULL')

END

GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[AccumulationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	--   
	INSERT INTO #BALANCE (, , , , , , , N, BALANCE)
	SELECT , , , , , , , N, SUM(BALANCE) AS BALANCE
	FROM
	(
	SELECT
		, , , , , , , N, CAST(CASE WHEN MovementType = 'Receipt' THEN 1 ELSE -1 END AS INT) AS BALANCE
	FROM
		{Variable_TempDb}.dbo.[AccumulationRegisterRecordSet|]
		CROSS APPLY {Variable_TempDb}.dbo.[GetNums](,)
	WHERE
		ACTIVE = 1
		AND
		PERIOD < DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)
	) T
	GROUP BY
		, , , , , , , N
	HAVING
		SUM(BALANCE) >= 1

END
GO

IF OBJECT_ID('TEMPDB..#BSO_REST','U') IS NOT NULL
	DROP TABLE #BSO_REST
GO

CREATE TABLE #BSO_REST (
	[ID_ROW] INT,
	[] uniqueidentifier,
	[] uniqueidentifier,
	[] nvarchar(10),
	[] nvarchar(MAX),
	[] nvarchar(MAX),
	[] nvarchar(MAX),
	[] nvarchar(MAX),
	[NUM1] bigint,
	[NUM2] bigint)
GO

--,    
INSERT INTO #BSO_REST (ID_ROW, , , , , , , , NUM1, NUM2)
SELECT ID_ROW = ROW_NUMBER() OVER (ORDER BY , , , , , , ), 
	, , , , , , , MIN(N) AS NUM1, MAX(N) AS NUM2
FROM (SELECT , , , , , , , N, ROW_NUMBER() OVER (ORDER BY , , , , , , , N) AS RN FROM #BALANCE) A
GROUP BY , , , , , , , (RN - N)	
ORDER BY 1,2
GO

-- -  
set xact_abort on
BEGIN TRAN

--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV__] (
    [LINK] int,
	[] UNIQUEIDENTIFIER,
    [] UNIQUEIDENTIFIER,
	[] UNIQUEIDENTIFIER,
	[] nvarchar(20))
ELSE 
    DELETE FROM [dbo].[__G_PROV__]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [] UNIQUEIDENTIFIER NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [] UNIQUEIDENTIFIER NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [] UNIQUEIDENTIFIER NULL
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [] nvarchar(20) NULL
GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'ID_ROW' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [ID_ROW]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [ID_ROW] INT NULL
GO

DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT, @iROWCOUNT INT
SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_BSO_POSTUPLENIE')

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) 
	([NUMBER], [DATE], [OBJECT], [DATE_PROV], [SUMMA], [COMMENT], [GET_STORE], [DEP], [ACC], [GUID], [], [], [],[])
OUTPUT INSERTED.LINK, INSERTED.[], INSERTED.[], INSERTED.[], INSERTED.[]
	INTO [{Variable_TempDb}].dbo.[__G_PROV__] (LINK,  [], [], [], [])
SELECT 
	NUMBER          = '1__'
	,[DATE]          = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) - 1
	,[OBJECT]       = @iOBJECT
	,DATE_PROV      = NULL
	,SUMMA          = 0
	,COMMENT        = ' '
	,GET_STORE      = 0
	,DEP            = DEP.LINK
	,ACC            = DEP.MAIN_LINK
	,[GUID]         = NULL
	,[]   = AR.[]
	,[]          = AR.[]
	,[]	= AR.[]
	,			= AR.[]
FROM
	#BSO_REST AR
	INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] do on do.Ref = AR.
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS DEP ON DEP.LINK = do.LINK
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV__] R WHERE R.[] = AR.[] AND R.[] = AR.[] AND R.[] = AR.[] AND R.[] = AR.[]) 
GROUP BY
	DEP.[LINK], DEP.[MAIN_LINK], [], [], [], []

SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
IF @iError <> 0
    ROLLBACK

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  -    "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
GO

---  - .
INSERT INTO [{Variable_WorkDb}].dbo.DOC_BSO_POSTUPLENIE_REQUISIT WITH (ROWLOCK) ([LINK_UP], [MOL_LINK])
SELECT 
	[LINK_UP] = T.LINK
	,[MOL_LINK] = EMP.LINK
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV__] T
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cmo1 ON cmo1.Ref = T. 
	LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ es1 ON es1.Ref = convert(uniqueidentifier,cmo1.)
	LEFT JOIN {Variable_WorkDb}.dbo.EMPL EMP ON EMP.LINK = ES1.LINK
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DOC_BSO_POSTUPLENIE_REQUISIT R WHERE R.[LINK_UP] = T.LINK AND R.[MOL_LINK] = EMP.LINK)
ORDER BY
	T.LINK

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO

-- 
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER(LINK_UP,DOC_OPER)
SELECT 
	[LINK_UP] = T.LINK
	,[DOC_OPER] = D_OP.LINK
FROM 
	[{Variable_TempDb}].dbo.[__G_PROV__] T
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = T.
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = T.
	LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS_1C sa1 ON sa1.CODE = ((CASE T. WHEN '' THEN '4' WHEN '' THEN '2' WHEN '' THEN '1' ELSE T. END) + '.' + accCD.Code) AND sa1.LINK_DEP = VD.LINK_CB
	LEFT JOIN {Variable_WorkDb}.dbo.DOC_OPERS D_OP ON
		(sa1.ZABALANS = 1 AND SA1.cSINTH = '03'
			AND (SA1.cANALIT = '1' AND D_OP.CODE = 'DOC_BSO_POSTUPL_USL_ED'
				OR SA1.cANALIT = '2' AND D_OP.CODE = 'DOC_BSO_POSTUPL_ACT_COST'
				)
		)
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER R WHERE R.[LINK_UP] = T.LINK AND R.[DOC_OPER] = D_OP.LINK)
ORDER BY
	T.LINK

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO

DECLARE @iTABLE_OBJ_ID INT
SET @iTABLE_OBJ_ID = [{Variable_WorkDb}].dbo.[obj_id]('DOC_BSO_NAKLAD_TABLE')

-- 
INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_ROW] ([LINK_UP],[OBJECT],[ORDERS],[LINK_OPER],[COMMENT],[ID_ROW])
SELECT
	[LINK_UP] = T.LINK
	,[OBJECT] = @iTABLE_OBJ_ID
	,[ORDERS] = ROW_NUMBER() OVER (PARTITION BY T.LINK ORDER BY T1.ID_ROW)  
	,[LINK_OPER] = NULL
	,[COMMENT] = ' '
	,[ID_ROW] = T1.ID_ROW
FROM
	[{Variable_TempDb}].dbo.[__G_PROV__] T
	INNER JOIN #BSO_REST T1 ON T. = T1. AND T. = T1. AND T. = T1. AND T. = T1.
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_ROW] Z WHERE Z.[LINK_UP] = T.LINK)

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO


--
INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] (LINK_UP, INV_TYPE, NOMEN_LINK)
SELECT
	LINK_UP = OT.LINK
	,INV_TYPE = 3
	,NOMEN_LINK = N.LINK
FROM
	#BSO_REST T
	INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[ID_ROW] = T.[ID_ROW]
	LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_ BSO ON T.  = BSO.REF
	LEFT JOIN {Variable_WorkDb}.dbo.NOMENCLATURE N ON BSO.LINK = N.LINK
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] Z WHERE Z.LINK_UP = OT.LINK)

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO

--
INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_SUM_ACCT] ([LINK_UP], [BALANCE], [QTY], [PRICE], [ACCOUNT_B])
SELECT
	LINK_UP = OT.LINK
	,[BALANCE] = (ISNULL (T.NUM2, T.NUM1) - ISNULL (T.NUM1, 0) + 1)
	,[QTY] = (ISNULL (T.NUM2, T.NUM1) - ISNULL (T.NUM1, 0) + 1)
	,[PRICE] = 1
	,[ACCOUNT_B] = sa1.LINK
FROM
	#BSO_REST T
	INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[ID_ROW] = T.[ID_ROW]
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = T.
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = T.
	LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS_1C sa1 ON sa1.CODE = ((CASE T. WHEN '' THEN '4' WHEN '' THEN '2' WHEN '' THEN '1' ELSE T. END) + '.' + accCD.Code) AND sa1.LINK_DEP = VD.LINK_CB
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_SUM_ACCT] Z WHERE Z.[LINK_UP] = OT.LINK)

	UPDATE SA SET SA.ap_TMC = 1
	FROM {Variable_WorkDb}.dbo.S_ACCOUNTS SA
	WHERE 
		SA.ap_TMC = 0
		AND
		EXISTS (
			SELECT * FROM
				#BSO_REST T
				INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[ID_ROW] = T.[ID_ROW]
				INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = T.
				INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
				INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = T.
				INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS_1C sa1 ON sa1.CODE = ((CASE T. WHEN '' THEN '4' WHEN '' THEN '2' WHEN '' THEN '1' ELSE T. END) + '.' + accCD.Code) AND sa1.LINK_DEP = VD.LINK_CB
			WHERE
				SA.LINK = SA1.LINK
		)

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO

--
INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_ANALIT] ([LINK_ROW], [EMP], [KAU], [PRICE], [FIN_SOURCE])
SELECT
	[LINK_ROW] = OT.LINK
	,[EMP] = EMP.LINK
	,[KAU] = KAU.LINK
	,[PRICE] = 1
	,[FIN_SOURCE] = FS.LINK
FROM
	#BSO_REST T
	INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[ID_ROW] = T.[ID_ROW]

	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = T.
	INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = T.
	LEFT JOIN {Variable_WorkDb}.dbo.FIN_SOURCE FS ON (CASE T. WHEN '' THEN '4' WHEN '' THEN '2' WHEN '' THEN '1' ELSE T. END) = FS.CODE

	LEFT JOIN dbo.[CatalogObject|] cmo1 ON cmo1.Ref = T.
	LEFT JOIN dbo.__EMPL_ es1 ON es1.Ref = convert(uniqueidentifier,cmo1.)
	LEFT JOIN {Variable_WorkDb}.dbo.EMPL EMP ON EMP.LINK = ES1.LINK

	LEFT JOIN dbo.__KAU_ TB ON TB.REF = T.
	LEFT JOIN {Variable_WorkDb}.dbo.KAU ON KAU.LINK = TB.LINK
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_ANALIT] Z WHERE Z.[LINK_ROW] = OT.LINK)

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO

-- 
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT [{Variable_WorkDb}].dbo.DOC_BSO_OPER ([LINK_UP], [SOURCE], [SERIES], [RANGE_BEG], [RANGE_END], [RANGE_BEG_C], [RANGE_END_C], [QTY_REQUEST], [QTY_GIVEN], [PRICE_R])
	SELECT
		[LINK_UP] = OT.LINK
		,[SOURCE] = FS.LINK
		,[SERIES] = left(ISNULL (SBSO.[Description], ''), 30)
		,[RANGE_BEG] = ISNULL (T.NUM1, 0)
		,[RANGE_END] = ISNULL (T.NUM2, 0)
		,[RANGE_BEG_C] = CASE WHEN ISNULL(N.[RANGE_LENGTH],0) <= 18 AND ISNULL(N.[RANGE_LENGTH],0) > LEN(ISNULL(T.NUM1, 0)) THEN RIGHT(REPLICATE('0',18) + CAST( ISNULL(T.NUM1, 0) AS VARCHAR(18)),N.[RANGE_LENGTH]) ELSE CAST( ISNULL(T.NUM1, 0) AS VARCHAR(18)) END
		,[RANGE_END_C] = CASE WHEN ISNULL(N.[RANGE_LENGTH],0) <= 18 AND ISNULL(N.[RANGE_LENGTH],0) > LEN(ISNULL(T.NUM2, 0)) THEN RIGHT(REPLICATE('0',18) + CAST( ISNULL(T.NUM2, 0) AS VARCHAR(18)),N.[RANGE_LENGTH]) ELSE CAST( ISNULL(T.NUM2, 0) AS VARCHAR(18)) END
		,[QTY_REQUEST] = (ISNULL (T.NUM2, T.NUM1) - ISNULL (T.NUM1, 0) + 1)
		,[QTY_GIVEN] = 0
		,[PRICE_R] = 0
	FROM
		#BSO_REST T
		INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[ID_ROW] = T.[ID_ROW]

		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = T.
		INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
		LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = T.
		LEFT JOIN {Variable_WorkDb}.dbo.FIN_SOURCE FS ON (CASE T. WHEN '' THEN '4' WHEN '' THEN '2' WHEN '' THEN '1' ELSE T. END) = FS.CODE

		LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] SBSO ON (SBSO.REF = T.)

		LEFT JOIN [{Variable_TempDb}].[dbo].[__NOMENCLATURE_] T_BSO ON T. = T_BSO.REF
		LEFT JOIN [{Variable_WorkDb}].dbo.NOMENCLATURE N ON N.LINK = T_BSO.LINK

	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[DOC_BSO_OPER] Z WHERE Z.[LINK_UP] = OT.LINK)
END

DECLARE @iError INT
SELECT @iError = @@ERROR
IF @iError <> 0
    ROLLBACK
GO


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
GO
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN 
GO
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'ID_ROW' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [ID_ROW]
GO


COMMIT TRAN

GO


