/*
       
    
*/


USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = '20490101'
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}

IF OBJECT_ID('TEMPDB..#DOCS','U') IS NOT NULL
	DROP TABLE #DOCS
GO
	
CREATE TABLE #DOCS (LINK INT, REF UNIQUEIDENTIFIER)
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK, REF)
	SELECT LINK, REF FROM {Variable_TempDb}.dbo.[__G_PROV__]
GO
IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK, REF)
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.[__G_PROV__]
GO
IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK, REF)
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.[__G_PROV__]
GO
IF exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	INSERT INTO #DOCS (LINK, REF)
	SELECT LINK, REF FROM [{Variable_TempDb}].dbo.[__G_PROV__]
GO

CREATE INDEX #TMP_IDX_DOCS_LINK ON #DOCS (LINK)
GO
CREATE INDEX #TMP_IDX_DOCS_REF ON #DOCS (REF)
GO

ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV] DISABLE TRIGGER ALL
ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV1] DISABLE TRIGGER ALL
GO

/*       */
UPDATE G1 SET G1.LINK_UP = D.LINK
FROM
	#DOCS D
	INNER JOIN {Variable_TempDb}.dbo.[AccountingRegisterRecordSet|] AR ON AR.RECORDER = D.REF
	INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_] T1 ON AR.LINK = T1.LINK2
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON T1.LINK1 = G1.LINK_UP
GO

/*  */
UPDATE GD SET GD.DATE_PROV = G.DATE_PROV
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV GD ON GD.LINK = D.LINK
	INNER JOIN {Variable_TempDb}.dbo.[AccountingRegisterRecordSet|] AR ON AR.RECORDER = D.REF
	INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_] T1 ON AR.LINK = T1.LINK2
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON T1.LINK1 = G.LINK
GO

/*   ,    */
UPDATE F
SET F.DOC_STATUS = CASE WHEN A.DATE_PROV IS NULL THEN F.DOC_STATUS & ~4 ELSE F.DOC_STATUS | 4 END
FROM #DOCS B INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV] A ON A.LINK = B.LINK
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] F ON A.LINK = F.LINK_UP
GO

/*   ,    */
UPDATE F
SET F.DOC_STATUS = CASE WHEN A.NUMBER IS NULL OR A.NUMBER = '' THEN F.DOC_STATUS & ~2 ELSE F.DOC_STATUS | 2 END
FROM #DOCS B INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV] A ON A.LINK = B.LINK 
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] F ON A.LINK = F.LINK_UP
GO

/*   */
UPDATE g
SET g.SUMMA = ISNULL([{Variable_WorkDb}].dbo.CalcDocSumma(G.LINK), G.SUMMA)
FROM
	#DOCS D 
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON G.LINK = D.LINK
GO

----         
SELECT 
	G.LINK AS G_LINK, 
	G1.LINK AS G1_LINK, 
	SAD.[CSOURCE], 
	GAPD.KBK, 
	GAPD.SGU,
	GAPK.NOMEN,
	G2.SUMMA,
	G2.QUANTITY,
	NUM = ROW_NUMBER() OVER (PARTITION BY G.LINK, GAPK.NOMEN, G2.SUMMA, G2.QUANTITY ORDER BY G1.LINK)
INTO 
	#OT_G_PROV1
FROM
	#DOCS D
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
WHERE
	SO.CODE = 'DOC_MENU_DEM_REST'
	AND
	SAD.ZABALANS = 0

---
SELECT 
	OT.LINK,
	OT.LINK_UP, 
	OTI.NOMEN_LINK,
	OTM.SUMMA,
	OTM.QTY,
	NUM = ROW_NUMBER() OVER (PARTITION BY OT.LINK_UP, OTI.NOMEN_LINK, OTM.SUMMA, OTM.QTY ORDER BY OT.LINK)
INTO 
	#OT_ROW
FROM
	[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OT
	INNER JOIN [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] OTI ON OTI.[LINK_UP] = OT.[LINK] --,[INV_TYPE],[NOMEN_LINK])
	INNER JOIN [{Variable_WorkDb}].dbo.[OUT_TABLE_MZ_SUMMA] OTM ON OTM.[LINK_ROW] = OT.[LINK] --,[QTY],[QTY_M],[SUMMA],[PRICE])

---
INSERT INTO {Variable_WorkDb}.dbo.OUT_TABLE_G_PROV1 (LINK_ROW, LINK_G1)
SELECT OT.LINK, G1.G1_LINK
FROM
	[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OT
	INNER JOIN #OT_ROW R ON R.LINK = OT.LINK
	INNER JOIN #OT_G_PROV1 G1 ON G1.G_LINK = OT.LINK_UP AND G1.NOMEN = R.NOMEN_LINK AND G1.SUMMA = R.SUMMA AND G1.QUANTITY = R.QTY AND G1.NUM = R.NUM
WHERE
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.OUT_TABLE_G_PROV1 T WHERE T.LINK_ROW = OT.LINK AND T.LINK_G1 = G1.G1_LINK)

---
INSERT INTO [{Variable_WorkDb}].dbo.[OUT_TABLE_ANALIT] ([LINK_ROW],[FIN_SOURCE],[KBK],[KBK_KT],[SGU])
SELECT 
	OTG1.LINK_ROW, FS.LINK, G1.KBK, G1.KBK, G1.SGU
FROM
	{Variable_WorkDb}.dbo.OUT_TABLE_G_PROV1 OTG1
	INNER JOIN #OT_G_PROV1 G1 ON OTG1.LINK_G1 = G1.G1_LINK
	INNER JOIN [{Variable_WorkDb}].dbo.FIN_SOURCE FS ON FS.[CODE] = G1.[CSOURCE]
WHERE
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.[OUT_TABLE_ANALIT] T WHERE T.LINK_ROW = OTG1.LINK_ROW)

----

/*      */
UPDATE G SET G.DATE_PROV = NULL
FROM
	#DOCS D
	INNER JOIN {Variable_TempDb}.dbo.[AccountingRegisterRecordSet|] AR ON AR.RECORDER = D.REF
	INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_] T1 ON AR.LINK = T1.LINK2
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON T1.LINK1 = G.LINK
GO

/*   (  ),       */
DELETE {Variable_WorkDb}.dbo.G_PROV
WHERE EXISTS (
	SELECT * 
	FROM 
		#DOCS D
		INNER JOIN {Variable_TempDb}.dbo.[AccountingRegisterRecordSet|] AR ON AR.RECORDER = D.REF
		INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_] T1 ON AR.LINK = T1.LINK2
		WHERE T1.LINK1 =  {Variable_WorkDb}.dbo.G_PROV.LINK
	)
GO


IF exists(select * from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[__G_PROV__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	--    
	
	--    ,     
	DELETE FROM {Variable_WorkDb}.dbo.G_PROV_DOC_OPER 
	WHERE EXISTS (SELECT * FROM #DOCS D INNER JOIN {Variable_TempDb}.dbo.[__G_PROV__] T ON T.LINK = D.LINK 
					WHERE D.LINK = {Variable_WorkDb}.dbo.G_PROV_DOC_OPER.LINK_UP)

	--- \   \    \ -  
	INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER (LINK_UP, DOC_OPER)
	SELECT D_LINK, DO_LINK
	FROM
	(SELECT DISTINCT D_LINK = D.LINK, DO_LINK = DO.LINK, ROW_NUMBER() OVER (PARTITION BY D.LINK ORDER BY (CASE WHEN DO.NAME LIKE '%' THEN 1 ELSE 0 END), DO.LINK) AS NUM
	FROM
		#DOCS D
		INNER JOIN {Variable_TempDb}.dbo.[__G_PROV__] T ON T.LINK = D.LINK 
		INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK = G.LINK
		INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
		INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
		INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
		INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPD ON GAPD.LINK_UP = G2.LINK AND GAPD.DB_KR = 0
		INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAD ON SAD.LINK = GAPD.ACCOUNT
		INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
		INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
		INNER JOIN {Variable_WorkDb}.dbo.V_DOC_OPERS DO ON DO.OBJ_CODE = SO.CODE AND DO.CODE =
			CASE 
				--1.   (401.20)
				WHEN SAD.cSinth LIKE '109' THEN 'NFA_OUT_TO_COSTPRICE' 
				--2.     ,  (109)
				WHEN SAD.cSinth LIKE '401' AND SAD.cAnalit LIKE '20' THEN 'NFA_WRITE_OFF'
				--     -			
				ELSE 'DOCUMENTS_KO_OTHER'
			END
	WHERE
		SO.CODE = 'DOC_MENU_DEM_REST'
		AND
		SAD.ZABALANS = 0
	) T	
	WHERE
		T.NUM = 1

END
GO

ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV] ENABLE TRIGGER ALL
ALTER TABLE {Variable_WorkDb}.dbo.[G_PROV1] ENABLE TRIGGER ALL
GO

--/*     */
--INSERT INTO {Variable_WorkDb}.dbo.OUT_TABLE_G_PROV1 (LINK_ROW, LINK_G1)
--SELECT DISTINCT OT.LINK, G1.LINK
--FROM
--	#DOCS D
--	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON D.LINK = G.LINK
--	INNER JOIN {Variable_WorkDb}.dbo.S_OBJECTS SO ON G.[OBJECT] = SO.LINK
--	INNER JOIN {Variable_WorkDb}.dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
--	INNER JOIN {Variable_WorkDb}.dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
--	INNER JOIN {Variable_WorkDb}.dbo.G_PROV_AP GAPK ON GAPK.LINK_UP = G2.LINK AND GAPK.DB_KR = 1
--	INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS SAK ON SAK.LINK = GAPK.ACCOUNT
--	INNER JOIN {Variable_WorkDb}.dbo.OUT_TABLE_ROW OT ON G.LINK = OT.LINK_UP
--	INNER JOIN {Variable_WorkDb}.dbo.OUT_TABLE_INV_SUM_ACCT OTISA ON OT.LINK = OTISA.LINK_UP AND OTISA.[ACCOUNT_B] = SAK.LINK
--	INNER JOIN {Variable_WorkDb}.dbo.DOC_BSO_OPER BO ON OT.LINK = BO.LINK_UP AND BO.[QTY_GIVEN] = G2.QUANTITY
--	INNER JOIN {Variable_WorkDb}.dbo.OUT_TABLE_INV_TYPE OTI ON OTI.[LINK_UP] = OT.[LINK] AND [INV_TYPE] = 3 AND [NOMEN_LINK] = GAPK.TMC 
--WHERE
--	SO.CODE = 'DOC_BSO_SPIS'
--	AND
--	SAK.ZABALANS = 1
--	AND
--	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.OUT_TABLE_G_PROV1 T WHERE T.LINK_ROW = OT.LINK AND T.LINK_G1 = G1.LINK)


---  
UPDATE F SET F.DATE_END = NULL
FROM 
	{Variable_TempDb}.dbo.__DEPARTMENTS_ T
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON G.DEP = T.LINK
	INNER JOIN {Variable_WorkDb}.dbo.FINANSE_CONTRACT_HEAD f ON f.LINK_UP = g.link
WHERE DATE_END <= '19010101'
GO

---  
UPDATE F SET F.DATE_BEGIN = '19910101'
FROM 
	{Variable_TempDb}.dbo.__DEPARTMENTS_ T
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON G.DEP = T.LINK
	INNER JOIN {Variable_WorkDb}.dbo.FINANSE_CONTRACT_HEAD f ON f.LINK_UP = g.link
WHERE DATE_BEGIN <= '19010101'
GO

---  
UPDATE G SET G.[DATE] = '19910101'
FROM 
	{Variable_TempDb}.dbo.__DEPARTMENTS_ T
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON G.DEP = T.LINK
WHERE G.[DATE] <= '19010101'
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]
GO

