USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

-- : g.[DATE] BETWEEN '20140101' AND '20141231'
set xact_abort on
begin tran

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_ A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


/** 1 **/
-----   ר "ר Ĩ    =
-----     

-- ,     
IF OBJECT_ID('TEMPDB..#LINK_G2','U') IS NOT NULL 
	DROP TABLE #LINK_G2

SELECT DISTINCT
	g2.LINK
INTO #LINK_G2	
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP} AND sa_k.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE = sa_k.CODE
	AND (sa_d.CODE LIKE '%101%' OR sa_d.CODE LIKE '%105%')	

INSERT INTO #LINK_G2 (LINK)
SELECT DISTINCT
	g2.LINK
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND (sa_d.CODE LIKE '%101%' AND sa_k.CODE LIKE '%106%')	
--------------------------------------------------------------------------------

UPDATE gap_d
SET gap_d.SGU = gap_d.EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK		
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_D.P_KASSA = 1
	AND
	gap_d.EKR IS NOT NULL	
	AND 
	(gap_d.SGU IS NULL OR gap_d.SGU <> gap_d.EKR)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)	
------------------------------------------------------------------------------

UPDATE gap_k
SET gap_K.SGU = gap_K.EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_K.P_KASSA = 1
	AND
	gap_K.EKR IS NOT NULL	
	AND 
	(gap_K.SGU IS NULL OR gap_K.SGU <> gap_K.EKR)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

---- 


UPDATE gap_d
SET gap_d.EKR = gap_d.SGU
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_D.P_KASSA = 1
	AND 
	gap_d.SGU IS NOT NULL	
	AND 
	(gap_d.EKR IS NULL OR gap_d.SGU <> gap_d.EKR)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

------------------------------------------------------------------------------

UPDATE gap_k
SET gap_K.EKR = gap_K.SGU
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_K.P_KASSA = 1
	AND
	gap_K.SGU IS NOT NULL	
	AND 
	(gap_K.EKR IS NULL OR gap_K.SGU <> gap_K.EKR)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

GO
---------------------------------------------------------------------------

UPDATE gap_K 
SET gap_K.EKR = gap_D.EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_K.P_EKR = 0 
	AND
	SA_K.AP_EKR = 1
	AND
	SA_K.P_KASSA <> 1
	AND 
	(gap_D.EKR IS NOT NULL AND ISNULL(gap_K.EKR,0) <> gap_D.EKR)
	AND	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)
		
GO
---------------------------------------------------------------------------

UPDATE gap_D 
SET gap_D.EKR = gap_K.EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_D.P_EKR = 0 
	AND
	SA_D.AP_EKR = 1
	AND
	SA_D.P_KASSA <> 1
	AND 
	(gap_K.EKR IS NOT NULL AND ISNULL(gap_D.EKR,0) <> gap_K.EKR)
	AND	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

		
GO

/** 2 **/
-----   ר "   
-----     

-- ,     
IF OBJECT_ID('TEMPDB..#LINK_G2','U') IS NOT NULL 
	DROP TABLE #LINK_G2
	
SELECT DISTINCT
	g2.LINK
INTO #LINK_G2	
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE = sa_k.CODE
	AND (sa_d.CODE LIKE '%101%' OR sa_d.CODE LIKE '%105%')


INSERT INTO #LINK_G2 (LINK)
SELECT DISTINCT
	g2.LINK
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND (sa_d.CODE LIKE '%101%' AND sa_k.CODE LIKE '%106%')
	
--------------------------------------------------------------------------------

---------------------------------------------------------------------------
	
UPDATE gap_D 
SET gap_D.EKR = gap_K.EKR,
gap_D.SGU = CASE WHEN sa_D.P_KASSA = 1 THEN gap_K.EKR ELSE gap_D.SGU END
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_K.AP_EKR = 1 AND SA_K.ANALIT_EKR IS NOT NULL
	AND 
	(gap_K.EKR IS NOT NULL AND gap_K.EKR <> ISNULL(gap_D.EKR, 0))
	AND	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

GO
---------------------------------------------------------------------------
UPDATE gap_K 
SET gap_K.EKR = gap_D.EKR,
gap_K.SGU = CASE WHEN sa_K.P_KASSA = 1 THEN gap_D.EKR ELSE gap_K.SGU END
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_D.AP_EKR = 1 AND SA_D.ANALIT_EKR IS NOT NULL
	AND 
	(gap_D.EKR IS NOT NULL AND gap_D.EKR <> ISNULL(gap_K.EKR, 0))
	AND	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)
		
GO


---------------------------------------------------------------------------
	
UPDATE gap_K
SET gap_K.EKR = gap_D.EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_D.P_EKR = 1 AND SA_D.ANALIT_EKR IS NOT NULL
	AND
	SA_K.P_EKR = 0
	AND 
	SA_K.AP_EKR = 1
	AND
	(gap_D.EKR IS NOT NULL AND ISNULL(gap_K.EKR,0) <> gap_D.EKR)
	AND	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)
		
GO


---------------------------------------------------------------------------
	
UPDATE gap_D
SET gap_D.EKR = gap_K.EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_K.P_EKR = 1 AND SA_K.ANALIT_EKR IS NOT NULL
	AND
	SA_D.P_EKR = 0
	AND 
	SA_D.AP_EKR = 1
	AND
	(gap_K.EKR IS NOT NULL AND ISNULL(gap_D.EKR,0) <> gap_K.EKR)
	AND	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)
GO

UPDATE gap_d
SET gap_d.EKR = SA_D.ANALIT_EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_D.AP_EKR = 1 AND SA_D.ANALIT_EKR IS NOT NULL
	AND 
	(gap_d.EKR IS NULL OR gap_d.EKR <> SA_D.ANALIT_EKR)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

---------------------------------------------------------------------------
	
UPDATE gap_k 
SET gap_K.EKR = SA_K.ANALIT_EKR
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND
	SA_K.AP_EKR = 1 AND SA_K.ANALIT_EKR IS NOT NULL
	AND 
	(gap_K.EKR IS NULL OR gap_K.EKR <> SA_K.ANALIT_EKR)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)
		
GO



/** 3 **/
-----   ר       .     

-- ,     
IF OBJECT_ID('TEMPDB..#LINK_G2','U') IS NOT NULL 
	DROP TABLE #LINK_G2
	
SELECT DISTINCT
	g2.LINK
INTO #LINK_G2	
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE = sa_k.CODE
	AND (sa_d.CODE LIKE '%101%' OR sa_d.CODE LIKE '%105%')

INSERT INTO #LINK_G2 (LINK)
SELECT DISTINCT
	g2.LINK
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND (sa_d.CODE LIKE '%101%' AND sa_k.CODE LIKE '%106%')
	
--------------------------------------------------------------------------------

UPDATE gap_d
SET gap_d.SGU = SGU_DEF.LINK_SGU
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}	
	LEFT JOIN (
				SELECT SGU.ACCOUNT, SGU.LINK_SGU 
				FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU 
				WHERE (SGU.DT_KT = 1 OR SGU.DT_KT = 3)
					AND EXISTS (SELECT ACCOUNT FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU2
									WHERE (SGU2.DT_KT = 1 OR SGU2.DT_KT = 3)
										AND SGU2.ACCOUNT = SGU.ACCOUNT
								GROUP BY ACCOUNT HAVING COUNT(*) = 1)	
	) SGU_DEF ON SGU_DEF.ACCOUNT = gap_d.account
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE NOT LIKE '%.50%.%'
	AND SA_D.P_KASSA = 0
	AND SGU_DEF.LINK_SGU IS NOT NULL 
	AND (gap_d.SGU IS NULL OR gap_d.SGU <> SGU_DEF.LINK_SGU)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

---------------------------------------------------------------------------

UPDATE gap_k
SET gap_K.SGU = SGU_DEF.LINK_SGU
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
	LEFT JOIN (
				SELECT SGU.ACCOUNT, SGU.LINK_SGU 
				FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU 
				WHERE (SGU.DT_KT = 2 OR SGU.DT_KT = 3)
					AND EXISTS (SELECT ACCOUNT FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU2
									WHERE (SGU2.DT_KT = 2 OR SGU2.DT_KT = 3)
										AND SGU2.ACCOUNT = SGU.ACCOUNT
								GROUP BY ACCOUNT HAVING COUNT(*) = 1)	
	) SGU_DEF ON SGU_DEF.ACCOUNT = gap_K.account
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_K.CODE NOT LIKE '%.50%.%'	
	AND SA_K.P_KASSA = 0
	AND SGU_DEF.LINK_SGU IS NOT NULL 
	AND (gap_K.SGU IS NULL OR gap_K.SGU <> SGU_DEF.LINK_SGU)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

----------------------------------------------------------------------------------------------
/*        ,       1  */
----------------------------------------------------------------------------------------------

UPDATE gap_d
SET gap_d.SGU = SGU_DEF.LINK_SGU
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}	
	LEFT JOIN (
				SELECT SGU.ACCOUNT, SGU.LINK_SGU 
				FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU 
				WHERE EXISTS (SELECT ACCOUNT FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU2
									WHERE SGU2.ACCOUNT = SGU.ACCOUNT
								GROUP BY ACCOUNT HAVING COUNT(*) = 1)	
	) SGU_DEF ON SGU_DEF.ACCOUNT = gap_d.account
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE NOT LIKE '%.50%.%'
	AND SA_D.P_KASSA = 0
	AND SGU_DEF.LINK_SGU IS NOT NULL 
	AND (gap_d.SGU IS NULL OR gap_d.SGU <> SGU_DEF.LINK_SGU)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)

----------------------------------------------------------------	
	
UPDATE gap_k 
SET gap_K.SGU = SGU_DEF.LINK_SGU
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	left join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	left join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
	LEFT JOIN (
				SELECT SGU.ACCOUNT, SGU.LINK_SGU 
				FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU 
				WHERE EXISTS (SELECT ACCOUNT FROM [{Variable_WorkDb}].dbo.s_accounts_sgu SGU2
									WHERE SGU2.ACCOUNT = SGU.ACCOUNT
								GROUP BY ACCOUNT HAVING COUNT(*) = 1)	
	) SGU_DEF ON SGU_DEF.ACCOUNT = gap_K.account
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_K.CODE NOT LIKE '%.50%.%'
	AND SA_K.P_KASSA = 0
	AND SGU_DEF.LINK_SGU IS NOT NULL 
	AND (gap_K.SGU IS NULL OR gap_K.SGU <> SGU_DEF.LINK_SGU)
	AND
	NOT EXISTS (SELECT * FROM #LINK_G2 A WHERE A.LINK = g2.LINK)
GO
		
/** 4 **/
-----      
/*
            
       010100000 " " 
(010111310 - 010113310, 010115310, 010118310, 010131310 - 010138310, 010141310 - 010148310) 
       010100000 " " 
(010111310 - 010113310, 010115310, 010131310 - 010138310, 010141310 - 010148310);

 105 (340)   105 (340)
 101 (310)  101 (310) 
 101 (310)  106 (310) 
*/

-- ,     
IF OBJECT_ID('TEMPDB..#LINK_G2','U') IS NOT NULL 
	DROP TABLE #LINK_G2
	
SELECT DISTINCT
	g2.LINK
INTO #LINK_G2	
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE = sa_k.CODE
	AND (sa_d.CODE LIKE '%101%' OR sa_d.CODE LIKE '%105%')

-----
UPDATE gap_d
SET gap_d.SGU = (CASE WHEN sa_d.CODE LIKE '%101%' THEN (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '310') ELSE (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '340') END)
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	INNER JOIN #LINK_G2 K ON K.LINK = G2.LINK
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')

-----
UPDATE gap_K
SET gap_K.SGU = (CASE WHEN sa_K.CODE LIKE '%101%' THEN (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '310') ELSE (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '340') END)
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	INNER JOIN #LINK_G2 K ON K.LINK = G2.LINK
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_K on (gap_K.link_up = g2.link and gap_K.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')



-- ,     
IF OBJECT_ID('TEMPDB..#LINK_G2B','U') IS NOT NULL 
	DROP TABLE #LINK_G2B
	
SELECT DISTINCT
	g2.LINK
INTO #LINK_G2B	
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND (sa_d.CODE LIKE '%101%' AND sa_k.CODE LIKE '%106%')

-----
UPDATE gap_d
SET gap_d.SGU = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '310')
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	INNER JOIN #LINK_G2B K ON K.LINK = G2.LINK
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')

-----
UPDATE gap_K
SET gap_K.SGU = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KOSGU WHERE CODE = '310')
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	INNER JOIN #LINK_G2B K ON K.LINK = G2.LINK
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_K on (gap_K.link_up = g2.link and gap_K.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
GO
/** 5 **/
-----      
/*
  500-500        .
       
*/

UPDATE GAP_D SET
	GAP_D.SGU = CASE WHEN GAP_D.SGU IS NULL AND GAP_K.SGU IS NOT NULL THEN GAP_K.SGU ELSE GAP_D.SGU END,
	GAP_D.EKR = CASE WHEN GAP_D.EKR IS NULL AND GAP_K.EKR IS NOT NULL THEN GAP_K.EKR ELSE GAP_D.EKR END
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE LIKE '%.50%' AND sa_K.CODE LIKE '%.50%'
	AND ( GAP_D.SGU IS NULL OR GAP_D.EKR IS NULL)

UPDATE GAP_K SET 
	GAP_K.SGU = CASE WHEN GAP_K.SGU IS NULL AND GAP_D.SGU IS NOT NULL THEN GAP_D.SGU ELSE GAP_K.SGU END,
	GAP_K.EKR = CASE WHEN GAP_K.EKR IS NULL AND GAP_D.EKR IS NOT NULL THEN GAP_D.EKR ELSE GAP_K.EKR END
from 
	[{Variable_WorkDb}].dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK	
	inner join [{Variable_WorkDb}].dbo.G_PROV1 g1 on (g1.link_up = g.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV2 g2 on (g2.link_up = g1.link)
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_d on (gap_d.link_up = g2.link and gap_d.db_kr = 0)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_d on (sa_d.LINK = gap_d.account) AND sa_d.LINK_DEP = {LINK_DEP}
	inner join [{Variable_WorkDb}].dbo.G_PROV_ap gap_k on (gap_k.link_up = g2.link and gap_k.db_kr = 1)
	inner join [{Variable_WorkDb}].dbo.s_accounts sa_k on (sa_k.LINK = gap_k.account) AND sa_k.LINK_DEP = {LINK_DEP}	
WHERE
	g.[object] <> [{Variable_WorkDb}].dbo.obj_id ('SHABLON_DOCUMENTS_PROV')
	AND sa_d.CODE LIKE '%.50%' AND sa_K.CODE LIKE '%.50%'
	AND ( GAP_K.SGU IS NULL OR GAP_K.EKR IS NULL)


/*     */

--            л,              .
UPDATE S SET S.EKR = SA.[ANALIT_EKR]
FROM 
	[{Variable_WorkDb}].dbo.S_ACCOUNTS SA
	INNER JOIN [{Variable_WorkDb}].dbo.SALDO S ON SA.LINK = S.ACCOUNT
	INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] do on do.LINK = S.[DEP_LINK]
WHERE
	SA.AP_EKR = 1 AND SA.[ANALIT_EKR] IS NOT NULL
	AND S.ISOBOROT = 2 AND S.EKR IS NULL 
GO

--=
UPDATE S SET S.[SGU] = S.[EKR]
FROM 
	[{Variable_WorkDb}].dbo.S_ACCOUNTS SA
	INNER JOIN [{Variable_WorkDb}].dbo.SALDO S ON SA.LINK = S.ACCOUNT
	INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] do on do.LINK = S.[DEP_LINK]
WHERE
	SA.P_KASSA = 1
	AND S.ISOBOROT = 2 AND S.SGU IS NULL AND S.[EKR] IS NOT NULL
GO

UPDATE S SET S.[EKR] = S.[SGU]
FROM 
	[{Variable_WorkDb}].dbo.S_ACCOUNTS SA
	INNER JOIN [{Variable_WorkDb}].dbo.SALDO S ON SA.[LINK] = S.[ACCOUNT]
	INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] do on do.LINK = S.[DEP_LINK]
WHERE
	SA.[P_KASSA] = 1 AND SA.[AP_EKR] = 1
	AND S.[ISOBOROT] = 2 AND S.[EKR] IS NULL AND S.[SGU] IS NOT NULL
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

commit tran
GO


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO
