USE [{Variable_TempDb}]
GO

SET XACT_ABORT ON 

BEGIN TRAN

DECLARE
	@SQL_EXEC	VARCHAR (8000)

IF OBJECT_ID ('TEMPDB..#ASSETS_UPD') IS NOT NULL
	EXEC ('DROP TABLE #ASSETS_UPD')

CREATE TABLE #ASSETS_UPD
	(
	LINK INT,
	PER_USED	INT,
	PER_USED_AM	INT,
	LAST_SUM	NUMERIC (28,4),

	DATE_CALC_AM	DATETIME,
	DATE_REST	DATETIME,
	MUST_SUM_A	NUMERIC (28,4),

	SUM_B	NUMERIC (28,4),
	SUM_A	NUMERIC (28,4)
	)

IF EXISTS (SELECT * FROM dbo.[SYSOBJECTS]
			WHERE ID = OBJECT_ID ('[dbo].[InformationRegisterRecordSet|]')
				AND OBJECTPROPERTY(id, N'IsUserTable') = 1
			)
BEGIN
	SET @SQL_EXEC =
'
INSERT INTO #ASSETS_UPD
	(
	LINK,
	PER_USED,
	PER_USED_AM,
	LAST_SUM,
	DATE_CALC_AM,
	DATE_REST,
	MUST_SUM_A,
	SUM_B,
	SUM_A
	)
SELECT
	B.LINK,
'
	+
	CASE
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[],'
		ELSE 'NULL,'
	END
	+
	CASE
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[],'
		ELSE 'NULL,'
	END
	+
	CASE
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[],'
		ELSE '0,'
	END
	+
'
	DATEADD (DAY, DATEDIFF (DAY, 0, C.PERIOD), 0),
	T1.[DATE],
	0,
	T1.SUMMA,
	T2.SUMMA

FROM [dbo].[__INVENTORY__] B
INNER JOIN [dbo].[InformationRegisterRecordSet|] C ON C. = B.INSERTED_UIDS 
INNER JOIN
	(
	SELECT
		S.INV,
		S.[DATE],
		SUMMA = S.D_SUMMA,
		REC_NO = ROW_NUMBER () OVER (PARTITION BY S.INV ORDER BY S.[DATE])
	FROM [{Variable_WorkDb}].dbo.SALDO S
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON
		SA.LINK = S.ACCOUNT
		AND SA.cSINTH = ''101''
	WHERE S.ISOBOROT = 2
	) AS T1 ON
		T1.INV = B.LINK
		AND T1.REC_NO = 1
LEFT JOIN
	(
	SELECT
		S.INV,
		S.[DATE],
		SUMMA = S.K_SUMMA,
		REC_NO = ROW_NUMBER () OVER (PARTITION BY S.INV ORDER BY S.[DATE])
	FROM [{Variable_WorkDb}].dbo.SALDO S
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON
		SA.LINK = S.ACCOUNT
		AND SA.cSINTH = ''104''
	WHERE S.ISOBOROT = 2
	) AS T2 ON
		T2.INV = B.LINK
		AND T2.REC_NO = 1
WHERE C.ACTIVE = ''True''
	AND C.[] > 0
'
	EXEC (@SQL_EXEC)
END

UPDATE T1
SET
	MUST_SUM_A = T1.LAST_SUM / PER_USED_AM
FROM #ASSETS_UPD T1
WHERE ISNULL (T1.PER_USED_AM, 0) > 0

USE [{Variable_WorkDb}]
GO

UPDATE A
SET 
	DEPRE_DATE_CALC = DATEADD (DAY, 1, B.DATE_REST),
--	LAST_PER_USED = B.PER_USED - DATEDIFF (MONTH, A.DATE_COME, B.DATE_REST) 
	LAST_PER_USED = (B.SUM_B - B.SUM_A)/B.MUST_SUM_A
FROM dbo.ASSETS A
INNER JOIN #ASSETS_UPD B ON B.LINK = A.LINK_UP
WHERE B.MUST_SUM_A > 0
	AND SUM_B > SUM_A

IF OBJECT_ID ('TEMPDB..#ASSETS_UPD') IS NOT NULL
	EXEC ('DROP TABLE #ASSETS_UPD')

COMMIT TRAN

GO
