SET NOCOUNT ON
SET XACT_ABORT ON
GO

USE [{Variable_WorkDb}]
GO

BEGIN TRAN
--   --
IF OBJECT_ID ('TEMPDB..#tINV_GRP') IS NOT NULL
	EXEC ('DROP TABLE #tINV_GRP')

CREATE TABLE #tINV_GRP
	(
	LINK		INT,
	INV_MAIN	INT
	)

INSERT INTO #tINV_GRP
	(
	LINK,
	INV_MAIN
	)
SELECT
	INV1.LINK,
	INV1.LINK_MAIN
FROM [{Variable_TempDb}].dbo.[__INVENTORY__] INV1
INNER JOIN dbo.ASSETS A ON
	A.LINK_UP = INV1.LINK_MAIN 
	AND A.GRP_CALC = 1

LEFT JOIN [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] T1 ON
	T1. = INV1.REF
	AND T1. = ''
WHERE T1. IS NULL
GROUP BY
	INV1.LINK,
	INV1.LINK_MAIN

--SELECT '#tINV_GRP', * FROM #tINV_GRP

--  --
--     --
IF OBJECT_ID ('TEMPDB..#tINV_INFO') IS NOT NULL
	EXEC ('DROP TABLE #tINV_INFO')

CREATE TABLE #tINV_INFO
	(
	INV_MAIN	INT,
	INV	INT,
	EMP	INT
	)

INSERT INTO #tINV_INFO
	(
	INV_MAIN,
	INV,
	EMP
	)
SELECT -- *
	T1.INV_MAIN,
	T1.LINK,
	T1.EMP
FROM 
	(
	SELECT
		INV_MAIN = INV1.LINK,
		INV2.LINK, PERIOD, EMP = ES.LINK, --A.PERIOD, INV.*,
		ROW_NUM = ROW_NUMBER () OVER (PARTITION BY INV1.LINK, INV2.LINK ORDER BY A.PERIOD DESC)
	FROM [{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|] a
	INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY__] INV1 ON
		INV1.[INSERTED_UIDS] = a.
	INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY__] INV2 ON
		INV2.ref = a.[]

	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cmo ON cmo.Ref = a.[]
	LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ es ON es.Ref = CONVERT(UNIQUEIDENTIFIER, cmo.)
	) AS T1
WHERE T1.ROW_NUM = 1

--      --
IF OBJECT_ID ('TEMPDB..#tINV_INFO_EMP') IS NOT NULL
	EXEC ('DROP TABLE #tINV_INFO_EMP')

CREATE TABLE #tINV_INFO_EMP
	(
	INV_MAIN	INT,
	QTY	INT,
	MAX_INV	INT,
	EMP	INT
	)

INSERT INTO #tINV_INFO_EMP
	(
	INV_MAIN,
	QTY,
	MAX_INV,
	EMP
	)
SELECT
	INV_MAIN,
	COUNT (*),
	MAX (INV),
	EMP
FROM #tINV_INFO
GROUP BY
	INV_MAIN,
	EMP

--SELECT * FROM #tINV_INFO_EMP

--     --
IF OBJECT_ID ('TEMPDB..#tSALDO') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO')

CREATE TABLE #tSALDO
	(
	LINK	INT,
	INV	INT,
	EMP	INT,
	D_SUMMA	NUMERIC (28,4),
	QTY	NUMERIC (28,4),
	PRICE	NUMERIC (28,4),
	ACCOUNT	INT,
	ZABALANS	TINYINT,
	COUNT_REC	INT
	)

INSERT INTO #tSALDO
	(
	LINK,
	INV,
	EMP,
	D_SUMMA,
	QTY,
	PRICE,
	ACCOUNT,
	ZABALANS,
	COUNT_REC
	)
SELECT
	S.LINK,
	S.INV,
	S.EMP,
	S.D_SUMMA,
	S.D_QUANTITY,
	S.D_SUMMA / S.D_QUANTITY,
	SA.LINK,
	SA.ZABALANS,
	0
FROM dbo.SALDO S
INNER JOIN dbo.S_ACCOUNTS SA ON
	SA.LINK = S.ACCOUNT
	AND SA.KSU = 1
	AND (
		SA.ZABALANS = 0 AND SA.cSINTH LIKE '10[1238]'
		OR SA.ZABALANS = 1 
		)
	AND S.ISOBOROT = 2

INNER JOIN dbo.ASSETS A ON
	A.LINK_UP = S.INV
	AND A.GRP_CALC = 1
	AND S.D_QUANTITY > 0
INNER JOIN 
	(
	SELECT
		INV_GR = INV_MAIN,
		QTY = COUNT (*) + 1
	FROM dbo.INVENTORY_GRP_LIST 
	GROUP BY
		INV_MAIN
	) AS T1 ON 
		T1.INV_GR = S.INV
		AND T1.QTY >= S.D_QUANTITY
INNER JOIN #tINV_INFO_EMP INV_QTY ON
	INV_QTY.INV_MAIN = S.INV
	AND INV_QTY.EMP = S.EMP

--SELECT '#tSALDO', * FROM #tSALDO

INSERT INTO dbo.SALDO
	(
	[DATE], ACCOUNT, D_SUMMA, K_SUMMA, R_SUMMA,
	D_QUANTITY, K_QUANTITY, ISOBOROT, KBK, EKR,
	DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC,
	TMC, INDATE, SGU,
	AP1, AP2, AP3, AP4, AP5, AP6,
	DEP_LINK, PRICE, LINK_DOC
	)
SELECT
	S.[DATE], S.ACCOUNT,
	D_SUMMA = S1.PRICE, 
	S.K_SUMMA, S.R_SUMMA,
	D_QUANTITY = 1, 
	S.K_QUANTITY, S.ISOBOROT,
	S.KBK, S.EKR, S.DEP, S.SUB, S.EMP, S.NOMEN,
	INV = IGR.LINK, 
	S.KAU, S.DEP_ACC, S.TMC, S.INDATE,
	S.SGU, S.AP1, S.AP2, S.AP3, S.AP4, S.AP5, S.AP6,
	S.DEP_LINK, S.PRICE, S.LINK_DOC
FROM #tSALDO S1
INNER JOIN dbo.SALDO S ON
	S.LINK = S1.LINK
	AND S1.QTY > 1

INNER JOIN #tINV_GRP IGR ON
	IGR.LINK <> IGR.INV_MAIN
	AND IGR.INV_MAIN = S.INV
INNER JOIN #tINV_INFO I1 ON
	I1.INV = IGR.LINK
	AND I1.EMP = S.EMP
INNER JOIN #tINV_INFO_EMP INV_QTY ON
	INV_QTY.INV_MAIN = S1.INV
	AND INV_QTY.EMP = S1.EMP

UPDATE S
SET
	D_SUMMA = S1.PRICE,
	D_QUANTITY = 1
FROM #tSALDO S1 
INNER JOIN dbo.SALDO S ON S.LINK = S1.LINK

--      --
--SELECT '#tINV_INFO', 
--	T1.INV,
--	S.INV, *
UPDATE S
SET INV = T1.INV
FROM #tINV_INFO T1
INNER JOIN #tINV_GRP T2 ON T2.LINK = T1.INV 
INNER JOIN dbo.SALDO S ON
	S.INV = T2.INV_MAIN
	AND S.EMP = T1.EMP

LEFT JOIN dbo.SALDO S1 ON
	S1.INV = T1.INV
	AND S1.EMP = S.EMP
	AND S1.ACCOUNT = S.ACCOUNT
WHERE S1.LINK IS NULL

IF OBJECT_ID ('TEMPDB..#tINV_SALDO_QTY') IS NOT NULL
	EXEC ('DROP TABLE #tINV_SALDO_QTY')

CREATE TABLE #tINV_SALDO_QTY
	(
	LINK	INT,
	INV	INT,
	ACCOUNT	INT,
	EMP	INT,
	COUNT_REC	INT
	)

IF EXISTS (SELECT 1 FROM #tINV_INFO)
BEGIN
	INSERT INTO #tINV_SALDO_QTY
		(
		LINK,
		INV,
		ACCOUNT,
		EMP,
		COUNT_REC
		)
	SELECT
		T1.LINK,
		T1.INV,
		T1.ACCOUNT,
		T1.EMP,
		COUNT (*)
	FROM #tSALDO T1
	INNER JOIN #tINV_GRP T2 ON T2.INV_MAIN = T1.INV
	INNER JOIN dbo.SALDO S ON
		S.INV = T2.LINK
		AND S.ACCOUNT = T1.ACCOUNT
		AND S.EMP = T1.EMP
	GROUP BY
		T1.LINK,
		T1.INV,
		T1.ACCOUNT,
		T1.EMP

	DELETE S
--select *
	FROM #tSALDO S1
	INNER JOIN #tINV_SALDO_QTY INV_SQ ON
		INV_SQ.LINK = S1.LINK
		AND INV_SQ.COUNT_REC > S1.QTY 
	INNER JOIN dbo.SALDO S ON
		S.LINK = S1.LINK
	LEFT JOIN #tINV_INFO T1 ON
		T1.INV = S.INV
		AND T1.EMP = S.EMP
	WHERE T1.INV IS NULL
END
--  --
--    101  (  ) --
DELETE #tSALDO

INSERT INTO #tSALDO
	(
	LINK,
	INV,
	D_SUMMA,
	QTY,
	PRICE,
	ACCOUNT,
	ZABALANS,
	COUNT_REC
	)
SELECT
	0,
	T1.INV_MAIN,
	SUM (S.D_SUMMA),
	SUM (S.D_QUANTITY),
	0,
	SA.LINK,
	SA.ZABALANS,
	COUNT (*)
FROM #tINV_GRP T1
INNER JOIN dbo.SALDO S ON S.INV = T1.LINK
INNER JOIN dbo.S_ACCOUNTS SA ON
	SA.LINK = S.ACCOUNT
	AND SA.KSU = 1
	AND (
		SA.ZABALANS = 0 AND SA.cSINTH LIKE '10[1238]'
		OR SA.ZABALANS = 1 
		)
	AND S.ISOBOROT = 2
GROUP BY
	T1.INV_MAIN,
	SA.LINK,
	SA.ZABALANS

--     --
IF OBJECT_ID ('TEMPDB..#tSALDO_A') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO_A')

CREATE TABLE #tSALDO_A
	(
	LINK	INT,
	K_SUMMA	NUMERIC (28,4),
	PRICE	NUMERIC (28,4),
	QTY	NUMERIC (28,4)
	)

INSERT INTO #tSALDO_A
	(
	LINK,
	K_SUMMA,
	PRICE,
	QTY
	)
SELECT
	S.LINK,
	S.K_SUMMA,
	S.K_SUMMA,
	S1.QTY 
FROM #tSALDO S1 
INNER JOIN dbo.SALDO S ON
	S1.ZABALANS = 0
	AND S.ISOBOROT = 2
	AND S.INV = S1.INV

INNER JOIN dbo.S_ACCOUNTS SA ON
	SA.LINK = S.ACCOUNT
	AND SA.ZABALANS = 0
	AND SA.cSINTH = '104'
WHERE S1.COUNT_REC > 1

UPDATE S
SET PRICE = S.PRICE/S.QTY
FROM #tSALDO_A S
WHERE S.QTY <> 0

--SELECT '#tSALDO_A', * FROM #tSALDO_A

INSERT INTO dbo.SALDO
	(
	[DATE], ACCOUNT, D_SUMMA, K_SUMMA, R_SUMMA,
	D_QUANTITY, K_QUANTITY, ISOBOROT, KBK, EKR,
	DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC,
	TMC, INDATE, SGU,
	AP1, AP2, AP3, AP4, AP5, AP6,
	DEP_LINK, PRICE, LINK_DOC
	)
SELECT
	S.[DATE], S.ACCOUNT,
	S.D_SUMMA,
	K_SUMMA = S1.PRICE, 
	S.R_SUMMA,
	S.D_QUANTITY,
	S.K_QUANTITY,
	S.ISOBOROT,
	S.KBK, S.EKR, S.DEP, S.SUB, S.EMP, S.NOMEN,
	INV = IGR.LINK, 
	S.KAU, S.DEP_ACC, S.TMC, S.INDATE,
	S.SGU, S.AP1, S.AP2, S.AP3, S.AP4, S.AP5, S.AP6,
	S.DEP_LINK, S.PRICE, S.LINK_DOC
FROM #tSALDO_A S1 
INNER JOIN dbo.SALDO S ON S.LINK = S1.LINK

INNER JOIN #tINV_GRP IGR ON IGR.INV_MAIN = S.INV

LEFT JOIN dbo.SALDO SS ON
	SS.INV = IGR.LINK
	AND SS.ACCOUNT = S.ACCOUNT
	AND SS.ISOBOROT = S.ISOBOROT
WHERE SS.LINK IS NULL

DELETE S_AM
FROM #tSALDO_A SA 
INNER JOIN dbo.SALDO S_AM ON S_AM.LINK = SA.LINK

INNER JOIN #tSALDO SB ON SB.INV = S_AM.INV
LEFT JOIN dbo.SALDO S_BAL ON
	S_BAL.INV = SB.INV
	AND S_BAL.ACCOUNT = SB.ACCOUNT
WHERE S_BAL.LINK IS NULL

UPDATE S
SET
	K_SUMMA = S1.PRICE
FROM #tSALDO_A S1 
INNER JOIN dbo.SALDO S ON S.LINK = S1.LINK

IF OBJECT_ID ('TEMPDB..#tSALDO') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO')

IF OBJECT_ID ('TEMPDB..#tSALDO_A') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO_A')

IF OBJECT_ID ('TEMPDB..#tINV_GRP') IS NOT NULL
	EXEC ('DROP TABLE #tINV_GRP')

IF OBJECT_ID ('TEMPDB..#tINV_INFO') IS NOT NULL
	EXEC ('DROP TABLE #tINV_INFO')

IF OBJECT_ID ('TEMPDB..#tINV_INFO_EMP') IS NOT NULL
	EXEC ('DROP TABLE #tINV_INFO_EMP')

IF OBJECT_ID ('TEMPDB..#tINV_SALDO_QTY') IS NOT NULL
	EXEC ('DROP TABLE #tINV_SALDO_QTY')

COMMIT TRAN

GO

