
/*
   "    "

SELECT LINK_DEP, [SYSTEM], NAME, COUNT(*)
FROM
	dbo.TYPE_OTHER_OPER B
GROUP BY
	LINK_DEP, [SYSTEM], CODE, NAME
HAVING
	COUNT(*) > 1
*/

USE [{Variable_WorkDb}]
GO

set xact_abort on
BEGIN TRAN

SET NOCOUNT ON

declare @RID UniqueIdentifier
execute dbo.newrid @RID=@RID output

DECLARE @LINK INT, @LINK_DEP INT, @SYSTEM INT, @CODE VARCHAR(10), @NAME VARCHAR(254)
 
DECLARE @Cur1 CURSOR

SET @Cur1 = CURSOR FORWARD_ONLY

FOR 

	SELECT 
		LINK, LINK_DEP, [SYSTEM], NAME
	FROM
		(
		SELECT 
			LINK, LINK_DEP, [SYSTEM], NAME, 
			NUM = ROW_NUMBER() OVER (PARTITION BY LINK_DEP, [SYSTEM], NAME ORDER BY LINK),
			CNT = COUNT(*) OVER (PARTITION BY LINK_DEP, [SYSTEM], NAME)
		FROM
			dbo.TYPE_OTHER_OPER A
		) T 
	WHERE
		T.NUM = 1 AND CNT > 1	
	
OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @LINK, @LINK_DEP, @SYSTEM, @NAME
WHILE (@@fetch_status <> -1)
BEGIN
	IF (@@fetch_status <> -2)
	BEGIN

		PRINT @NAME
		
		insert into dbo.sys_link ([rid], [link]) 
		SELECT @RID, T.LINK FROM dbo.TYPE_OTHER_OPER T WHERE T.LINK_DEP = @LINK_DEP AND T.[SYSTEM] = @SYSTEM AND T.NAME = @NAME 
		
		exec dbo.XA_MERGE_REC @OBJ_CODE = 'DICTIONARY_DOC_TYPES', @nMainLink = @LINK, @RID = @RID
		
		DELETE FROM dbo.sys_link WHERE [rid] = @RID
		
	END

	FETCH NEXT FROM @Cur1 INTO @LINK, @LINK_DEP, @SYSTEM, @NAME
END

CLOSE @Cur1
DEALLOCATE @Cur1

SET NOCOUNT OFF


COMMIT TRAN
GO
